-- (C) 2012-2013 Miranda
--------------------------------------------------------------------------------
-- 名前空間作成
if(_G and not _G.Kitty) then
	_G.Kitty = {};
end

--------------------------------------------------------------------------------
Kitty.BasicConfigFrame = {};
-- UIコントロール/データ対応表
Kitty.BasicConfigFrame.relativeList = {
	-- 静的メッセージ一覧
	["KittyBasicConfigFrame_VersionLabel"] = "KittyCombo Version:[" .. Kitty.VERSION .. "]",
	["KittyBasicConfigFrame_TitleLabel"] = Kitty.T("message", "BasicSettingTitle"),
	["KittyBasicConfigFrame_Separator1Label"] = Kitty.T("message", "Separator1Label"),
	["KittyBasicConfigFrame_Separator2Label"] = Kitty.T("message", "Separator2Label"),
	["KittyBasicConfigFrame_ShowDamageTakenThresholdLabel"] = Kitty.T("message", "ShowDamageTakenThresholdLabel"),
	["KittyBasicConfigFrame_ShowDamageDoneThresholdLabel"] = Kitty.T("message", "ShowDamageDoneThresholdLabel"),
	["KittyBasicConfigFrame_ShowDPSTypeLabel"] = Kitty.T("message", "ShowDPSTypeLabel"),
	["KittyBasicConfigFrame_SkipPetTargetLabel"] = Kitty.T("message", "SkipPetTargetLabel"),

	["KittyBasicConfigFrame_AutoInvitePartyLabel"] = Kitty.T("message", "AutoInvitePartyLabel"),
	["KittyBasicConfigFrame_AutoAcceptPartyLabel"] = Kitty.T("message", "AutoAcceptPartyLabel"),
	["KittyBasicConfigFrame_GivePartyLeaderLabel"] = Kitty.T("message", "GivePartyLeaderLabel", Kitty.T("keyword", "PromoteToPartyLeader1")),
	["KittyBasicConfigFrame_AutoAssistantLabel"] = Kitty.T("message", "AutoAssistantLabel"),
	["KittyBasicConfigFrame_InstanceLevelLabel"] = Kitty.T("message", "InstanceLevelLabel"),
	["KittyBasicConfigFrame_LootThresholdLabel"] = Kitty.T("message", "LootThresholdLabel"),
	["KittyBasicConfigFrame_ShowInstanceLevelLabel"] = Kitty.T("message", "ShowInstanceLevelLabel"),

	["KittyBasicConfigFrame_CommandListButton"] = Kitty.T("message", "CommandListButton"),
	["KittyBasicConfigFrame_CloseButton"] = Kitty.T("message", "SaveAndCloseButton"),
	["KittyBasicConfigFrame_CancelButton"] = Kitty.T("message", "CancelButton"),

	-- 動的メッセージ一覧
	["KittyBasicConfigFrame_ShowDamageTakenThresholdEditBox"] = "showDamageTakenThreshold",
	["KittyBasicConfigFrame_ShowDamageDoneThresholdEditBox"] = "showDamageDoneThreshold",
	["KittyBasicConfigFrame_ShowDPSTypeDropDownMenu"] = "showDPSType",
	["KittyBasicConfigFrame_SkipPetTargetCheckButton"] = "skipPetTarget",

	["KittyBasicConfigFrame_AutoInvitePartyCheckButton"] = "autoInviteParty",
	["KittyBasicConfigFrame_AutoInvitePartyKeyword1EditBox"] = "keyword1",
	["KittyBasicConfigFrame_AutoInvitePartyKeyword2EditBox"] = "keyword2",
	["KittyBasicConfigFrame_AutoInvitePartyKeyword3EditBox"] = "keyword3",
	["KittyBasicConfigFrame_AutoAcceptPartyCheckButton"] = "autoAcceptParty",
	["KittyBasicConfigFrame_GivePartyLeaderCheckButton"] = "givePartyLeader",
	["KittyBasicConfigFrame_AutoAssistantCheckButton"] = "autoAssistant",
	["KittyBasicConfigFrame_InstanceLevelDropDownMenu"] = "instanceLevel",
	["KittyBasicConfigFrame_LootThresholdCheckButton"] = "lootThreshold",
	["KittyBasicConfigFrame_ShowInstanceLevelCheckButton"] = "showInstanceLevel",
};

--------------------------------------------------------------------------------
-- UIの初期設定
Kitty.BasicConfigFrame.set = function(this)
	-- テキストエリアの状態設定
	if(KittyBasicConfigFrame_AutoInvitePartyCheckButton:IsChecked()) then
		-- Enable
		KittyBasicConfigFrame_AutoInvitePartyKeyword1EditBox:Enable();
		KittyBasicConfigFrame_AutoInvitePartyKeyword1EditBox:SetTextColor(1.0, 1.0, 1.0);
		KittyBasicConfigFrame_AutoInvitePartyKeyword2EditBox:Enable();
		KittyBasicConfigFrame_AutoInvitePartyKeyword2EditBox:SetTextColor(1.0, 1.0, 1.0);
		KittyBasicConfigFrame_AutoInvitePartyKeyword3EditBox:Enable();
		KittyBasicConfigFrame_AutoInvitePartyKeyword3EditBox:SetTextColor(1.0, 1.0, 1.0);
	else
		-- Disable
		KittyBasicConfigFrame_AutoInvitePartyKeyword1EditBox:Disable();
		KittyBasicConfigFrame_AutoInvitePartyKeyword1EditBox:SetTextColor(0.5, 0.5, 0.5);
		KittyBasicConfigFrame_AutoInvitePartyKeyword2EditBox:Disable();
		KittyBasicConfigFrame_AutoInvitePartyKeyword2EditBox:SetTextColor(0.5, 0.5, 0.5);
		KittyBasicConfigFrame_AutoInvitePartyKeyword3EditBox:Disable();
		KittyBasicConfigFrame_AutoInvitePartyKeyword3EditBox:SetTextColor(0.5, 0.5, 0.5);
	end
end;

--------------------------------------------------------------------------------
-- 画面表示
Kitty.BasicConfigFrame.onShow = function(this)
	Kitty.settingToComponent(Kitty.SettingManager.setting.basic, Kitty.BasicConfigFrame.relativeList);

	-- テキストエリアの状態設定
	Kitty.BasicConfigFrame.set();
end;
-- 設定値保存
Kitty.BasicConfigFrame.onSave = function(this)
	Kitty.componentToSetting(Kitty.SettingManager.setting.basic, Kitty.BasicConfigFrame.relativeList);

	-- 設定変更イベント通知
	Kitty.onVariablesChanged(Kitty.SettingManager.setting);
end;
