-- [EventCodeButton v2012.05.18 YossyE@オセル]より、
-- YossyEさんの了承の上、コードの一部を流用。
--------------------------------------------------------------------------------
-- 名前空間作成
if(_G and not _G.Kitty) then
	_G.Kitty = {};
end

--------------------------------------------------------------------------------
Kitty.EventCodeButton = {};
Kitty.EventCodeButton.eventCode = nil;
Kitty.EventCodeButton.eventPassword = nil;

Kitty.EventCodeButton.startEventCode = function()
	local onOpenMail = function()
		local message = OpenMailBodyText:GetText();
		local eventCode = nil;
		local eventPassword = nil;

		if(message ~= nil) then
			-- ID抽出
			if(eventCode == nil) then
				-- コロン半角
				_, _, eventCode = string.find(message, "[Ii][Dd]%s-：%s-【(%w-)】");
			end
			if(eventCode == nil) then
				-- コロン全角
				_, _, eventCode = string.find(message, "[Ii][Dd]%s-:%s-【(%w-)】");
			end
			-- パスワード抽出
			if(eventPassword == nil) then
				-- コロン半角
				_, _, eventPassword = string.find(message, "パスワード%s-：%s-【(%w-)】");
			end
			if(eventPassword == nil) then
				-- コロン全角
				_, _, eventPassword = string.find(message, "パスワード%s-:%s-【(%w-)】");
			end

			-- ボタン表示判定
			if(eventCode ~= nil and eventPassword ~= nil) then
				Kitty.EventCodeButton.eventCode = eventCode;
				Kitty.EventCodeButton.eventPassword = eventPassword;

				KittyEventCodeButton:Enable();
			else
				Kitty.EventCodeButton.eventCode = nil;
				Kitty.EventCodeButton.eventPassword = nil;

				KittyEventCodeButton:Disable();
			end

			-- Debug
			Kitty.debugPrint("ID:[" .. tostring(eventCode) .. "], Password:[" .. tostring(eventPassword) .. "]");
		end
	end;

	KittyEventCodeButton:Show();
	-- Hook
	OpenMail_Update = Kitty.HookManager(OpenMail_Update, nil, onOpenMail);
end;
Kitty.EventCodeButton.endEventCode = function()
	KittyEventCodeButton:Hide();
	-- Hook解除
	if(OpenMail_Update ~= nil and type(OpenMail_Update) == "table" and OpenMail_Update.getOriginalFunction ~= nil) then
		OpenMail_Update = OpenMail_Update:getOriginalFunction();
	end
end;

--------------------------------------------------------------------------------
-- ロード
Kitty.EventCodeButton.onLoad = function(this)
	this:RegisterEvent("LOADING_END");
end;
-- イベント
Kitty.EventCodeButton.onEvent = function(this, event, arg1, arg2, arg3, arg4)
	if(event == "LOADING_END") then
		-- LOADING_ENDで判定しないと、競合チェックできない
		if(EventCodeButton == nil) then
			Kitty.EventCodeButton.startEventCode();
		end
	end
end;

-- 吹きだし
Kitty.EventCodeButton.onEnter = function(this)
	GameTooltip:SetOwner(this, "ANCHOR_LEFT", 4, 0);

	if(Kitty.EventCodeButton.eventCode ~= nil and Kitty.EventCodeButton.eventPassword ~= nil) then
		GameTooltip:SetText(Kitty.T("message", "PickUpEventCode"), 1, 1, 1);
		GameTooltip:AddLine("   " .. Kitty.T("message", "EventCode") .. Kitty.colorGreen(Kitty.EventCodeButton.eventCode), 1, 1, 1);
		GameTooltip:AddLine("   " .. Kitty.T("message", "EventPassword") .. Kitty.colorGreen(Kitty.EventCodeButton.eventPassword), 1, 1, 1);
		GameTooltip:AddLine(Kitty.T("message", "ExchangeEventCodeMessage"), 0, 0.75, 0.95);
		GameTooltip:AddLine(Kitty.T("message", "TransmissionMessage"), 0, 0.75, 0.95);
		GameTooltip:AddLine(Kitty.T("message", "DiversionMessage", Kitty.colorCyan("YossyE")), 1, 1, 1);
	else
		GameTooltip:SetText(Kitty.T("message", "InvalidMailMessage"), 1, 1, 1);
	end

	GameTooltip:Show();
end;
Kitty.EventCodeButton.onLeave = function(this)
	GameTooltip:Hide();
end;

Kitty.EventCodeButton.onClick = function(this)
	if(Kitty.EventCodeButton.eventCode ~= nil and Kitty.EventCodeButton.eventPassword ~= nil) then
		if(not IsShiftKeyDown()) then
			-- イベントコード交換
			ItemExchangeRequest(Kitty.EventCodeButton.eventCode, Kitty.EventCodeButton.eventPassword);
		else
			-- 送信窓へ転送
			SendMailSubjectEditBox:SetText(OpenMailSubject:GetText());
			SendMailBodyEditBox:SetText(OpenMailBodyText:GetText());
			MailFrameTab_OnClick(2);
			SendMailNameEditBox:SetFocus();
		end
	end
end;

Kitty.EventCodeButton.exchange = function(isExchange)
	if(isExchange) then
		-- イベントコード交換
		ItemExchangeRequest(Kitty.EventCodeButton.eventCode, Kitty.EventCodeButton.eventPassword);
	else
		Kitty.sendMessage(Kitty.T("message", "EventCodeMessage", Kitty.colorGreen(Kitty.EventCodeButton.eventCode), Kitty.colorGreen(Kitty.EventCodeButton.eventPassword)));
	end
end;
