-------------------------------------------------------------------------------
--
-- PLANTCARE 
--
-- Last Update
-- 2017-09-11T6:07:30Z
--
-- Author
--   Omnibrain
--
-- AddonManager 
--	 lusiux
--
-- Former Authors
--   DawnSight, Skity, Alleri, oeginc, DocSaintly, vidarsk, lusiux, arnefi
--
-- Thanks to
--   Telltod for the help on code and the optimizations 
--   PetraAreon for some code of GreenThumb (pot- and time frame)
--   Naifu for Templates from nkCraft (entry template: statistics)
-- 
-- released under the Creative Commons License By-Nc-Sa
--   http://creativecommons.org/licenses/by-nc-sa/3.0/
--
-- Get the current version at
--   http://www.curse.com/addons/rom/plantcare
--
--
-------------------------------------------------------------------------------

-- Setup some Global variables
local Sol = LibStub("Sol")

local PlantCare = {
	Addonname = "PlantCare",
	 Version = "v7.1.1",
	currentSeedInHand= 0,
	currentWaterSteps = 10,
	currentFertilizerSteps = 10,
	currentWaterFeeds = 1,
	currentFertilizerFeeds = 1,
	WaitForPlantingSuccessLoop = 0,
	caringForPlants = false,
	displayedHelp = false,
	watchCounter = 60,
	waterGrabbed = 0,
	topdressGrabbed = 0,
	Counter = 0,
	resetTimer = 0,
	plantCounter = 0,
	counterTimer = 0,
	shopWaterDisableTimer = 0,
	shopFertilizerDisableTimer = 0,
	action = "",
	tooltipframe = nil,
	tooltipdelay = 0,
	Last_Seed=nil
}

_G.PlantCare = PlantCare

PlantCare.DefaultSettings = {
    GetProduct = true,
    LongCare = false,
    AutoCare = true,
    MaxLevelMaterial = 91,
	MaxLevelRarity = 0,
	InfoCount = 0,
	AlertWater = true,
	AlertPercentUnder = 50,
	WaterSound = false,
	CountPlants = false,
	AutoSeed = true,
	AutoBuySeed = true,
	AutoBuySeedValue = 10,
	WaterBeforeHarvest = false,
	Compensate = false,
	ExpertLongCare = 0,
	ExpertWaterHarvest = 0,
	ExpertWaterHarvestLow = 0,
	ExpertLongCareValue = 0,
	ExpertWaterHarvestValue = 0,
	ExpertWaterHarvestLowValue = 0,
}

PlantCare.BlockMessages = {
    {TEXT('SYS_PLANT_SEED_SUCCEED'),       0},
    {TEXT('SYS_PLANT_WATER_SUCCEED'),      0},
    {TEXT('SYS_PLANT_TOPDRESS_SUCCEED'),   0},
    {TEXT('SYS_PLANT_GETPRODUCT_SUCCEED'), 0},
}

function PlantCare_OnLoad(frame)
local language = string.upper(string.sub(GetLanguage(),1,2))
local  func, err = loadfile("Interface/Addons/PlantCare/Locales/"..language..".lua")
if (err) then
	PlantCare.ErrMsg   = "\n\n|cffff0000No Locales found for your language \""..PlantCare.language.."\", switching to fallback \"EN\"|r"
	dofile("Interface/Addons/PlantCare/Locales/en.lua")
else
    func()
end

	PlantCare.name    = "PlantCare"
	PlantCare.frame   = PlantCare_Frame

	frame:RegisterEvent("VARIABLES_LOADED")
	frame:RegisterEvent("HOUSES_PLANT_OPEN")
	frame:RegisterEvent("HOUSES_PLANT_CLOSE")
	frame:RegisterEvent("HOUSESFRAME_HIDE")
	frame:RegisterEvent("HOUSES_PLANT_CHANGED")
	frame:RegisterEvent("STORE_OPEN")
	frame:RegisterEvent("STORE_CLOSE")
	frame:RegisterEvent("UPDATE_STORE_BUYBACK_ITEMS")
	frame:RegisterEvent("UPDATE_STORE_SELL_ITEMS")

	-- Change Anchors and Size of PlantFrame
	PlantFrame:SetSize(280,415)
	PlantSeedInfoFrame :ClearAllAnchors(); PlantSeedInfoFrame :SetAnchor("BOTTOM", "BOTTOM", PlantFrame, 0, -283)
	PlantWaterInfoFrame:ClearAllAnchors(); PlantWaterInfoFrame:SetAnchor("BOTTOM", "BOTTOM", PlantFrame, 0, -143)
	PlantStateBer01    :ClearAllAnchors(); PlantStateBer01    :SetAnchor("BOTTOM", "BOTTOM", PlantFrame, 0, -255)

	PlantCareFrame_PotInfoFrame          :Show()
	PlantCareFrame_PotInfoFrameButton    :Disable()

	PlantCareFrame_PotInfoFramePottitle :SetText(PlantCare.Strings.Potname..":")
	PlantCareFrame_PotInfoFrameTypetitle:SetText(PlantCare.Strings.Pottype..":")

	PlantCare_Frame_PropertiesOpenButton:SetText(PlantCare.Strings.GUI_properties)
	PlantCare_Frame_CareButton:SetText(PlantCare.Strings.GUI_care)
	PlantCare_Frame_LongCareButton:SetText(PlantCare.Strings.GUI_longcare)
	PlantCare_Frame_InfoButton:SetText(PlantCare.Strings.GUI_info)
	
	if PlantCare.Version == "@".."project-version".."@" then
		PlantCare.Version = "Development"
	end

	PlantCare_Frame_Version:SetText(PlantCare.Version)
	PlantCare_Frame_Version:SetColor(1,0.89,0.06)

	PlantCareFrame_PotInfoFramePottitle :SetColor(0,0.63,0)
	PlantCareFrame_PotInfoFrameTypetitle:SetColor(0,0.63,0)

	PlantCareFrame_PotInfoFramePottext  :SetColor(0.6,1,0.3)
	PlantCareFrame_PotInfoFrameTypetext :SetColor(0.6,1,0.3)

	PlantCareFrame_SeedInfoFrameMsg2Text:SetColor(0.6,1,0.3)
	PlantCareFrame_Progress             :Show()

	Sol.hooks.Hook(PlantCare.name, "PlantFrame_Update", PlantCare_PlantFrame_Update)

	SaveVariables("PlantCare_Settings")

	DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] Version "..PlantCare.Version.." loaded.")
	DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] "..string.format(PlantCare.Strings.SlashHelp3,"|cff00ff00/plantcare help|r"))
	
	PlantCare.PrepareClock()
	
	Sol.hooks.Hook(PlantCare.name, "SetStoreItem", 		PlantCare_SetStoreItem, GameTooltip)
	Sol.hooks.Hook(PlantCare.name, "StoreBuyItem", 		PlantCare_StoreBuyItem)
end

-- Clock preparation
function PlantCare.PrepareClock()
    PlantCare.clock = PlantCare.clocks_None
    if not os then
		if MorphClock then
    		MorphClock:RegisterClockReady("PlantCare_Clock")
        end
		PlantCare.clock = PlantCare.clocks_None
		DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] "..PlantCare.Strings.Time_Warn)
    else
        assert(os.date and os.time, "os found but functions are missing")
        
        PlantCare.clock = PlantCare.clocks_os
    end
end

function PlantCare_Clock(timetab)
	PlantCare.clock = PlantCare.clocks_Morphclock
	PlantCare.log(PlantCare.Strings.clock)
end

-- Clocks
PlantCare.clocks_None={
    FormatDate = function () return "-"  end,
	FormatDate2 = function () return "-"  end,
    FormatDateDelta_short = function () return ""  end,
}

PlantCare.clocks_Morphclock={
    FormatDate = function (mtime) return MorphClock:date(PlantCare.Strings.Date2,mtime)  end,
	FormatDate2 = function (mtime) return MorphClock:date(PlantCare.Strings.Date,mtime)  end,
    FormatDateDelta_short = function (time_dif)

        local mtime = MorphClock:time() + time_dif
        local day_in_sec=24*60*60
		 
		if ((MorphClock:time()%day_in_sec)+time_dif < day_in_sec) then 
            return MorphClock:date(PlantCare.Strings.Date_Today,mtime)
        else
            return MorphClock:date(PlantCare.Strings.Date2,mtime)
        end
     end,
    time = function() return MorphClock:time() end,
}

PlantCare.clocks_os={
    FormatDate = function (mtime) return os.date(PlantCare.Strings.Date2,mtime)  end,
	FormatDate2 = function (mtime) return os.date(PlantCare.Strings.Date,mtime)  end,
    FormatDateDelta_short = function (time_dif)
	
        local mtime = os.time() + time_dif
        local day_in_sec=24*60*60
		 
		if ((os.time()%day_in_sec)+time_dif < day_in_sec) then 
            return os.date(PlantCare.Strings.Date_Today,mtime)
        else
            return os.date(PlantCare.Strings.Date2,mtime)
        end
      end,
    time = function() return os.time()	end,
}
-- Clocks end

-- DB Stuff

-- DB idx 
local S_ID = 1
local S_LEVEL = 2
local S_FEED_VAL_MIN = 3
local S_FEED_VAL_MAX = 4
local S_PRODUCTS = 5
local S_AMMOUNTS = 6
local SPECIAL_ID = 205084

function PlantCare.DB_FindSeedByName(name)
	for seedType, seedTable in pairs(PlantCare.Seeds) do
		for _, seed in pairs(seedTable) do
			if TEXT("Sys"..seed[S_ID].."_name") == name then
				return seed, seedType
			end
		end
	end
end

function PlantCare.DB_FindSeedByID(id)
	for seedType, seedTable in pairs(PlantCare.Seeds) do
		for _, seed in pairs(seedTable) do
			if seed[S_ID] == id then
				return seed, seedType
			end
		end
	end
end

function PlantCare_SetStoreItem(tip,tab,index)
	Sol.hooks.GetOriginalFn(PlantCare.name, "SetStoreItem",GameTooltip)(tip,tab,index)
	if (tab == "SELL") then
		icon, name, price, moneyType, count, stock, maxheap, secondPrice, secondMoneyType = GetStoreSellItemInfo(index)
		local f = 0 
		local seed = PlantCare.DB_FindSeedByName(name)
		local currValue, _, _ = GetPlayerSkilled("PLANT")
		local count ="?"
		if seed and seed[S_PRODUCTS] then 
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine(PlantCare.Strings.PossibleProducts..":",1,1,1)
			for i, prod_id in pairs(seed[S_PRODUCTS]) do 
				local r,g,b = GetItemQualityColor(GetQualityByGUID(prod_id))
				if (string.sub((seed[S_AMMOUNTS][i]),1,1) ==  "S") then 
					if (f==0) then 
						GameTooltip:AddLine(PlantCare.Strings.Special_Mat..":",1,1,1)
					end
					if ((currValue - 5) >= seed[S_LEVEL]) then
						count = "  ("..(string.sub(seed[S_AMMOUNTS][i],2))..")" or "?"
					else
						count = "  (-)"
					end
				f=1
				else	
					count = "  ("..seed[S_AMMOUNTS][i]..")" or "?"
				end
				GameTooltip:AddLine("⋅ "..TEXT("Sys"..prod_id.."_name")..count,r,g,b)			
			end
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine("PlantCare "..PlantCare.Version,0.2,1,0.2)
		end
	end
end

function PlantCare_SaveConfig()
	local value = tonumber(PlantCare_Properties_standard_Percent_Value:GetText())
	if value == nil then
		value = 0
	end
	if (value < 0) then
		value = 1
	end
	if (value > 50) then
		value = 50
	end
	PlantCare_Settings.AlertPercentUnder = value
	PlantCare_Properties_standard_Percent_Value:SetText(tostring(value))
	
	value = PlantCare_Properties_standard_autoBuySeed_Value:GetText()
	if (value == nil) then value = 10; end
	value = tonumber(value)
	if (value < 1) then value = 1; end
	if (value > 100) then value = 100; end
	PlantCare_Settings.AutoBuySeedValue = value
	PlantCare_Properties_standard_autoBuySeed_Value:SetText(tostring(value))

	value = tonumber(PlantCare_Properties_expert_longcare_Percent_Value:GetText())
	if value == nil then
		value = 0
	end
	local setting = PlantCare_Settings.ExpertLongCare
	if (value <= 0) then
		value = 0
		if (setting == 3) or (setting == 4) or (setting == 5) then
			--PlantCare_Settings.ExpertLongCare = 0
			value = 60
		end
	end
	-- if (value >= 50) then
		-- if (setting == 1) or (setting == 2) then
			-- value = 50
		-- end
	-- end
	if (value >= 100) then
		value = 100
	end
	PlantCare_Settings.ExpertLongCareValue = value
	PlantCare_Properties_expert_longcare_Percent_Value:SetText(tostring(value))
	
	value = tonumber(PlantCare_Properties_expert_harvestcare_Percent_Value:GetText())
	if value == nil then
		value = 0
	end
	if (value <= 0) then
		value = 0
		PlantCare_Settings.ExpertWaterHarvest = 0
	end
	if (value >= 100) then
		value = 100
	end
	PlantCare_Settings.ExpertWaterHarvestValue = value
	PlantCare_Properties_expert_harvestcare_Percent_Value:SetText(tostring(value))

	value = tonumber(PlantCare_Properties_expert_harvestcare_low_Percent_Value:GetText())
	if value == nil then
		value = 0
	end
	if (value <= 0) then
		value = 0
		PlantCare_Settings.ExpertWaterHarvestLow = 0
	end
	if (value >= 100) then
		value = 100
	end
	PlantCare_Settings.ExpertWaterHarvestLowValue = value
	PlantCare_Properties_expert_harvestcare_low_Percent_Value:SetText(tostring(value))
	
	PlantCare.loadExpertSettings()
end

function PlantCare_ShowHelp()
	local Counter = PlantCare_Settings.InfoCount
	local doitbaby = 0
	if (PlantCare.displayedHelp == false) then
		Counter = Counter + 1
		if (Counter < 30) then
			doitbaby = 1
		elseif (Counter == 40) then
			Counter = 30
			doitbaby = 1
		end
		PlantCare_Settings.InfoCount = Counter
		if (doitbaby == 1) then
			PlaySoundByPath("Interface/AddOns/PlantCare/Sounds/info.mp3")
			DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] "..PlantCare.Strings.Help1)
			DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] "..PlantCare.Strings.Help2)
		end
	end
	PlantCare.displayedHelp = true
end

function PlantCare_LockCareForPlants()
	-- Everything looks good, let's place our mutex..
	-- We don't want to run this function twice at the same time!
	PlantCare.caringForPlants = true
end

function PlantCare_CheckLockCareForPlants()
	return PlantCare.CaringForPlants
end

function PlantCare_UnLockCareForPlants()
	-- Clear our mutex
	PlantCare.caringForPlants = false
end

function PlantCare.Hook_FormalTime(nReapTime)
	local realHours = math.floor((nReapTime/60)/60)
	local realMinutes = math.floor((nReapTime - (realHours*3600)) / 60)

	return string.format("%02dh %02dm", realHours, realMinutes)
end

function PlantCare_TimeFormat(seconds)
	if (seconds > 3600) then
		local divide = seconds/3600
		local hours = math.floor(divide)
		local minutes = math.floor((divide-hours)*60)

		local msg = tostring(hours)
		if (hours ~= 1) then 
			msg = msg.." "..PlantCare.Strings.Hours..", "..minutes
		else 
			msg = msg.." "..PlantCare.Strings.Hour..", "..minutes
		end
		if (minutes ~= 1) then 
			msg = msg.." "..PlantCare.Strings.Minutes
		else 
			msg = msg.." "..PlantCare.Strings.Minute
		end

		return msg
	else
		local minutes = math.floor(seconds/60)

		local msg = tostring(minutes)
		if (minutes ~= 1) then 
			msg = msg.." "..PlantCare.Strings.Minutes
		else
			msg = msg.." "..PlantCare.Strings.Minute
		end

		return msg
	end
end

function PlantCare_GetFocusFurnishingID()
	local maxItems, StorageName, FurnishingID = Houses_GetItemInfo(Houses_GetFocusFurnishingID(), -1)
	return FurnishingID
end

function PlantCare_PlantFrame_Update()
	Sol.hooks.GetOriginalFn(PlantCare.name, "PlantFrame_Update")()

	-- Get information about the plant
	local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink, fGrowRate, fHealthRate, nReapTime,
	nFeedPoint, nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint, fDecWater, fDecTopdress = Plant_GetInfo()

	-- Set our PlantCare window title to this players current planting skill
	local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
	PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")

	-- Now check the state of the currently selected plant
	if (szState == "grow") then
		GameTooltip:Hide()
		GameTooltip:SetHyperLink(szSeedLink)
		GameTooltip:Hide()
		Last_Seed = szSeedName
		PlantCareFrame_Progress:Show()
		PlantCareFrame_Progress_Text:SetText(tostring(math.floor(fGrowRate*100)).."%")

		PlantCareFrame_SeedInfoFrameMsg2:Show()
		
		if PlantCare.clock.time then
			PlantCareFrame_SeedInfoFrameMsg2Text:SetText(string.gsub(GameTooltipTextLeft3:GetText(),"^.*: ","")..", "..C_LEVEL.." "..string.gsub(GameTooltipTextLeft4:GetText(),"[^0-9]","").."\n"..PlantCare_TimeFormat(nReapTime).."\n"..PlantCare.clock.FormatDate2(PlantCare.clock.time() + nReapTime))
		else
			PlantCareFrame_SeedInfoFrameMsg2Text:SetText(string.gsub(GameTooltipTextLeft3:GetText(),"^.*: ","")..", "..C_LEVEL.." "..string.gsub(GameTooltipTextLeft4:GetText(),"[^0-9]","").."\n"..PlantCare_TimeFormat(nReapTime).."\n".."-")
		end
		
		PlantSeedInfoFrameMsg:SetText("|cff00a000"..PlantCare.Strings.Seed..":\n"..PlantCare.Strings.RipeIn..":\n"..PlantCare.Strings.Ripe..":")
	else
		PlantCareFrame_Progress:Hide()
		PlantCareFrame_SeedInfoFrameMsg2:Hide()
	end
	
	-- We change the type of the smiley based on our background knowledge about seeds
	local seed = PlantCare.DB_FindSeedByName(szSeedName)
	if seed then
		local smallFeed= seed[S_FEED_VAL_MIN]
		local bigFeed  = seed[S_FEED_VAL_MAX]
				local nHealth = math.floor( fHealthRate * 100 )
				local sztexture
				
				if( nHealth >= bigFeed )then
					sztexture = "interface\\HouseFrame\\PlantFrame_Health5"
				elseif( nHealth >= smallFeed )then
					sztexture = "interface\\HouseFrame\\PlantFrame_Health4"
				elseif( nHealth >= 20 )then
					sztexture = "interface\\HouseFrame\\PlantFrame_Health3"
				elseif( nHealth > 0 )then
					sztexture = "interface\\HouseFrame\\PlantFrame_Health2"
				else
					sztexture = "interface\\HouseFrame\\PlantFrame_Health1"
				end

				PlantHealthFrameTexture:SetFile( sztexture )
	end
end

-- Tooltip for progress frame in the plant frame
function PlantCareFrame_Progress_OnEnter(this)
	GameTooltip:SetText(Last_Seed)
	GameTooltip:AddLine(PlantCare.Strings.products,0,.7,.9)
	GameTooltip:AddSeparator()
	local f = 0 
	local seed = PlantCare.DB_FindSeedByName(Last_Seed)
	local currValue, _, _ = GetPlayerSkilled("PLANT")
	local count ="-"
		if seed and seed[S_PRODUCTS] then 
			GameTooltip:AddLine(" ")
			GameTooltip:AddLine(PlantCare.Strings.PossibleProducts..":",1,1,1)
			for i, prod_id in pairs(seed[S_PRODUCTS]) do 
				local r,g,b = GetItemQualityColor(GetQualityByGUID(prod_id))
				--if (prod_id == SPECIAL_ID) then
				if (string.sub((seed[S_AMMOUNTS][i]),1,1) ==  "S") then 
					if (f==0) then 
						GameTooltip:AddLine(PlantCare.Strings.Special_Mat..":",1,1,1)
					end
					if ((currValue - 5) >= seed[S_LEVEL]) then
						count = "  ("..(string.sub(seed[S_AMMOUNTS][i],2))..")" or "?"
					else
						count = "  (-)"
					end
				f=1
				else	
					count = "  ("..seed[S_AMMOUNTS][i]..")" or "?"
				end
				GameTooltip:AddLine("⋅ "..TEXT("Sys"..prod_id.."_name")..count,r,g,b)			
			end
		end
end





function PlantCare_InfoFrame_PlantList_Catalog_OnClick(this, id)

	local catalog= _G[this:GetName() .. "Text"]:GetText()

	if this.Expand == 1 then
		this.Expand = 0
		PlantCareInfoFrame_PlantDetailFrame:Hide()
	else
		this.Expand = 1
	end
	
	TreeView_SetFolderExpand(PlantCare, catalog, this.Expand)
	TreeView_SetListButtonInfo(this, this.Expand)

	PlantCare_InfoFrame_Show(this)
end

function PlantCare_InfoFrame_PlantList_Item_OnClick(this, id)
	local plant = this.PlantInfo
	
	if plant and plant.Health then
		PlantCareInfoFrame_PlantDetailFrame:Show()
		
		PlantCareInfoFrame_PlantDetailFrame_LastHealth:SetText(string.format("%d%%", (100 * plant.Health)))
		PlantCareInfoFrame_PlantDetailFrame_LastGrowRate:SetText(string.format("%d%%", (100 * plant.GrowRate)))
		PlantCareInfoFrame_PlantDetailFrame_LastTopdressPoint:SetText(plant.TopdressPoint)
		PlantCareInfoFrame_PlantDetailFrame_LastWaterPoint:SetText(plant.WaterPoint)
		PlantCareInfoFrame_PlantDetailFrame_DecWater:SetText(string.format("%.02f", plant.DecWater))
		PlantCareInfoFrame_PlantDetailFrame_DecTopdress:SetText(string.format("%.02f", plant.DecTopdress))
			
		if PlantCare.clock.time then
			PlantCareInfoFrame_PlantDetailFrame_HarvestTime:SetText( PlantCare.clock.FormatDate2(plant.HarvestTime) )
			PlantCareInfoFrame_PlantDetailFrame_LastCareTime:SetText( PlantCare.clock.FormatDate2(plant.LastCareTime) )	
            
			local timedif = (PlantCare.clock.time() - plant.LastCareTime)/3600
			local currentTopdress = plant.TopdressPoint - timedif * plant.DecTopdress
			PlantCareInfoFrame_PlantDetailFrame_CalcTopdressPoint:SetText(string.format("%.1f%%", currentTopdress))
			
			local currentWater = plant.WaterPoint - timedif * plant.DecWater
			PlantCareInfoFrame_PlantDetailFrame_CalcWaterPoint:SetText(string.format("%.1f%%", currentWater))
		else
			PlantCareInfoFrame_PlantDetailFrame_CalcTopdressPoint:SetText("-")
			PlantCareInfoFrame_PlantDetailFrame_CalcWaterPoint:SetText("-")
			PlantCareInfoFrame_PlantDetailFrame_HarvestTime:SetText("-")
			PlantCareInfoFrame_PlantDetailFrame_LastCareTime:SetText("-")
		end
	else
		PlantCareInfoFrame_PlantDetailFrame:Hide()
	end
end

function PlantCare_InfoFrame_ResetFrame (frame)
	TreeView_Reset(PlantCare)
	for player, pots in pairs(PlantCare_Settings.HarvestTimes) do
		TreeView_SetFolder(PlantCare, player ,1)
		for plantID, plantInfoTable in pairs(pots) do
			TreeView_SetItem(PlantCare, plantInfoTable, player)
		end
	end

	if (PlantCareInfoFrame:IsVisible()) then
		PlantCare_InfoFrame_Show(frame)
	end
end

function PlantCare_checkWaterState()
	local dotalk = 0
	local addedchar = 0
	local charlist = nil
	local i
	local v

	for i,v in pairs(PlantCare_Settings.HarvestTimes) do

		for plantID, plantInfoTable in pairs(PlantCare_Settings.HarvestTimes[i]) do
		
			if (plantInfoTable.harvested == 0) then

				local timediff = 0
				
				if PlantCare.clock.time then
					timediff = (plantInfoTable.HarvestTime - PlantCare.clock.time())
				end			
				local alert = plantInfoTable.alert; -- "You have to care for your plants."
				
				if (alert == nil) then
					alert = 2
				end
				local notify = plantInfoTable.notify; -- "Your plants are ready to be harvested."
				
				if (notify == nil) then
					notify = 2
				end

				local currentTopdress
				local currentWater
				
				if PlantCare.clock.time then
					currentTopdress = (PlantCare.clock.time() - plantInfoTable.LastCareTime)/3600
					currentTopdress = currentTopdress * plantInfoTable.DecTopdress
					currentTopdress = plantInfoTable.TopdressPoint - currentTopdress

					currentWater = (PlantCare.clock.time() - plantInfoTable.LastCareTime)/3600
					currentWater = currentWater * plantInfoTable.DecWater
					currentWater = plantInfoTable.WaterPoint - currentWater

					if ((currentTopdress <= (plantInfoTable.BestTopdressPoint-PlantCare_Settings.AlertPercentUnder)) or (currentWater <= (plantInfoTable.BestWaterPoint-PlantCare_Settings.AlertPercentUnder)))
						and (alert > 0) and (timediff > 0) then
						if (addedchar == 0) then
							if (charlist) then
								charlist = charlist..", "..i
							else
								charlist = i
							end
						end
						alert = alert - 1
						PlantCare_Settings.HarvestTimes[i][plantID].alert = alert
						addedchar = 1
						dotalk = 1
					end

				end
			end
		end
		addedchar = 0
	end

	if (dotalk == 1) then
		PlaySoundByPath("sound/interface/ui_sysmsg_normal.mp3")
		PlaySoundByPath("Interface/AddOns/PlantCare/Sounds/care.mp3")
		SystemMsgFrame:AddMessage(PlantCare.Strings.AlertMsg..": "..charlist, 0, 1, 0)
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.AlertMsg..": "..charlist)
	end
	return(dotalk)
end

function PlantCare_checkHarvestState()
	local dotalk = 0
	local addedchar = 0
	local charlist = nil
	local i
	local v
	local anzahl

	for i,v in pairs(PlantCare_Settings.HarvestTimes) do
		anzahl = 0

		for plantID, plantInfoTable in pairs(PlantCare_Settings.HarvestTimes[i]) do

			if (plantInfoTable.ID == nil) then
				PlantCare_Settings.HarvestTimes[i][plantID] = nil
			else
				local harvested = 0
				local timediff = 0

				anzahl = anzahl + 1

				if PlantCare.clock.time then
					timediff = (plantInfoTable.HarvestTime - PlantCare.clock.time())

					local notify = plantInfoTable.notify
					harvested = plantInfoTable.harvested

					if (notify == nil) then
						notify = 2
					end
					if (harvested == nil) then
						harvested = 0
					end

					if (timediff < 0) and (timediff > -43200) and (notify > 0) and (plantID > 0) and (harvested == 0) then
						if (addedchar == 0) then
							if (charlist) then
								charlist = charlist..", "..i
							else
								charlist = i
							end
						end
						notify = notify - 1
						PlantCare_Settings.HarvestTimes[i][plantID].notify = notify
						addedchar = 1
						dotalk = 1
					end
				end
				
				if (timediff <= -86400) or (plantID < 0) or (harvested == 1) then
					PlantCare_Settings.HarvestTimes[i][plantID] = nil
					anzahl = anzahl - 1
				end
			end

		end

		-- Delete alts with no entries from list
		if (anzahl == 0) then
			PlantCare_Settings.HarvestTimes[i] = nil
		end

		addedchar = 0
	end

	if (dotalk == 1) then
		PlaySoundByPath("sound/interface/ui_sysmsg_normal.mp3")
		PlaySoundByPath("Interface/AddOns/PlantCare/Sounds/harvest.mp3")
		SystemMsgFrame:AddMessage(PlantCare.Strings.timeToHarvest..": "..charlist, 0, 1, 0)
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.timeToHarvest..": "..charlist)
	end
	return(dotalk)
end

local function GetPlantInfoLine(plant_data)

	local COLORS={
		GREY = {0.5, 0.5, 0.5},
		YELLOW = {0.93,0.76,0},
		ORANGE = {1,0.5,0.25},
		RED = {1,0,0},
		GREEN = {0,1,0}
	}

	if not PlantCare.clock.time then
		return string.format("[%d] %s (%d|%d)",
				plant_data.ID, plant_data.SeedName, 
				plant_data.TopdressPoint, plant_data.WaterPoint),
				COLORS.YELLOW
	end

	if not plant_data.LastCareTime then
		return "----",COLORS.GREY
	end
	
	local timediff = (PlantCare.clock.time() - plant_data.LastCareTime)/3600
	local currentTopdress = plant_data.TopdressPoint - timediff * plant_data.DecTopdress
	local currentWater = plant_data.WaterPoint - timediff * plant_data.DecWater

	local timetogo = (plant_data.HarvestTime-PlantCare.clock.time())/3600

	local text = string.format("[%d] %s (%.1f|%d|%d)",plant_data.ID , plant_data.SeedName,  timetogo, currentTopdress, currentWater)

	local col = COLORS.YELLOW	
	if (currentTopdress <= (plant_data.BestTopdressPoint - 20)) or (currentWater <= (plant_data.BestWaterPoint - 20)) then col = COLORS.ORANGE end
	if (currentTopdress <= (plant_data.BestTopdressPoint - 30)) or (currentWater <= (plant_data.BestWaterPoint - 30)) then col = COLORS.RED end
	if (timediff <= 0) then col = COLORS.GREEN end
	if ((timediff < -10) or (plant_data.harvested == 1)) then col = COLORS.GREY end

	return text,col

end

function PlantCare_InfoFrame_Show(frame)

	for i=1,20 do
		local button = getglobal("PlantCareInfoFrame_PlantListFrame_Button" .. i)
		button:Hide()
	end
	
	local count = TreeView_GetTotalNode(PlantCare) or 0

	local Slider = getglobal("PlantCareInfoFrame_PlantListFrame_ScrollBar")
	Slider:SetMinValue(1)
	if (count - 20 + 1) <= 0  then
		Slider:SetMaxValue(1)
	else
		Slider:SetMaxValue(count-20+1)
	end
	Slider:SetValueStepMode("INT")

	
	local tree_data = TreeView_GetCollect(PlantCare,Slider:GetValue(),20)

	for i,item in ipairs(tree_data.list) do

		local button = getglobal("PlantCareInfoFrame_PlantListFrame_Button" .. i)
		button:Show()

		local buttonItem = getglobal(button:GetName() .. "Item")
		local buttonFolder = getglobal(button:GetName() .. "Folder")

		if item.type == 0 then --folder
			local buttonFolderText = getglobal(button:GetName() .. "FolderText")

			buttonItem:Hide()
			buttonFolder:Show()
			buttonFolder.Expand = item.expand
			buttonFolderText:SetText(item.id)
		else

			buttonFolder:Hide()
			buttonItem:Show()
			
			buttonItem.PlantInfo = item.id
			local text,col = GetPlantInfoLine(item.id)
			local buttonItemName = getglobal(button:GetName() .. "Item_ItemName")
			buttonItemName:SetColor(col[1],col[2],col[3])
			buttonItemName:SetText(text)
		end
	end
end

function PlantCare_InfoFrame_OnValueChanged(this, arg1)
	PlantCare_InfoFrame_Show(this)
end

function PlantCare:getSeedInfo(seedID)
	local seedTypeNumber = 0
	local stid

	local seed,seedType = PlantCare.DB_FindSeedByID(seedID)
	if seed then
			if seedType == "Wood" then
				seedTypeNumber = 1
			elseif seedType == "Herb" then
				seedTypeNumber = 2
			elseif seedType == "Ore" then
				seedTypeNumber = 3
			end

			return seedTypeNumber,seed[S_LEVEL]
	end

	return 0,0
end

function PlantCare:grabBestSeed(potType, potLevel)
	local currValue, _, _ = GetPlayerSkilled("PLANT")
	local seedID = 0
	local bestLevel=0
	local bestType=0
	local i

	
	local occupiedSlots, totalSlots = GetBagCount()
	for i=1, totalSlots do
		local invNr, texture, name, itemCnt, locked, invalid = GetBagItemInfo(i)
		local itemLink = GetBagItemLink(invNr)

		if (itemLink) then
			local _, itemData, itemName = ParseHyperlink(itemLink)
			local _, _, itemID = string.find(itemData, "^(%x+)")
			itemID = tonumber(itemID, 16)

			local seedType, seedLevel = PlantCare:getSeedInfo(itemID)
			
			if (potType == 0) then
				-- Multi-purpose: the higher the level the better
				if (seedLevel > bestLevel) and (seedLevel <= currValue) then
					bestLevel = seedLevel
					bestType  = seedType
					seedID = itemID
				end
			else
				-- Try to find exactly matching seed first
				-- otherwise take the seed with the highest level matching the pot type
				-- otherwise take the seed with the highest Level
				if (seedLevel <= currValue) then
					if (seedLevel == potLevel) and (seedType == potType) and (potLevel > 1)then
						bestLevel = seedLevel
						bestType  = seedType
						seedID = itemID
						
					else
						if (seedType == potType) then
							if ((seedLevel > bestLevel) and (bestType == potType) and (bestLevel ~= potLevel)) or (bestType ~= potType) then
								bestLevel = seedLevel
								bestType  = seedType
								seedID = itemID
							end
						else
							if (seedLevel > bestLevel) and (bestType ~= potType) then
								bestLevel = seedLevel
								bestType  = seedType
								seedID = itemID
							end
						end
					end
				end
			end

		end
	end

	return(seedID)
end

-- Event functions
function PlantCare.STORE_OPEN()
    local icon, name, price, moneyType, count, stock = GetStoreSellItemInfo(1)

    if ((PlantCare.Materials.Water[1][1] == name) or (PlantCare.Materials.Water[4][1] == name) or (PlantCare.Materials.Water[7][1] == name) or (TEXT('Sys242771_name') == name)) then
				
        PlantCareFrame_PlantStoreModifications:Show()
        PlantCare:UpdateMaterialHighlights()
        PlantCare:UpdateMaterialCounts()
        PlantCare:DisplayMaxLevelMaterial()
        PlantCare:DisplayMaxLevelRarity()

        PlantCareFrame_PlantStoreModifications_StoreFertilizerButton:Enable()
        PlantCareFrame_PlantStoreModifications_StoreWaterButton:Enable()

        if (IsCtrlKeyDown()) then
            PlantCare:BuyMaterials()
        end
    else
        PlantCareFrame_PlantStoreModifications:Hide()
    end
end

function PlantCare.STORE_CLOSE()
    PlantCare.counterTimer = 0
    PlantCare.shopWaterDisableTimer = 0
    PlantCare.shopFertilizerDisableTimer = 0
end

function PlantCare.HOUSES_PLANT_OPEN()
    PlantCare_Frame:Show()
	
    -- Update the picture of the currently selected pot
    local enable, name, texture , placed, ID = Houses_GetFurnitureItemInfo(PlantCare_GetFocusFurnishingID())
    SetItemButtonTexture(PlantCareFrame_PotInfoFrameButton, texture)
	
	-- Get information about the plant
    local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink, fGrowRate, fHealthRate, nReapTime,
    nFeedPoint, nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint, fDecWater, fDecTopdress = Plant_GetInfo()

    local seedType = PlantCare.GetSeedName(nPotType)
    local nPotLevel = nil
    if placed then nPotLevel = PlantCare.GetCurrentPotLevel() end

	
    -- Now update our PotInfoFrame
    PlantCareFrame_PotInfoFramePottext:SetText(szPotName)
    PlantCareFrame_PotInfoFrameTypetext:SetText(seedType..", "..PlantCare.Strings.Potlevel.." "..tostring(nPotLevel))

    if (szState == "none") then
		
        if (PlantCare.currentSeedInHand == 0) then

            local seedID = PlantCare:grabBestSeed(nPotType,nPotLevel)

            if (PlantCare_Settings.AutoSeed) and (seedID ~= 0) and (not IsShiftKeyDown()) then

                -- Pot is empty and user wants to plant the best seed found in backpack
                PlantCare.PlantSeedFromBag(seedID)

                PlantCare.DoAutoCareAfterPlanting()

                local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
                PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")

                PlantCare:UpdateTimes()
                PlantCare_InfoFrame_ResetFrame()

            else
                -- If we don't currently have a seed selected and we
                -- clicked on an empty pot, then hide our plant info
                if (PlantCare_Settings.AutoSeed)  then
                    SendSystemMsg(PlantCare.Strings.NoSeedFound)
                end

                PlantCareFrame_Progress:Hide()
                PlantCareFrame_SeedInfoFrameMsg2:Hide()
            end

        else

            -- If we have a seed selected and we click on an empty pot,
            -- make sure we still have seed left in that stack
            -- and then plant it.  Also feed/water it if autocare is on.

            if not IsShiftKeyDown() then

                local itemCount = PlantCare.PlantSeedFromBag(PlantCare.currentSeedInHand)

                if not itemCount then
                    SendSystemMsg(PlantCare.Strings.SeedEmpty)
                    DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedEmpty)
                    PlantCare.currentSeedInHand = 0
                else

                    -- We just planted a seed, if we don't have anymore - display a message.
                    if itemCount == 1 then
                        SendSystemMsg(PlantCare.Strings.SeedEmpty)
                        DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedEmpty)
                        PlantCare.currentSeedInHand = 0
                    end

                    PlantCare.DoAutoCareAfterPlanting()
                end
            end
        end
    end

    local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
    PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")

    if (PlantCare_Settings.AutoCare == true) and (not IsShiftKeyDown()) then
        PlantCare.DoAutoCare()
    end

    PlantCare:UpdateTimes()
    PlantCare_InfoFrame_ResetFrame()
end

function PlantCare.GetCurrentPotLevel()
    -- Set our game tooltip to the currently selected pot
    PlantCareFrame_InfoTooltip:SetHouseItem(-1 , PlantCare_GetFocusFurnishingID())
	
	
    -- Now loop thru all the lines of the tooltip looking for specific information about this pot
    local nPotLevel = nil
    for n=2,7 do
        if (string.find(getglobal("PlantCareFrame_InfoTooltipTextLeft"..n):GetText(),string.gsub(TEXT('SYS_NEED_PLANT_SKILL'),"%%d",""),1,true)~=nil) then
            -- don't know, why this doesn't work any more, looks good to me.
            -- nPotLevel = tonumber(string.match(getglobal("PlantCareFrame_InfoTooltipTextLeft"..n):GetText(), string.gsub(TEXT('SYS_NEED_PLANT_SKILL'), "%%d", "(%%d+)")))
            local anfang,ende = string.find(getglobal("PlantCareFrame_InfoTooltipTextLeft"..n):GetText(),"%d+")
            nPotLevel = tonumber(string.sub(getglobal("PlantCareFrame_InfoTooltipTextLeft"..n):GetText(),anfang,ende))
			--testmessage
			--DEFAULT_CHAT_FRAME:AddMessage("Potlevel:"..n.." - "..nPotLevel)
			break
        end
    end
		
    return nPotLevel
end

function PlantCare.GetSeedName(nPotType)
    if (nPotType == 0) then return PlantCare.Strings.seedAll; end
    if (nPotType == 1) then return PlantCare.Strings.seedWood; end
    if (nPotType == 2) then return PlantCare.Strings.seedHerb; end
    if (nPotType == 3) then return PlantCare.Strings.seedOre; end

    return "?"
end

function PlantCare.PlantSeedFromBag(seedID)

    local occupiedSlots, totalSlots = GetBagCount()
    for i=1, totalSlots do
        local invNr, texture, name, itemCnt, locked, invalid = GetBagItemInfo(i)
        local itemLink = GetBagItemLink(invNr)

        if (itemLink) then
            local _, itemData, itemName = ParseHyperlink(itemLink)
            local _, _, itemID = string.find(itemData, "^(%x+)")
            itemID = tonumber(itemID, 16)

            if (itemID == seedID) then
                -- Clear our "Planting Successful" message count
                PlantCare.BlockMessages[1][2] = 0

                PickupBagItem(invNr)
                Plant_PickupItem("seed")
                Plant_Grow("seed")

                return itemCnt
            end
        end
    end
end

function PlantCare.DoAutoCareAfterPlanting()
    if PlantCare_Settings.AutoCare == true and not IsShiftKeyDown() then
        if PlantCare_CheckLockCareForPlants() then
            DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants while LOCKED!")
        else
            PlantCare.WaitForPlantingSuccessLoop = 0
            Sol.timers.ScheduleTimer(PlantCare.name, 0.2, PlantCare_WaitForPlantingSuccess)
        end
    end
end

function PlantCare.HOUSES_PLANT_CLOSE()
    PlantCare_Frame:Hide()
end

function PlantCare.HOUSESFRAME_HIDE()
    PlantCare_Frame:Hide()
end

function PlantCare.UPDATE_STORE_BUYBACK_ITEMS()
    PlantCare.counterTimer = 2
end

function PlantCare.UPDATE_STORE_SELL_ITEMS()
    PlantCare.counterTimer = 2
end
	
-- generall Event handler
function PlantCare:OnEvent(frame, _event, ...)
	if PlantCare[_event] then
		PlantCare[_event](frame, ...)
	end
end

--[[
--   This function sits around waiting for the last seed we planted to finish being planted.
--   I wrote this function because depending on the speed of your system, sometimes recently
--   planted seeds would not get water/fertilizer (with AutoCare turned on) if they took too
--   long to plant.
--   ..Castaway
--]]
function PlantCare_WaitForPlantingSuccess()
	if (PlantCare.BlockMessages[1][2] == 0) then
		PlantCare.WaitForPlantingSuccessLoop = PlantCare.WaitForPlantingSuccessLoop + 1

		if (PlantCare.WaitForPlantingSuccessLoop > 20) then
			DEFAULT_CHAT_FRAME:AddMessage("PlantCare encountered an ERROR waiting for your seed to be planted. You may have to manually feed and water.")
			return
		else
			Sol.timers.ScheduleTimer(PlantCare.name, 0.1, PlantCare_WaitForPlantingSuccess)
		end
	else
        PlantCare.DoAutoCare()
	end
end

function PlantCare.DoAutoCare()
		if (PlantCare_CheckLockCareForPlants()) then
			DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants while LOCKED!")
		else
			if (PlantCare_Settings.LongCare == true) then
				PlantCare:LongCareForPlants()
			else
				PlantCare_CareForPlants()
			end
		end
end


function PlantCare:HOUSES_PLANT_CHANGED()
	local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
	PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")

	PlantCare:UpdateTimes()
	PlantCare_InfoFrame_ResetFrame()
end

function PlantCare:VARIABLES_LOADED()
	Sol.config.CheckSettings(PlantCare.name, PlantCare.DefaultSettings)
	
	PlantCare:CheckLanguage()
	PlantCare:RegisterWithAddonManager()

	if (PlantCare_Settings.version == nil) then
		PlantCare_Settings.HarvestTimes={}
		PlantCare_Settings.version = PlantCare.Version
	elseif (PlantCare_Settings.version ~= PlantCare.Version) then
		PlantCare_Settings.version = PlantCare.Version
		PlantCare_Settings.MaxLevelMaterial = PlantCare.DefaultSettings.MaxLevelMaterial
		PlantCare_Settings.HarvestTimes = {}
	end

	if PlantCare_Settings.HarvestTimes == nil then
		PlantCare_Settings.HarvestTimes = {}
	end

	PlantCare:Enable()

	PlantCare_Properties_standard_LongCare:SetChecked   				(PlantCare_Settings.LongCare)
	PlantCare_Properties_standard_GetProduct:SetChecked 				(PlantCare_Settings.GetProduct)
	PlantCare_Properties_standard_AutoCare:SetChecked   				(PlantCare_Settings.AutoCare)
	PlantCare_Properties_standard_AlertWater:SetChecked 				(PlantCare_Settings.AlertWater)
	PlantCare_Properties_standard_countPlants:SetChecked				(PlantCare_Settings.CountPlants)
	PlantCare_Properties_standard_autoSeed:SetChecked   				(PlantCare_Settings.AutoSeed)
	PlantCare_Properties_standard_autoBuySeed:SetChecked   				(PlantCare_Settings.AutoBuySeed)
	PlantCare_Properties_standard_waterBeforeHarvest:SetChecked  		(PlantCare_Settings.WaterBeforeHarvest)
	PlantCare_Properties_standard_compensate:SetChecked  				(PlantCare_Settings.Compensate)
	if (not PlantCare_Settings.WaterBeforeHarvest) then
		PlantCare_Properties_standard_compensate:Disable()
		PlantCare_Properties_standard_compensate_Text:SetColor(0.2,0.2,0.2)
	end
	PlantCare_Properties_standard_waterSound:SetChecked 				(PlantCare_Settings.WaterSound)
	PlantCare_Properties_standard_Percent_Value:SetText 				(tostring(PlantCare_Settings.AlertPercentUnder))
	PlantCare_Properties_standard_autoBuySeed_Value:SetText				(tostring(PlantCare_Settings.AutoBuySeedValue))
	PlantCare_Properties_expert_longcare_Percent_Value:SetText 			(tostring(PlantCare_Settings.ExpertLongCareValue))
	PlantCare_Properties_expert_harvestcare_Percent_Value:SetText 		(tostring(PlantCare_Settings.ExpertWaterHarvestValue))
	PlantCare_Properties_expert_harvestcare_low_Percent_Value:SetText	(tostring(PlantCare_Settings.ExpertWaterHarvestLowValue))
	
	PlantCare.loadExpertSettings()

	SLASH_APC1 = "/apc"
	SLASH_APC2 = "/plantcare"
	SlashCmdList["APC"] = PlantCare.slash

	-- because old values of MaxLevelMaterial don't work anymore
	local found = false
	local i,v
	for i, v in ipairs(PlantCare.Materials.Levels) do
		if v == PlantCare_Settings.MaxLevelMaterial then
			found = true
		end
	end
	if not found then
		PlantCare_Settings.MaxLevelMaterial = PlantCare.DefaultSettings.MaxLevelMaterial
	end
end

function PlantCare_ToggleInfoFrame(this, cmd)
	if (PlantCareInfoFrame:IsVisible()) then
		PlantCareInfoFrame:Hide()
	else
		PlantCareInfoFrame:Show()
	end
end

function PlantCare.slash(_,msg)
	if (msg == nil) or (msg == "") or (msg == "info") then
		if (not PlantCareInfoFrame:IsVisible()) then
			PlantCareInfoFrame:Show()
		end
		if (msg ~= "info") then
			doSHelp = true
		end
	elseif (msg == "settings") or (msg == "properties") or (msg == "config") then
		if (not PlantCare_Properties:IsVisible()) then
			PlantCare_Properties:Show()
		end
	elseif (msg == "help") then
		DEFAULT_CHAT_FRAME:AddMessage("---[|cff00ff00".."PlantCare|r]-------------------------------")
		DEFAULT_CHAT_FRAME:AddMessage(string.format(PlantCare.Strings.MoreHelp1,"|cff00ff00/plantcare|r","|cff00ff00/apc|r"))
		DEFAULT_CHAT_FRAME:AddMessage(string.format(PlantCare.Strings.SlashHelp1,"|cff00ff00/plantcare info|r"))
		DEFAULT_CHAT_FRAME:AddMessage(string.format(PlantCare.Strings.SlashHelp2,"|cff00ff00/plantcare settings|r"))
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.Help1)
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.Help2)
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.MoreHelp2)
		DEFAULT_CHAT_FRAME:AddMessage("-------------------------------------------")
	else
		DEFAULT_CHAT_FRAME:AddMessage("[|cff00ff00".."PlantCare|r] "..string.format(PlantCare.Strings.SlashHelp3,"|cff00ff00/plantcare help|r"))
	end
end

function PlantCareOnClickScript()
	PlantCareInfoFrame:Show()
end

function PlantCare:RegisterWithAddonManager()
    if AddonManager then
        local addon = {
            name          = PlantCare.name,
            description   = PlantCare.Strings.description,
            category      = "Other",
            version       = PlantCare.Version,
            author        = "lusiux, Castaway, Alleris, skite2001, DawnSight, ArneFi, Omnibrain", 
			miniButton    = PlantCareMiniButton,
			onClickScript = PlantCareOnClickScript,
			slashCommands = "/apc, /plantcare",
            icon          = "Interface/Addons/PlantCare/Textures/PlantCareIcon",
        }
        if AddonManager.RegisterAddonTable then
            AddonManager.RegisterAddonTable(addon)
        else
            AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category,
                addon.configFrame, addon.slashCommands, addon.miniButton, addon.onClickScript)
        end
    else
        Sol.io.Print("PlantCare loaded")
    end
end

function PlantCare:CheckLanguage()
	PlantCare_Properties_Header:SetText          					(PlantCare.Addonname.." - "..PlantCare.Strings.SettingsTitle)

	PlantCare_Properties_standard_LongCare_Text:SetText   			(PlantCare.Strings.GUI_longcare)
	PlantCare_Properties_standard_AlertWater_Text:SetText 			(PlantCare.Strings.AlertWaterUnder)
	PlantCare_Properties_standard_countPlants_Text:SetText			(PlantCare.Strings.CountPlants)
	PlantCare_Properties_standard_autoSeed_Text:SetText   			(PlantCare.Strings.AutoSeed)
	PlantCare_Properties_standard_autoBuySeed_Text:SetText 			(PlantCare.Strings.AutoBuySeed)
	PlantCare_Properties_standard_waterBeforeHarvest_Text:SetText	(PlantCare.Strings.WaterBeforeHarvest)
	PlantCare_Properties_standard_compensate_Text:SetText			(PlantCare.Strings.Compensate)
	PlantCare_Properties_standard_waterSound_Text:SetText 			(PlantCare.Strings.WaterSound)
	PlantCare_Properties_standard_GetProduct_Text:SetText 			(PlantCare.Strings.GetProduct)
	PlantCare_Properties_standard_AutoCare_Text:SetText   			(PlantCare.Strings.AutoCare)
	PlantCare_Properties_standard_additional_care:SetText 			(PlantCare.Strings.additionalCare)
	PlantCare_Properties_standard_messages:SetText 					(PlantCare.Strings.Messages)
	PlantCare_Properties_standard_Title:SetText 					(PlantCare.Strings.normalSettings)
	PlantCare_Properties_expert_Title:SetText 						(PlantCare.Strings.expertSettings)
	PlantCare_Properties_expert_long:SetText 						(PlantCare.Strings.GUI_longcare)
	PlantCare_Properties_expert_havestcare:SetText 					(PlantCare.Strings.HarvestCare)
	PlantCare_Properties_expert_havestcare_low:SetText 				(PlantCare.Strings.HarvestCareLow)
	PlantCare_Properties_expert_longcare_auto_Label:SetText 		(PlantCare.Strings.automatic)
	PlantCare_Properties_expert_longcare_opt_min_Label:SetText 		(PlantCare.Strings.ExpertWaterOptMin)
	PlantCare_Properties_expert_longcare_opt_max_Label:SetText 		(PlantCare.Strings.ExpertWaterOptMax)
	PlantCare_Properties_expert_longcare_min_Label:SetText 			(PlantCare.Strings.ExpertWaterMin)
	PlantCare_Properties_expert_longcare_max_Label:SetText 			(PlantCare.Strings.ExpertWaterMax)
	PlantCare_Properties_expert_longcare_feed_Label:SetText 		(PlantCare.Strings.ExpertFeed)
	PlantCare_Properties_expert_harvestcare_auto_Label:SetText 		(PlantCare.Strings.automatic)
	PlantCare_Properties_expert_harvestcare_feed_Label:SetText 		(PlantCare.Strings.ExpertFeed)
	PlantCare_Properties_expert_harvestcare_low_auto_Label:SetText 	(PlantCare.Strings.automatic)
	PlantCare_Properties_expert_harvestcare_low_feed_Label:SetText 	(PlantCare.Strings.ExpertFeed)
	PlantCareInfoFrame_Title:SetText(PlantCare.Addonname.." - "..PlantCare.Strings.InfoTitle)
	PlantCareInfoFrame_SlashText:SetText(PlantCare.Strings.Slash)
	PlantCareInfoFrame_PlantDetailFrame_HarvestTimeDesc:SetText  (PlantCare.Strings.Ripe)
	PlantCareInfoFrame_PlantDetailFrame_LastCareTimeDesc:SetText (PlantCare.Strings.InfoFrom)
	PlantCareInfoFrame_PlantDetailFrame_LastGrowRateDesc:SetText (PlantCare.Strings.LastGrowRate)
	PlantCareInfoFrame_PlantDetailFrame_LastHealthDesc:SetText   (PlantCare.Strings.LastHealth)
	PlantCareInfoFrame_PlantDetailFrame_Topdress:SetText         (PlantCare.Strings.Topdress)
	PlantCareInfoFrame_PlantDetailFrame_Water:SetText            (PlantCare.Strings.Water)
	PlantCareInfoFrame_PlantDetailFrame_Last:SetText             (PlantCare.Strings.LastTime)
	PlantCareInfoFrame_PlantDetailFrame_Drain:SetText            (PlantCare.Strings.Drain)
	PlantCareInfoFrame_PlantDetailFrame_Calculated:SetText       (PlantCare.Strings.Now)
end

function PlantCare:Enable()
	PlantCare.frame:RegisterEvent("HOUSES_PLANT_OPEN")
	PlantCare.frame:RegisterEvent("STORE_OPEN")
	Sol.hooks.Hook(PlantCare.name, "PlantFrame_FormalTime", PlantCare.Hook_FormalTime)
	Sol.hooks.Hook(PlantCare.name, "BagItemButton_OnClick", PlantCare.BagItemButton_OnClick)
	if (type(zBag)=="table" and type(zBagItem1)=="table") then
		Sol.hooks.Hook(PlantCare.name, "zBagItem_OnClick", PlantCare.zBagItemButton_OnClick)
	end

	Sol.hooks.Hook(PlantCare.name, "StoreFrame_SellUpdate", PlantCare.SellUpdate)
	Sol.hooks.Hook(PlantCare.name, "ChatFrame_OnEvent",     PlantCare.ChatFrame_OnEvent)
end

function PlantCare:UpdateTimes(updateSettings)
	local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink,
		fGrowRate, fHealthRate, nReapTime, nFeedPoint,
		nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint,
		fDecWater, fDecTopdress = Plant_GetInfo()

	local playerName = UnitName("player")

	if PlantCare_Settings.HarvestTimes[playerName] == nil then
		PlantCare_Settings.HarvestTimes[playerName] = {}
	end

	local furnishID = Houses_GetFocusFurnishingID()

	if PlantCare_Settings.HarvestTimes[playerName][furnishID] == nil then
		PlantCare_Settings.HarvestTimes[playerName][furnishID] = {}
	end

	local dateString = ""

	if szState == "grow" then
		dateString = PlantCare.clock.FormatDateDelta_short(nReapTime)

		if (nWaterPoint > (nBestWaterPoint - PlantCare_Settings.AlertPercentUnder)) and (nTopdressPoint > (nBestTopdressPoint - PlantCare_Settings.AlertPercentUnder)) then
			PlantCare_Settings.HarvestTimes[playerName][furnishID].alert        = 2
		end
		
		if PlantCare.clock.time then
			PlantCare_Settings.HarvestTimes[playerName][furnishID].HarvestTime    = PlantCare.clock.time() + nReapTime
			PlantCare_Settings.HarvestTimes[playerName][furnishID].LastCareTime   = PlantCare.clock.time()
		end
		
		PlantCare_Settings.HarvestTimes[playerName][furnishID].SeedName          = szSeedName
		PlantCare_Settings.HarvestTimes[playerName][furnishID].GrowRate          = fGrowRate
		PlantCare_Settings.HarvestTimes[playerName][furnishID].Health            = fHealthRate
		PlantCare_Settings.HarvestTimes[playerName][furnishID].TopdressPoint     = nTopdressPoint
		PlantCare_Settings.HarvestTimes[playerName][furnishID].BestTopdressPoint = nBestTopdressPoint
		PlantCare_Settings.HarvestTimes[playerName][furnishID].WaterPoint        = nWaterPoint
		PlantCare_Settings.HarvestTimes[playerName][furnishID].BestWaterPoint    = nBestWaterPoint
		PlantCare_Settings.HarvestTimes[playerName][furnishID].DecWater          = fDecWater
		PlantCare_Settings.HarvestTimes[playerName][furnishID].DecTopdress       = fDecTopdress
		PlantCare_Settings.HarvestTimes[playerName][furnishID].ID                = furnishID
		if PlantCare_Settings.HarvestTimes[playerName][furnishID].notify == nil then
			PlantCare_Settings.HarvestTimes[playerName][furnishID].notify        = 2
		end
		if (PlantCare_Settings.HarvestTimes[playerName][furnishID].harvested == nil) or (nReapTime > 0) then
			PlantCare_Settings.HarvestTimes[playerName][furnishID].harvested     = 0
		end
		if PlantCare_Settings.HarvestTimes[playerName][furnishID].alert == nil then
			PlantCare_Settings.HarvestTimes[playerName][furnishID].alert        = 2
		end
	end
	
	--alte Einträge löschen
	if szState == "none" then
		PlantCare_Settings.HarvestTimes[playerName][furnishID] = nil
	end

	PlantCare_PlantTime_String:SetText(dateString)
end

function PlantCare:LongCareForPlants()
	if (PlantCare_CheckLockCareForPlants()) then
		DEFAULT_CHAT_FRAME:AddMessage("LongCareForPlants() LOCKED!")
		return
	end

	local didsth = 0

	PlantCare_LockCareForPlants()

	local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink,
	fGrowRate, fHealthRate, nReapTime, nFeedPoint,
	nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint,
	fDecWater, fDecTopdress = Plant_GetInfo()

	if ((szState == "ripe") and (PlantCare_Settings.GetProduct)) then
		PlantCare_WaterHarvest()
		return
	elseif szState == "death" then
		if PlantCare_Settings.GetProduct then
			Plant_Clear();
		end

		PlantCare_UnLockCareForPlants()
		return

	elseif ((szState == "grow") or ((szState == "ripe") and (PlantCare_Settings.GetProduct == false))) then
	
		PlantCare:GrabWater()
		PlantCare:GrabTopdress()
		
		local waterCount = 0
		local topdressCount = 0
		
		if (PlantCare_Settings.ExpertLongCare == 0) then
			waterCount = PlantCare:calcLongCareCount(nWaterPoint, nBestWaterPoint, 1)
			topdressCount = PlantCare:calcLongCareCount(nTopdressPoint, nBestTopdressPoint, 2)
		elseif (PlantCare_Settings.ExpertLongCare > 0) and (PlantCare_Settings.ExpertLongCare < 5) then
			local target = PlantCare_Settings.ExpertLongCareValue
			local maximize = false
			if (PlantCare_Settings.ExpertLongCare == 1) or (PlantCare_Settings.ExpertLongCare == 3) then
				maximize = true
			end
			if (PlantCare_Settings.ExpertLongCare == 1) or (PlantCare_Settings.ExpertLongCare == 2) then
				waterCount =    PlantCare:calcLongCareCountStrict(nWaterPoint,    nBestWaterPoint,    1, maximize)
				topdressCount = PlantCare:calcLongCareCountStrict(nTopdressPoint, nBestTopdressPoint, 2, maximize)
			end
			if (PlantCare_Settings.ExpertLongCare == 3) or (PlantCare_Settings.ExpertLongCare == 4) then
				waterCount =    PlantCare:calcLongCareCountStrict(nWaterPoint,    target, 1, maximize)
				topdressCount = PlantCare:calcLongCareCountStrict(nTopdressPoint, target, 2, maximize)
			end
		elseif (PlantCare_Settings.ExpertLongCare == 5) then
			if (nFeedPoint < PlantCare_Settings.ExpertLongCareValue) then
				local delta = math.ceil((PlantCare_Settings.ExpertLongCareValue - nFeedPoint) / 2)
				waterCount =    math.ceil(delta / PlantCare.currentWaterFeeds)
				topdressCount = math.ceil(delta / PlantCare.currentFertilizerFeeds)
				if (nFeedPoint + (waterCount * PlantCare.currentWaterFeeds) + (topdressCount * PlantCare.currentFertilizerFeeds) > 100) then
					waterCount = waterCount - 1
					topdressCount = topdressCount - 1
				end
			end
		end
		
		while (waterCount > 0) do
			Plant_Grow("water")
			PlantCare.waterGrabbed = PlantCare.waterGrabbed - 1
			if (PlantCare.waterGrabbed == 0) then
				PlantCare.action = "long"
				PlantCare_UnLockCareForPlants()
				PlantCare.Counter = 0.5
				return
			end
			didsth = 1
			waterCount = waterCount - 1
		end

		while (topdressCount > 0) do
			Plant_Grow("topdress")
			topdressCount = topdressCount - 1
			PlantCare.topdressGrabbed = PlantCare.topdressGrabbed - 1
			if (PlantCare.topdressGrabbed == 0) then
				PlantCare.action = "long"
				PlantCare_UnLockCareForPlants()
				PlantCare.Counter = 0.5
				return
			end
			didsth = 1
		end

		if (didsth == 1) then
			PlantCare:CountAndSound()
		end

	end

	Sol.timers.ScheduleTimer(PlantCare.name, 1.0, PlantCare_UnLockCareForPlants())
end

function PlantCare:FeedPlant(overwaterFlag, nTopdressPoint, nBestTopdressPoint)
	local didsth = 0

	PlantCare:GrabTopdress()
	local times = PlantCare:calcCareCount(nTopdressPoint, nBestTopdressPoint, 2)

	while (times > 0) do
		Plant_Grow("topdress")
		times = times - 1
		didsth = 1
		PlantCare.topdressGrabbed = PlantCare.topdressGrabbed - 1
		if ((PlantCare.topdressGrabbed == 0) and (times > 0)) then
			PlantCare.action = "normal"
			PlantCare_UnLockCareForPlants()
			PlantCare.Counter = 0.5
			return(-1)
		end
	end
	return (didsth)
end

function PlantCare:WaterPlant(overwaterFlag, nWaterPoint, nBestWaterPoint)
	local didsth = 0

	PlantCare:GrabWater()
	local times = PlantCare:calcCareCount(nWaterPoint, nBestWaterPoint, 1)
	
	while (times > 0) do
		Plant_Grow("water")
		times = times - 1
		didsth = 1
		PlantCare.waterGrabbed = PlantCare.waterGrabbed - 1
		if ((PlantCare.waterGrabbed == 0) and (times > 0)) then
			PlantCare.action = "normal"
			PlantCare_UnLockCareForPlants()
			PlantCare.Counter = 0.5
			return (-1)
		end
	end
	return (didsth)
end

function PlantCare_WaterHarvest()
	if PlantCare_Settings.WaterBeforeHarvest then
		PlantCare_WaterBeforeHarvest()
	else
		if PlantCare_Settings.GetProduct then
			Plant_GetProduct()
			if not (PlantCare_Settings.HarvestTimes[UnitName("player")][Houses_GetFocusFurnishingID()]) then
				PlantCare_Settings.HarvestTimes[UnitName("player")][Houses_GetFocusFurnishingID()] = {}
			end
			PlantCare_Settings.HarvestTimes[UnitName("player")][Houses_GetFocusFurnishingID()].harvested = 1
			PlantCare_Settings.HarvestTimes[UnitName("player")][Houses_GetFocusFurnishingID()].notify = nil
			
		end
		PlantCare_UnLockCareForPlants()
	end
end

function PlantCare_WaterBeforeHarvest()
	if (PlantCare_CheckLockCareForPlants()) then
		DEFAULT_CHAT_FRAME:AddMessage("LongCareForPlants() LOCKED!")
		return
	end

	PlantCare_LockCareForPlants()

	local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink,
		fGrowRate, fHealthRate, nReapTime, nFeedPoint,
		nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint,
		fDecWater, fDecTopdress = Plant_GetInfo()
	
	local smallFeed = 40
	local bigFeed = 85
	local delta
	
	local seed = PlantCare.DB_FindSeedByName(szSeedName)
	if seed then 
		smallFeed = seed[S_FEED_VAL_MIN]
		bigFeed = seed[S_FEED_VAL_MAX]
	end

	local bestFeed = smallFeed
	
	if (PlantCare_Settings.ExpertWaterHarvest == 1) then
		bestFeed = PlantCare_Settings.ExpertWaterHarvestValue
		if (bestFeed == nil) then
			bestFeed = smallFeed
		end
	end

	if (PlantCare_Settings.Compensate) then
		if ((fHealthRate * 100) < bigFeed) then
			bestFeed = bigFeed
		end
		if (PlantCare_Settings.ExpertWaterHarvestLow == 1) then
			bestFeed = PlantCare_Settings.ExpertWaterHarvestLowValue
			if (bestFeed == nil) then
				bestFeed = bigFeed
			end
		end
	end
	
	PlantCare:GrabWater()
	local waterCount = 0
	PlantCare:GrabTopdress()
	local topdressCount = 0
	
	if (nFeedPoint < bestFeed) then
		delta = math.ceil((bestFeed - nFeedPoint) / 2)
		waterCount = math.ceil(delta / PlantCare.currentWaterFeeds)
		topdressCount = math.ceil(delta / PlantCare.currentFertilizerFeeds)
	end
	
	if (nFeedPoint + (waterCount * PlantCare.currentWaterFeeds) + (topdressCount * PlantCare.currentFertilizerFeeds) > 100) then
		waterCount = waterCount - 1
		topdressCount = topdressCount - 1
	end
				
	while (waterCount > 0) do
		Plant_Grow("water")
		PlantCare.waterGrabbed = PlantCare.waterGrabbed - 1
		if (PlantCare.waterGrabbed == 0) then
			PlantCare.action = "over"
			PlantCare_UnLockCareForPlants()
			PlantCare.Counter = 0.5
			return
		end
		waterCount = waterCount - 1
	end
	
	while (topdressCount > 0) do
		Plant_Grow("topdress")
		PlantCare.topdressGrabbed = PlantCare.topdressGrabbed - 1
		if (PlantCare.topdressGrabbed == 0) then
			PlantCare.action = "over"
			PlantCare_UnLockCareForPlants()
			PlantCare.Counter = 0.5
			return
		end
		topdressCount = topdressCount - 1
	end

	if PlantCare_Settings.GetProduct then
		Plant_GetProduct()
			if not (PlantCare_Settings.HarvestTimes[UnitName("player")][Houses_GetFocusFurnishingID()]) then
				PlantCare_Settings.HarvestTimes[UnitName("player")][Houses_GetFocusFurnishingID()] = {}
			end
		PlantCare_Settings.HarvestTimes[UnitName("player")][Houses_GetFocusFurnishingID()].harvested = 1
		PlantCare_Settings.HarvestTimes[UnitName("player")][Houses_GetFocusFurnishingID()].notify = nil
		
	end

	Sol.timers.ScheduleTimer(PlantCare.name, 1.0, PlantCare_UnLockCareForPlants())
end

function PlantCare_CareForPlants()
	if (IsShiftKeyDown()) then
		PlantCare:LongCareForPlants()
	else
		if (PlantCare_CheckLockCareForPlants()) then
			DEFAULT_CHAT_FRAME:AddMessage("CareForPlants() LOCKED!")
			return
		end

		PlantCare_LockCareForPlants()

		local szState, szPotName, nPotType, szSeedName, szSeedTexture, szSeedLink,
		fGrowRate, fHealthRate, nReapTime, nFeedPoint,
		nWaterPoint, nTopdressPoint, nBestWaterPoint, nBestTopdressPoint,
		fDecWater, fDecTopdress = Plant_GetInfo()

		if ((szState == "ripe") and (PlantCare_Settings.GetProduct)) then
			PlantCare_WaterHarvest()
			return
		elseif szState == "death" then
			if PlantCare_Settings.GetProduct then
				Plant_Clear();
			end

			PlantCare_UnLockCareForPlants()
			return

		elseif ((szState == "grow") or ((szState == "ripe") and (PlantCare_Settings.GetProduct == false))) then
			local overwaterFlag = 1
			local didwater = 0
			local didfertilizer = 0

			didfertilizer = PlantCare:FeedPlant(overwaterFlag, nTopdressPoint, nBestTopdressPoint)
			didwater = PlantCare:WaterPlant(overwaterFlag, nWaterPoint, nBestWaterPoint)

			if ((didwater == 1) or (didfertilizer == 1)) then
				if ((didwater >= 0) and (didfertilizer >= 0)) then
					PlantCare:CountAndSound()
				end
			end
		end

		Sol.timers.ScheduleTimer(PlantCare.name, 2.0, PlantCare_UnLockCareForPlants())
	end
end

function PlantCare:CountAndSound()
	if (PlantCare_Settings.WaterSound == true) then
		PlaySoundByPath("Interface/AddOns/PlantCare/Sounds/ding.mp3")
	end
	if (PlantCare_Settings.CountPlants == true) then
		PlantCare.plantCounter = PlantCare.plantCounter + 1
		PlantCare.resetTimer = 30
		SystemMsgFrame:AddMessage(PlantCare.plantCounter, 0, 1, 0)
		if (PlantCare_Settings.WaterSound ~= true) then
			PlaySoundByPath("sound\\interface\\ui_sysmsg_normal.mp3")
		end
	end
end

function PlantCare:calcCareCount(current, best, type)
	if (best == 90) then
		best = 93
	elseif (best == 85) then
		best = 91
	elseif (best == 80) then
		best = 87
	elseif (best == 70) then
		best = 80
	end

	if (type == 2) then
		return math.floor((best-current)/ PlantCare.currentFertilizerSteps)
	else
		return math.floor((best-current)/ PlantCare.currentWaterSteps)
	end
end

function PlantCare:calcLongCareCount(current, best, type)
	if (best == 90) then
		best = 100
	elseif (best == 85) then
		best = 100
	elseif (best == 80) then
		best = 95
	elseif (best == 70) then
		best = 90
	end

	if (type == 2) then
		return math.floor((best-current)/ PlantCare.currentFertilizerSteps)
	else
		return math.floor((best-current)/ PlantCare.currentWaterSteps)
	end
end

function PlantCare:calcLongCareCountStrict(current, best, type, maxi)
	if (best > 100) then
		best = 100
	end
	if maxi then
		if (type == 2) then
			return math.ceil((best-current)/ PlantCare.currentFertilizerSteps)
		else
			return math.ceil((best-current)/ PlantCare.currentWaterSteps)
		end
	else
		if (type == 2) then
			return math.floor((best-current)/ PlantCare.currentFertilizerSteps)
		else
			return math.floor((best-current)/ PlantCare.currentWaterSteps)
		end
	end
end

function PlantCare:getBestConsumable(type)
	-- gets the best water or fertilizer from the backpack
	local searchTable
	if (type == "water") then
		searchTable = PlantCare.Materials.Water
	elseif (type == "fertilizer") then
		searchTable = PlantCare.Materials.Fertilizer
	else
		return 0
	end

	local i,s,v
	local occupiedSlots, totalSlots = GetBagCount()
	local bestName
	local bestLevel = 0
	local bestRarity = 0
	local plantlevel=PlantCare:GetPlantLevel()

	for i=1, totalSlots do
		local invNr, texture, name, itemCnt, locked, invalid = GetBagItemInfo(i)
		local itemLink = GetBagItemLink(invNr)

		for s, v in pairs(searchTable) do
			if (name == v[1]) then
				if (((v[2] > bestLevel) and (v[3] == bestRarity)) or
				   (v[3] > bestRarity)) and
				   (v[2] <= plantlevel) then
					bestRarity = v[3]
					bestLevel = v[2]
					bestName = v[1]
				end
			end
		end

	end
	
	-- Check for not found water or fertilizer
	if (bestName== nil or bestName==0) then
		if (type == "water") then
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.Water.." "..PlantCare.Strings.MaxLevelWarning1.." "..plantlevel.."). "..PlantCare.Strings.MaxLevelWarning2)
		elseif (type == "fertilizer") then
		DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.Fertilizer.." "..PlantCare.Strings.MaxLevelWarning1.." "..plantlevel.."). "..PlantCare.Strings.MaxLevelWarning2)
		end
	end

	return bestName
end

function PlantCare:GrabWater()
    local occupiedSlots, totalSlots = GetBagCount()
	local bestName = PlantCare:getBestConsumable("water")
	local i,k,v

    for i=1, totalSlots do
        local invNr, _, bagname, quantity = GetBagItemInfo(i)
		if (bestName == 0) or (bestName == bagname) then
			local itemLink = GetBagItemLink(invNr)
			if (itemLink) then
				local _, itemData, itemName = ParseHyperlink(itemLink)
				local _, _, itemID = string.find(itemData, "^(%x+)")
				itemID = tonumber(itemID, 16)
				PlantCare.currentWaterSteps = 10
				PlantCare.currentWaterFeeds = 1

				for k,v in pairs(PlantCare.Materials.Water) do
					if bagname == v[1] then
						PlantCare.currentWaterSteps = v[4]
						PlantCare.currentWaterFeeds = v[6]
						PlantCare.waterGrabbed = quantity
						PickupBagItem(invNr)
						Plant_PickupItem("water")
						return
					end
				end
			end
		end
    end
end

function PlantCare:GrabTopdress()

    local occupiedSlots, totalSlots = GetBagCount()
	local bestName = PlantCare:getBestConsumable("fertilizer")

    for i=1, totalSlots do
		local invNr, _, bagname, quantity  = GetBagItemInfo(i)
		local itemLink = GetBagItemLink(invNr)
		if (bestName == 0) or (bestName == bagname) then
			if (itemLink) then
				local _, itemData, itemName = ParseHyperlink(itemLink)
				local _, _, itemID = string.find(itemData, "^(%x+)")
				itemID = tonumber(itemID, 16)
				PlantCare.currentFertilizerSteps = 10
				PlantCare.currentFertilizerFeeds = 1

				for k,v in pairs(PlantCare.Materials.Fertilizer) do
					if bagname == v[1] then
						PlantCare.currentFertilizerSteps = v[4]
						PlantCare.currentFertilizerFeeds = v[6]
						PlantCare.topdressGrabbed = quantity
						PickupBagItem(invNr)
						Plant_PickupItem("topdress")
						return
					end
				end
			end
		end
    end
end

function PlantCare.zBagItemButton_OnClick(bagButton, ...)
	if (PlantFrame:IsVisible()) then
		PlantCare_ShowHelp()
	end

	if IsCtrlKeyDown() and PlantFrame:IsVisible() then
		-- AutoPlant this seed
		local itemlink = GetBagItemLink(bagButton.index)

		if (itemlink) then
			local itemkind, itemdata, itemname = ParseHyperlink(itemlink)
			local _, _, itemid = string.find(itemdata, "^(%x+)")
			itemid = tonumber(itemid, 16)

			-- Clear our "Planting Successful" message count
			PlantCare.BlockMessages[1][2] = 0

			PickupBagItem(bagButton.index)
			Plant_PickupItem("seed")
			Plant_Grow("seed")

			if PlantCare_Settings.AutoCare then
				if (PlantCare_CheckLockCareForPlants()) then
					DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants() while LOCKED!")
				else
					PlantCare.WaitForPlantingSuccessLoop = 0
					Sol.timers.ScheduleTimer(PlantCare.name, 0.1, PlantCare_WaitForPlantingSuccess)
				end
			end
		end

	elseif IsAltKeyDown() and PlantFrame:IsVisible() then
		-- Store this seed information for planting later...
		local itemlink = GetBagItemLink(bagButton.index)

		if (itemlink) then
			local itemkind, itemdata, itemname = ParseHyperlink(itemlink)
			local _, _, itemid = string.find(itemdata, "^(%x+)")
			itemid = tonumber(itemid, 16)

			if (PlantCare.currentSeedInHand == itemid) then
				SendSystemMsg(PlantCare.Strings.SeedUnSelected)
				DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedUnSelected)
				PlantCare.currentSeedInHand = 0
			else
				SendSystemMsg(PlantCare.Strings.SeedSelected)
				DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedSelected)
				PlantCare.currentSeedInHand = itemid
			end
		end
	else
		Sol.hooks.GetOriginalFn(PlantCare.name, "zBagItem_OnClick")(bagButton, ...)
	end
end

function PlantCare.BagItemButton_OnClick(bagButton, ...)
	if (PlantFrame:IsVisible()) then
		PlantCare_ShowHelp()
	end

	if IsCtrlKeyDown() and PlantFrame:IsVisible() then
		-- AutoPlant this seed
		local itemlink = GetBagItemLink(bagButton.index)

		if (itemlink) then
			local itemkind, itemdata, itemname = ParseHyperlink(itemlink)
			local _, _, itemid = string.find(itemdata, "^(%x+)")
			itemid = tonumber(itemid, 16)

			-- Clear our "Planting Successful" message count
			PlantCare.BlockMessages[1][2] = 0

			PickupBagItem(bagButton.index)
			Plant_PickupItem("seed")
			Plant_Grow("seed")

			if PlantCare_Settings.AutoCare then
				if (PlantCare_CheckLockCareForPlants()) then
					DEFAULT_CHAT_FRAME:AddMessage("Attempted to CareForPlants() while LOCKED!")
				else
					PlantCare.WaitForPlantingSuccessLoop = 0
					Sol.timers.ScheduleTimer(PlantCare.name, 0.1, PlantCare_WaitForPlantingSuccess)
				end
			end
		end

	elseif IsAltKeyDown() and PlantFrame:IsVisible() then
		-- Store this seed information for planting later...
		local itemlink = GetBagItemLink(bagButton.index)

		if (itemlink) then
			local itemkind, itemdata, itemname = ParseHyperlink(itemlink)
			local _, _, itemid = string.find(itemdata, "^(%x+)")
			itemid = tonumber(itemid, 16)

			if (PlantCare.currentSeedInHand == itemid) then
				SendSystemMsg(PlantCare.Strings.SeedUnSelected)
				DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedUnSelected)
				PlantCare.currentSeedInHand = 0
			else
				SendSystemMsg(PlantCare.Strings.SeedSelected)
				DEFAULT_CHAT_FRAME:AddMessage(PlantCare.Strings.SeedSelected)
				PlantCare.currentSeedInHand = itemid
			end
		end
	else
		Sol.hooks.GetOriginalFn(PlantCare.name, "BagItemButton_OnClick")(bagButton, ...)
	end
end

function PlantCare_OnUpdate(frame, elapsedTime)
	if (not PlantFrame:IsVisible()) then
		PlantCare_Frame:Hide()
	end
	if (PlantCare.Counter > 0) then
		PlantCare.Counter = PlantCare.Counter - elapsedTime
		if (PlantCare.Counter <= 0) then
			if (PlantCare.action == "normal") then
				PlantCare_CareForPlants()
			elseif (PlantCare.action == "long") then
				PlantCare:LongCareForPlants()
			elseif (PlantCare.action == "over") then
				PlantCare_WaterBeforeHarvest()
			end
		end
	end
end

function PlantCare_ReminderUpdate(frame, elapsedTime)
	PlantCare.watchCounter = PlantCare.watchCounter - elapsedTime
	if (PlantCare.watchCounter <= 0) then
		PlantCare.watchCounter = 300
		if (PlantCare_checkHarvestState() == 0) then
			if (PlantCare_Settings.AlertWater == true) then
				PlantCare_checkWaterState()
			end
		end
	end

	if (PlantCare.resetTimer > 0) then
		PlantCare.resetTimer = PlantCare.resetTimer - elapsedTime
		if (PlantCare.resetTimer <= 0) then
			PlantCare.plantCounter = 0
		end
	end

	if (PlantCare.counterTimer > 0) then
		PlantCare.counterTimer = PlantCare.counterTimer - elapsedTime
		if (PlantCare.counterTimer <= 0) then
			PlantCare:UpdateMaterialCounts()
		end
	end

	if (PlantCare.shopWaterDisableTimer > 0) then
		PlantCare.shopWaterDisableTimer = PlantCare.shopWaterDisableTimer - elapsedTime
		if (PlantCare.shopWaterDisableTimer <= 0) then
			PlantCareFrame_PlantStoreModifications_StoreWaterButton:Enable()
		end
	end
	if (PlantCare.shopFertilizerDisableTimer > 0) then
		PlantCare.shopFertilizerDisableTimer = PlantCare.shopFertilizerDisableTimer - elapsedTime
		if (PlantCare.shopFertilizerDisableTimer <= 0) then
			PlantCareFrame_PlantStoreModifications_StoreFertilizerButton:Enable()
		end
	end
	if (PlantCare.tooltipdelay > 0) then
		PlantCare.tooltipdelay = PlantCare.tooltipdelay - elapsedTime
		if (PlantCare.tooltipdelay <= 0) then
			PlantCare.showToolTip()
		end
	end
end

function PlantCare.ChatFrame_OnEvent(this, event)
	if ((PlantFrame:IsVisible()) and (event == "CHAT_MSG_SYSTEM")) then
		for n=1,table.maxn(PlantCare.BlockMessages) do
			if (string.match(arg1, PlantCare.BlockMessages[n][1])) then
				PlantCare.BlockMessages[n][2] = PlantCare.BlockMessages[n][2] + 1
				return
			end
		end
		if (Houses_GetFocusFurnishingID()) then
			local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")
			PlantFrameTitle:SetText("["..tostring(Houses_GetFocusFurnishingID()).."] "..C_LEVEL.." "..math.floor(currValue).." - "..string.format("%.1f",100*(currValue-math.floor(currValue))).."%")
		end
	end
	Sol.hooks.GetOriginalFn(PlantCare.name, "ChatFrame_OnEvent")(this, event)
end

--[[
--   PlantCare Store Modificiations
--]]

function PlantCare:GetPlantLevel()
	-- a := Level of Water/Fertilizer that's <= Player's planting skill
	-- b := Maxlevel of Water/Fertilizer to buy (set by user)
	-- this function returns min(a,b)

	local plantlevel=1
	local i
	local v
	local newValue = 0
	local currValue, extraValue, maxValue = GetPlayerSkilled("PLANT")

	if (currValue >= PlantCare_Settings.MaxLevelMaterial) then
		plantlevel = PlantCare_Settings.MaxLevelMaterial
	else
		for i, v in ipairs(PlantCare.Materials.Levels) do
			if (v <= currValue) and (newValue < v) then
				newValue = v
			end
		end
		plantlevel = newValue
	end

	return plantlevel
end

function PlantCare.SellUpdate()
	Sol.hooks.GetOriginalFn(PlantCare.name, "StoreFrame_SellUpdate")()
	PlantCare:UpdateMaterialHighlights()
	PlantCare:UpdateMaterialCounts()
end

function PlantCare:StoreFrameTooltip(this)
	GameTooltip:SetOwner(this, "ANCHOR_BOTTOMRIGHT")

	if (this:GetName()=="PlantCareFrame_PlantStoreModifications_StoreWaterButton") then
		GameTooltip:SetText(PlantCare.Strings.BuyWater1,0,0.63,0)
		GameTooltip:AddLine("[PlantCare "..PlantCare.Version.."]",0,0.63,0)
		GameTooltip:AddLine(PlantCare.Strings.BuyWater2,0.6,1,0.3)
	elseif (this:GetName()=="PlantCareFrame_PlantStoreModifications_StoreFertilizerButton") then
		GameTooltip:SetText(PlantCare.Strings.BuyFert1,0,0.63,0)
		GameTooltip:AddLine("[PlantCare "..PlantCare.Version.."]",0,0.63,0)
		GameTooltip:AddLine(PlantCare.Strings.BuyFert2,0.6,1,0.3)
	elseif (this:GetName()=="PlantCareFrame_PlantStoreModifications_MaxLevelMaterial") then
		GameTooltip:SetText(PlantCare.Strings.MaxLevel1,0,0.63,0)
		GameTooltip:AddLine("[PlantCare "..PlantCare.Version.."]",0,0.63,0)
		GameTooltip:AddLine(PlantCare.Strings.MaxLevel2,0.6,1,0.3)
	elseif (this:GetName()=="PlantCareFrame_PlantStoreModifications_Rarities") then
		GameTooltip:SetText(PlantCare.Strings.MaxRarity1,0,0.63,0)
		GameTooltip:AddLine("[PlantCare "..PlantCare.Version.."]",0,0.63,0)
		GameTooltip:AddLine(PlantCare.Strings.MaxRarity2,0.6,1,0.3)
	end
end

function PlantCare:getBestWaterIndex()
	local plantlevel=PlantCare:GetPlantLevel()
	local n
	local suggestedLevel = 0
	local suggestedRarity = 0
	local WaterIndex = 0

	for n=1,10 do
		for i, v in ipairs(PlantCare.Materials.Water) do
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Water[i][1]) then
				if (((PlantCare.Materials.Water[i][2] > suggestedLevel) and (PlantCare.Materials.Water[i][3] == suggestedRarity)) or
					(PlantCare.Materials.Water[i][3] > suggestedRarity)) and
					(PlantCare.Materials.Water[i][2] <= plantlevel) and
					(PlantCare.Materials.Water[i][3] <= PlantCare_Settings.MaxLevelRarity) then
					suggestedLevel = PlantCare.Materials.Water[i][2]
					suggestedRarity = PlantCare.Materials.Water[i][3]
					WaterIndex = i
				end
			end
		end
	end
	return(WaterIndex)
end

function PlantCare:getBestFertilizerIndex()
	local plantlevel=PlantCare:GetPlantLevel()
	local n
	local suggestedLevel = 0
	local suggestedRarity = 0
	local FertilizerIndex = 0

	for n=1,10 do
		for i, v in ipairs(PlantCare.Materials.Fertilizer) do
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Fertilizer[i][1]) then
				if (((PlantCare.Materials.Fertilizer[i][2] > suggestedLevel) and (PlantCare.Materials.Fertilizer[i][3] == suggestedRarity)) or
					(PlantCare.Materials.Fertilizer[i][3] > suggestedRarity)) and
					(PlantCare.Materials.Fertilizer[i][2] <= plantlevel) and
					(PlantCare.Materials.Fertilizer[i][3] <= PlantCare_Settings.MaxLevelRarity) then
					suggestedLevel = PlantCare.Materials.Fertilizer[i][2]
					FertilizerIndex = i
				end
			end
		end
	end
	return(FertilizerIndex)
end

function PlantCare:UpdateMaterialCounts()
	local n
	local m

	for n=1,10 do
		for m = 1, table.maxn(PlantCare.Materials.Water) do
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Water[m][1]) then
				SetItemButtonStock(getglobal("StoreFrameItem"..n.."Button"),GetCountInBagByName(PlantCare.Materials.Water[m][1]))
			end
		end

		for m = 1, table.maxn(PlantCare.Materials.Fertilizer) do
			if (getglobal("StoreFrameItem"..n.."Name"):GetText() == PlantCare.Materials.Fertilizer[m][1]) then
				SetItemButtonStock(getglobal("StoreFrameItem"..n.."Button"),GetCountInBagByName(PlantCare.Materials.Fertilizer[m][1]))
			end
		end
	end
end

function PlantCare:UpdateMaterialHighlights()
	PlantCareFrame_PlantStoreModifications_Highlight_Water:Hide()
	PlantCareFrame_PlantStoreModifications_Highlight_Fertilizer:Hide()

	-- what's the best usable level on this page?
	local WaterIndex      = PlantCare:getBestWaterIndex()
	local FertilizerIndex = PlantCare:getBestFertilizerIndex()

	for n=1,10 do
		local itemname = getglobal("StoreFrameItem"..n.."Name"):GetText()
		
		if (WaterIndex > 0) then
			if (itemname == PlantCare.Materials.Water[WaterIndex][1]) then
				PlantCareFrame_PlantStoreModifications_Highlight_Water:ClearAllAnchors()
				PlantCareFrame_PlantStoreModifications_Highlight_Water:SetAnchor("CENTER", "CENTER", getglobal("StoreFrameItem"..n.."Button"), 0, 0)
				PlantCareFrame_PlantStoreModifications_Highlight_Water:Show()
			end
		end

		if (FertilizerIndex > 0) then
			if (itemname == PlantCare.Materials.Fertilizer[FertilizerIndex][1]) then
				PlantCareFrame_PlantStoreModifications_Highlight_Fertilizer:ClearAllAnchors()
				PlantCareFrame_PlantStoreModifications_Highlight_Fertilizer:SetAnchor("CENTER", "CENTER", getglobal("StoreFrameItem"..n.."Button"), 0, 0)
				PlantCareFrame_PlantStoreModifications_Highlight_Fertilizer:Show()
			end
		end
		
		getglobal("StoreFrameItem"..n.."ButtonStock"):SetColor(1,1,1)

		local seed,seedType = PlantCare.DB_FindSeedByName(itemname)
		if seed then
			SetItemButtonStock(getglobal("StoreFrameItem"..n.."Button"),seed[S_LEVEL])
			if seedType == "Herb" then
				getglobal("StoreFrameItem"..n.."ButtonStock"):SetColor(0,1,0)
			elseif seedType == "Ore" then
				getglobal("StoreFrameItem"..n.."ButtonStock"):SetColor(.77,.78,1)
			else
				getglobal("StoreFrameItem"..n.."ButtonStock"):SetColor(.92,.64,.13)
			end
		end
		
		for si,st in pairs(PlantCare.Pots.Herb) do
			if (itemname == TEXT('Sys'..st[1]..'_name')) then
				SetItemButtonStock(getglobal("StoreFrameItem"..n.."Button"),st[2])
				getglobal("StoreFrameItem"..n.."ButtonStock"):SetColor(0,1,0)
			end
		end
		for si,st in pairs(PlantCare.Pots.Ore) do
			if (itemname == TEXT('Sys'..st[1]..'_name')) then
				SetItemButtonStock(getglobal("StoreFrameItem"..n.."Button"),st[2])
				getglobal("StoreFrameItem"..n.."ButtonStock"):SetColor(.77,.78,1)
			end
		end
		for si,st in pairs(PlantCare.Pots.Wood) do
			if (itemname == TEXT('Sys'..st[1]..'_name')) then
				SetItemButtonStock(getglobal("StoreFrameItem"..n.."Button"),st[2])
				getglobal("StoreFrameItem"..n.."ButtonStock"):SetColor(.92,.64,.13)
			end
		end
		
	end
end

function PlantCare:DisplayMaxLevelMaterial()
	PlantCareFrame_PlantStoreModifications_MaxLevelMaterial_Text:SetText(tostring(PlantCare_Settings.MaxLevelMaterial))

	if (PlantCare_Settings.MaxLevelMaterial == 1) then
		PlantCareFrame_PlantStoreModifications_MaterialsMinus:Disable()
	else
		PlantCareFrame_PlantStoreModifications_MaterialsMinus:Enable()
	end

	if (PlantCare_Settings.MaxLevelMaterial == PlantCare.Materials.Levels[table.maxn(PlantCare.Materials.Levels)]) then
		PlantCareFrame_PlantStoreModifications_MaterialsPlus:Disable()
	else
		PlantCareFrame_PlantStoreModifications_MaterialsPlus:Enable()
	end
end

function PlantCare:DisplayMaxLevelRarity()
	local i
	if (PlantCare_Settings.MaxLevelRarity == 0) then
		PlantCareFrame_PlantStoreModifications_RarityMinus:Disable()
	else
		PlantCareFrame_PlantStoreModifications_RarityMinus:Enable()
	end

	if (PlantCare_Settings.MaxLevelRarity == 2) then
		PlantCareFrame_PlantStoreModifications_RarityPlus:Disable()
	else
		PlantCareFrame_PlantStoreModifications_RarityPlus:Enable()
	end

	for i=0,5 do
		local RarityTexture = getglobal("PlantCareFrame_PlantStoreModifications_Rarities_Rarity"..i)
		if i == PlantCare_Settings.MaxLevelRarity then
			RarityTexture:Show()
		else
			RarityTexture:Hide()
		end
	end
end

function PlantCare:ChangeMaxLevelMaterials(int)
	local i
	local v
	local newLevel

	for i, v in ipairs(PlantCare.Materials.Levels) do
		if PlantCare_Settings.MaxLevelMaterial == v then
			newLevel = PlantCare.Materials.Levels[i+int]
		end
	end

	PlantCare_Settings.MaxLevelMaterial = newLevel


	if (PlantCare_Settings.MaxLevelMaterial < 1) then
		PlantCare_Settings.MaxLevelMaterial = 1
	end

	if (PlantCare_Settings.MaxLevelMaterial > PlantCare.Materials.Levels[table.maxn(PlantCare.Materials.Levels)]) then
		PlantCare_Settings.MaxLevelMaterial = PlantCare.Materials.Levels[table.maxn(PlantCare.Materials.Levels)]
	end

	PlantCare:DisplayMaxLevelMaterial()
	PlantCare:UpdateMaterialHighlights()
end

function PlantCare:ChangeMaxLevelRarity(int)
	PlantCare_Settings.MaxLevelRarity = PlantCare_Settings.MaxLevelRarity + int


	if (PlantCare_Settings.MaxLevelRarity < 0) then
		PlantCare_Settings.MaxLevelRarity = 0
	end

	if (PlantCare_Settings.MaxLevelRarity > 2) then
		PlantCare_Settings.MaxLevelRarity = 2
	end

	PlantCare:DisplayMaxLevelRarity()
	PlantCare:UpdateMaterialHighlights()
end

function PlantCare:BuyMaterials(item)
	local WaterIndex      = PlantCare:getBestWaterIndex()
	local FertilizerIndex = PlantCare:getBestFertilizerIndex()
	local plantlevel=PlantCare:GetPlantLevel()

	local BuyWater = 0
	local BuyFert  = 0
	local bagitems, bagsize = GetBagCount()

	-- due to ch4-updates we have to fill up each stack separately
	for i=1,bagsize do
		local index, texture, name, itemCount, locked, invalid = GetBagItemInfo(i)

		if ((WaterIndex ~= 0) and (item == nil or item == "water") and (name == PlantCare.Materials.Water[WaterIndex][1]) and (BuyWater == 0)) then
			BuyWater = BuyWater + PlantCare.Materials.Water[WaterIndex][5] - itemCount
		end

		if ((FertilizerIndex ~= 0) and (item == nil or item == "fertilizer") and (name == PlantCare.Materials.Fertilizer[FertilizerIndex][1]) and (BuyFert == 0)) then
			BuyFert  = BuyFert  + PlantCare.Materials.Fertilizer[FertilizerIndex][5] - itemCount
		end
	end

	-- If all of our stacks are currently full, or we don't have any stacks
	-- then purchase a complete new stack of $stacksize
	if ((WaterIndex ~= 0) and (item == "water") and (BuyWater == 0)) then BuyWater = PlantCare.Materials.Water[WaterIndex][5]; end
	if ((FertilizerIndex ~= 0) and (item == "fertilizer") and (BuyFert  == 0)) then BuyFert  = PlantCare.Materials.Fertilizer[FertilizerIndex][5]; end

	local index=1
	while true do
		local icon, name, price, moneyType, count, stock = GetStoreSellItemInfo(index)

		if (name==nil) then break; end

		if (BuyWater > 0 and PlantCare.Materials.Water[WaterIndex][1]==name) then
			PlantCare.counterTimer = 2
			if (BuyWater < PlantCare.Materials.Water[WaterIndex][5]) and (BuyWater > 0) then
				PlantCareFrame_PlantStoreModifications_StoreWaterButton:Disable()
				PlantCare.shopWaterDisableTimer = 2
			end
			StoreBuyItem(index, BuyWater)
		end

		if (BuyFert > 0 and PlantCare.Materials.Fertilizer[FertilizerIndex][1]==name) then
			PlantCare.counterTimer = 2
			if (BuyFert < PlantCare.Materials.Fertilizer[FertilizerIndex][5]) and (BuyFert > 0) then
				PlantCareFrame_PlantStoreModifications_StoreFertilizerButton:Disable()
				PlantCare.shopFertilizerDisableTimer = 2
			end
			StoreBuyItem(index, BuyFert)
		end
				
		index=index+1
	end
end

function PlantCare_StoreBuyItem(index, number)
	if (number == nil) then number = 0; end
	if ((PlantCare_Settings.AutoBuySeed) and (number == 0)) then
		local itemLink = GetStoreSellItemLink(index)
		local _, itemData, itemName = ParseHyperlink(itemLink)
		local _, _, itemID = string.find(itemData, "^(%x+)")
		itemID = tonumber(itemID, 16)
		local seed = PlantCare.DB_FindSeedByID(itemID)
		if seed then 
					Sol.hooks.GetOriginalFn(PlantCare.name, "StoreBuyItem")(index, PlantCare_Settings.AutoBuySeedValue)
					return
				end
			end
	if (number == 0) then
		Sol.hooks.GetOriginalFn(PlantCare.name, "StoreBuyItem")(index)
	else
		Sol.hooks.GetOriginalFn(PlantCare.name, "StoreBuyItem")(index, number)
	end
end

function PlantCare.radio(frame)
	local id = frame:GetID()
	if (id ~= nil) then
		if (id == 1) then
			PlantCare_Settings.ExpertLongCare = 0
		elseif (id == 2) then
			PlantCare_Settings.ExpertLongCare = 1
		elseif (id == 3) then
			PlantCare_Settings.ExpertLongCare = 2
		elseif (id == 4) then
			PlantCare_Settings.ExpertLongCare = 3
		elseif (id == 5) then
			PlantCare_Settings.ExpertLongCare = 4
		elseif (id == 6) then
			PlantCare_Settings.ExpertLongCare = 5
		elseif (id == 7) then
			PlantCare_Settings.ExpertWaterHarvest = 0
		elseif (id == 8) then
			PlantCare_Settings.ExpertWaterHarvest = 1
		elseif (id == 9) then
			PlantCare_Settings.ExpertWaterHarvestLow = 0
		elseif (id == 10) then
			PlantCare_Settings.ExpertWaterHarvestLow = 1
		end
	end
	PlantCare.loadExpertSettings()
end

function PlantCare.loadExpertSettings()
	PlantCare_Properties_expert_longcare_auto:SetChecked(false)
	PlantCare_Properties_expert_longcare_opt_min:SetChecked(false)
	PlantCare_Properties_expert_longcare_opt_max:SetChecked(false)
	PlantCare_Properties_expert_longcare_min:SetChecked(false)
	PlantCare_Properties_expert_longcare_max:SetChecked(false)
	PlantCare_Properties_expert_longcare_feed:SetChecked(false)
	PlantCare_Properties_expert_harvestcare_auto:SetChecked(false)
	PlantCare_Properties_expert_harvestcare_feed:SetChecked(false)
	PlantCare_Properties_expert_harvestcare_low_auto:SetChecked(false)
	PlantCare_Properties_expert_harvestcare_low_feed:SetChecked(false)

	if (PlantCare_Settings.ExpertLongCare == 0) then
		PlantCare_Properties_expert_longcare_auto:SetChecked(true)
	elseif (PlantCare_Settings.ExpertLongCare == 1) then
		PlantCare_Properties_expert_longcare_opt_min:SetChecked(true)
	elseif (PlantCare_Settings.ExpertLongCare == 2) then
		PlantCare_Properties_expert_longcare_opt_max:SetChecked(true)
	elseif (PlantCare_Settings.ExpertLongCare == 3) then
		PlantCare_Properties_expert_longcare_min:SetChecked(true)
	elseif (PlantCare_Settings.ExpertLongCare == 4) then
		PlantCare_Properties_expert_longcare_max:SetChecked(true)
	elseif (PlantCare_Settings.ExpertLongCare == 5) then
		PlantCare_Properties_expert_longcare_feed:SetChecked(true)
	end	
	
	if (PlantCare_Settings.ExpertWaterHarvest == 0) then
		PlantCare_Properties_expert_harvestcare_auto:SetChecked(true)
	elseif (PlantCare_Settings.ExpertWaterHarvest == 1) then
		PlantCare_Properties_expert_harvestcare_feed:SetChecked(true)
	end
	
	if (PlantCare_Settings.ExpertWaterHarvestLow == 0) then
		PlantCare_Properties_expert_harvestcare_low_auto:SetChecked(true)
	elseif (PlantCare_Settings.ExpertWaterHarvestLow == 1) then
		PlantCare_Properties_expert_harvestcare_low_feed:SetChecked(true)
	end
end

function PlantCare.prepareToolTip(frame)
	PlantCare.tooltipframe = frame
	PlantCare.tooltipdelay = 1.3
end

function PlantCare.showToolTip()
	GameTooltip:SetOwner(PlantCare.tooltipframe, "ANCHOR_TOPLEFT")
	
	if (PlantCare.tooltipframe == PlantCare_Properties_standard_AutoCare) then
		GameTooltip:SetText(PlantCare.Strings.AutoCare,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.AutoCare)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_LongCare) then
		GameTooltip:SetText(PlantCare.Strings.GUI_longcare,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.Longcare)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_GetProduct) then
		GameTooltip:SetText(PlantCare.Strings.GetProduct,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.GetProduct)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_autoSeed) then
		GameTooltip:SetText(PlantCare.Strings.AutoSeed,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.AutoSeed)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_autoBuySeed) then
		GameTooltip:SetText(PlantCare.Strings.AutoBuySeed,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.AutoBuySeed)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_autoBuySeed_Value) then
		GameTooltip:SetText(PlantCare.Strings.AutoBuySeed,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.AutoBuySeed)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_waterBeforeHarvest) then
		GameTooltip:SetText(PlantCare.Strings.WaterBeforeHarvest,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.WaterBeforeHarvest)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_compensate) then
		GameTooltip:SetText(PlantCare.Strings.Compensate,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.Compensate)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_AlertWater) then
		GameTooltip:SetText(PlantCare.Strings.AlertWaterUnder,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.AlertWater)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_Percent) then
		GameTooltip:SetText(PlantCare.Strings.AlertWaterUnder,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.AlertWater)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_waterSound) then
		GameTooltip:SetText(PlantCare.Strings.WaterSound,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.WaterSound .." ".. PlantCare.Strings.Tooltips.CounterHelp)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_standard_countPlants) then
		GameTooltip:SetText(PlantCare.Strings.CountPlants,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.CountPlants .." ".. PlantCare.Strings.Tooltips.CounterHelp)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_longcare_auto) then
		GameTooltip:SetText(PlantCare.Strings.automatic,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.automatic)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_longcare_opt_min) then
		GameTooltip:SetText(PlantCare.Strings.ExpertWaterOptMin,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.ExpertWaterOptMin)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_longcare_opt_max) then
		GameTooltip:SetText(PlantCare.Strings.ExpertWaterOptMax,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.ExpertWaterOptMax)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_longcare_min) then
		GameTooltip:SetText(PlantCare.Strings.ExpertWaterMin,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.ExpertWaterMin)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_longcare_max) then
		GameTooltip:SetText(PlantCare.Strings.ExpertWaterMax,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.ExpertWaterMax)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_longcare_feed) then
		GameTooltip:SetText(PlantCare.Strings.ExpertFeed,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.ExpertFeed)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_longcare_Percent) then
		GameTooltip:SetText(PlantCare.Strings.GUI_longcare,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.LongCarePercent)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_harvestcare_auto) then
		GameTooltip:SetText(PlantCare.Strings.automatic,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.automatic)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_harvestcare_feed) then
		GameTooltip:SetText(PlantCare.Strings.ExpertFeed,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.ExpertFeed)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_harvestcare_Percent) then
		GameTooltip:SetText(PlantCare.Strings.HarvestCare,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.HarvestCarePercent)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_harvestcare_low_auto) then
		GameTooltip:SetText(PlantCare.Strings.automatic,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.automatic)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_harvestcare_low_feed) then
		GameTooltip:SetText(PlantCare.Strings.ExpertFeed,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.ExpertFeed)
	elseif (PlantCare.tooltipframe == PlantCare_Properties_expert_harvestcare_low_Percent) then
		GameTooltip:SetText(PlantCare.Strings.HarvestCareLow,1,1,0)
		GameTooltip:AddLine(PlantCare.Strings.Tooltips.HarvestCareLowPercent)
	end
	
	GameTooltip:AddLine("PlantCare "..PlantCare.Version,0,1,0)
end

function PlantCare.hideToolTip()
	PlantCare.tooltipdelay = 0
	GameTooltip:Hide()
end

function PlantCare.log(message)
	local n
	for n=1,10 do
		if getglobal("ChatFrame"..n):IsVisible() then
			getglobal("ChatFrame"..n):AddMessage("[|cff00ff00".."PlantCare|r] "..message)
		end
	end
end
