yGather.i18n = {};

function yGather.translate(key)
    return yGather.i18n.translate(key);
end

-- make globals available
local GetLanguage = GetLanguage;
local logger = yGather.logger;
local dofile = dofile;
local pcall = pcall;

setfenv(1, yGather.i18n);

local mDefaultLanguage = nil;
local mLocalLanguage = nil;

function loadLocale(language)
    -- load default language
    mDefaultLanguage = dofile("Interface/AddOns/yGather/lang/lang.ENEU.lua");
    
    -- try to load locale
    local localLoaded, errorOrResult = pcall(dofile, "Interface/AddOns/yGather/lang/lang." .. language .. ".lua");
    if (localLoaded) then
        mLocalLanguage = errorOrResult;
    else
        mLocalLanguage = nil;
        logger.warn("error loading language pack: language=" .. language .. " error: " .. errorOrResult);
    end
end

loadLocale(GetLanguage());

function translate(key)
    if (mLocalLanguage) then
        local translated = mLocalLanguage[key];
        if (translated) then
            return translated;
        end
    end
    local translated = mDefaultLanguage[key];
    if (translated) then
        return translated;
    end
    return key;
end
