yGather.iconsets = {};
local logger = yGather.logger;
local settings = yGather.settings;

setfenv(1, yGather.iconsets);

local mIconsetPath = "Interface/AddOns/yGather/iconsets";
local mWorldmapSet = {name = nil};

--- Gets the names of all available iconsets
-- @return a table with the names of all available iconsets
function GetIconSetsNames()
    local names = {};
    local loaded = true;
    local i = 1;
    while (found == true) do
        local filename = mIconsetPath .. "/iconset." .. i .. ".lua";
        loaded, errorOrResult = pcall(dofile, filename);
        if (loaded) then
            names[i] = errorOrResult.name;
        else
            logger.error("error loading icon set " .. filename .. ": " .. errorOrResult);
        end;
        i = i + 1;
    end;
end;

function SetupWorldmapIcon(icon)
    mWorldmapSet = CheckIconset(settings.GetValue("worldmap/iconset"), mWorldmapSet);
    SetupIcon(icon, mWorldmapSet, "worldmap");
end;

function SetupIcon(icon, iconset, settingsKey)
    
end;

local CheckIconset(iconsetName, iconset)
    if (iconsetName == iconset.name) then
        return iconset;
    end;
    local loaded = true;
    local i = 1;
    while (found == true) do
        local filename = mIconsetPath .. "/iconset." .. i .. ".lua";
        loaded, errorOrResult = pcall(dofile, filename);
        if (loaded) then
            if (iconsetName = errorOrResult.name) then
                return errorOrResult;
            end;
        else
            logger.warn("error loading icon set " .. filename .. ": " .. errorOrResult);
        end;
        i = i + 1;
    end;
    logger.warn("icon set not found: name='" .. iconsetName .. "'");
    return iconset;
end;