-- item_her_001.dds HERBLISM
-- item_lum_001.dds LUMBERING
-- item_ore_001.dds MINING
yGather_ZONE = 0;
yGather_WZONE = 0;
yGather_SX = 1;
yGather_SY = 1;

function yGather.round(n, p)
    if (n == nil) then
        return;
    end
    
    if (p == nil) then
        p = 0;
    end;
    
    local shift = math.pow(10, p);
    return math.floor(n * shift + 0.5) / shift;
end

function yGather_isInList(id,zone,x,y)
    if (zone == nil) then
        error("zone must not be nil", 2);
    end
    if (id == nil) then
        error("id must not be nil", 2);
    end
    yGather.logger.trace("inlist:"..id.."/"..zone.."/"..x..","..y);
    local xl,xh,yl,yh = x-2,x+2,y-2,y+2;
    local data = yGather.database:GetZoneResourceData(zone, id);
    if (data ~= nil) then
        for i, location in pairs(data) do
            if ((location.x > xl) and (location.x < xh) and
                    (location.y > yl) and (location.y < yh)) then
                return i;
            end -- if
        end -- for
    end
    return 0;
end

function yGather_MatInMinimapList(id,mx,my)
    local xl,xh,yl,yh = mx-2,mx+2,my-2,my+2;
    local matinlist=0;
    for i=1,yGather_mini_cnt do
        if (yGather_mini[i].wx>xl and yGather_mini[i].wx<xh and
                yGather_mini[i].wy>yl and yGather_mini[i].wy<yh) then
            matinlist=1;
            break;
        end --if
    end
    return matinlist
end

function yGather_FilterPass(matid)
    local level = yGather.resourceData:GetSkillLevel(matid);
    local skill = yGather.resourceData:GetResourceSkill(matid);
    local name = yGather.resourceData:GetResourceName(matid);
    if (level == nil) then return false end;
    if (not yGatherV.options[name]) then return false end;
    if (not yGatherV.options[skill]) then return false end;
    if (not yGatherV.options["L10"] and level>0 and level<11) then return false end;
    if (not yGatherV.options["L20"] and level>10 and level<21) then return false end;
    if (not yGatherV.options["L30"] and level>20 and level<31) then return false end;
    if (not yGatherV.options["L40"] and level>30 and level<41) then return false end;
    if (not yGatherV.options["L50"] and level>40 and level<51) then return false end;
    if (not yGatherV.options["L999"] and level>50) then return false end
    return true;
end

function yGather_AddGathered(px, py, maxDistance)
    local zone=GetCurrentWorldMapID();

    local zoneData = yGather.database:GetZoneData(zone);
    if (zoneData == nil) then
        return;
    end

    for id, locations in pairs(zoneData) do
        if (yGather_FilterPass(id)) then
            local maxid = table.maxn(zoneData[id]);
            for idx, location in pairs(locations) do
                local mx,my = location.x, location.y;
                local tx,ty =mx-px, my-py;
                local matdist=tx*tx+ty*ty;
                if (matdist<maxDistance and yGather_MatInMinimapList(id,mx,my)==0) then --we should show this one
                    local miniico={};
                    miniico.zone=zone;
                     miniico.id = id;
                    miniico.idx=idx;
                    miniico.wx = mx;
                    miniico.wy = my;
                    miniico.skill = yGather.resourceData:GetResourceSkill(id);
                    miniico.alive = 0;
                    miniico.tex = yGather.resourceData:GetResourceTexture(id) ..".dds";
                    miniico.name = yGather.resourceData:GetResourceName(id);
                    yGather_mini_cnt = yGather_mini_cnt +1;
                    yGather_mini[yGather_mini_cnt] = miniico;
                end --if visibility check
            end --for matrecs
        end -- filterpass
    end
end

function yGather_minimap_GetColorForSkill(skill, matId)
    if (skill == "LUMBERING") then 
        return yGather.settings.GetValue("minimap/iconWoodColor");
    elseif (skill == "MINING") then
        return yGather.settings.GetValue("minimap/iconOreColor");
    elseif (skill == "HERBLISM") then
        return yGather.settings.GetValue("minimap/iconHerbsColor");
    else
        return yGather.resourceData:GetResourceColor(matId);
    end
end

function yGather_SetIcon(icon, text, x,y, w,h,sizescale, zoneid,matid,idx, skill, textureFile)
    local showColoredDots = yGather.settings.GetValue("minimap/iconMode") == "coloredDots";
    local transparency = yGather.settings.GetValue("minimap/iconTransparency");
    local icontex=getglobal(icon:GetName().."tex");
    icon.name=text;

    icon.zoneid=zoneid;
    icon.matid=matid;
    icon.idx=idx;
    local iconWidth, iconHeight = icon:GetSize();
    icon:SetPos(x - iconWidth / 2, y - iconHeight / 2);

    local icondata=yGather_DBID[matid];
    if (icondata[3] == "PLAYER") then
        icontex:SetTexture("interface\\minimap\\minimapicon.tga");
        icontex:SetTexCoord(icondata[5] / 60.2, (icondata[5] + 1) / 60.2, 0, 1);
        icontex:SetColor(icondata[6], icondata[7], icondata[8], 1.0);
        icontex:SetAlpha(1 - transparency);
    elseif (showColoredDots) then
        local color = yGather_minimap_GetColorForSkill(skill, matId);
        icontex:SetTexture("interface\\minimap\\minimapicon.tga");
        icontex:SetTexCoord(icondata[5]/60.2,(icondata[5]+1)/60.2,0,1);
        icontex:SetColor(color[1], color[2], color[3], 1.0);
        icontex:SetSize(w*sizescale*1.4,h*sizescale*1.4);
        icontex:SetAlpha(1 - transparency);
    else
        icontex:SetTexture(textureFile);
        icontex:SetTexCoord(0,1,0,1);
        icontex:SetColor(1.0,1.0,1.0,1.0);
        icontex:SetSize(w*sizescale,h*sizescale);
        icontex:SetAlpha(1 - transparency);
    end
end

function yGather_UpdateMinimapIcons()
    for i=1,yGather_MAXICONS do
        getglobal("yGatherMiniL1I"..i):Hide();
    end --fori

    if (not yGather.settings.GetValue("minimap/showResources")) then
        return;
    end
    
    local cx,cy = MinimapViewFrame:GetCenter();
    local tx,ty = MinimapViewFrame:GetSize();
    local px,py = GetPlayerWorldMapPos();
    local rscale = MinimapViewFrame:GetRealScale();
    local minimapZoom = yGather.minimapZoom;
    local wrangex=(tx/2)/rscale/minimapZoom/yGather_SX*500;
    local wrangey=(ty/2)/rscale/minimapZoom/yGather_SY*500;
    yGather_AddGathered(px*1000,py*1000,wrangex*wrangex+wrangey*wrangey);
    for i=1,yGather_MAXICONS do
        local icon=getglobal("yGatherMiniL1I"..i);
        local icontex=getglobal("yGatherMiniL1I"..i.."tex");
        if (i>yGather_mini_cnt) then
            icon:Hide();
        else
            local icondata=yGather_mini[i];
            if (icondata.alive==0) then
                local sx,sy = icondata.wx, icondata.wy;
                yGather.logger.debug("showing on minimap: " .. icondata.name .. " world: " .. sx .. "," .. sy);
                sx=(sx/1000-px)*yGather_SX*minimapZoom*rscale+cx;  sy=(sy/1000-py)*yGather_SY*minimapZoom*rscale+cy;
                yGather.logger.debug("setting minimap icon at (" .. sx .. "," .. sy .. ") name=" .. icondata.name);

                local skill = yGather.resourceData:GetResourceSkill(icondata.id);
                yGather_SetIcon(icon, icondata.name, sx,sy, 8,8,rscale,  icondata.zone,icondata.id,icondata.idx,
                        skill, "Interface\\Icons\\"..icondata.tex);
                icon:Show();
            else
                icon:Hide();
            end
        end
    end
end

function yGather_CheckMinimap()
    if (not yGather_DB) then
--        yGather.logger.error("yGather resource database not initialized");
        return;
    end
    
    local px,py = GetPlayerWorldMapPos();
    local rscale = MinimapViewFrame:GetRealScale();
    local minimapZoom = yGather.minimapZoom;
    local zone = GetCurrentWorldMapID();
    yGather_ZONE=zone;
    yGather_mini = {};
    yGather_mini_cnt = 0;
    if (yGather_Zones[yGather_ZONE] ~=nil) then
        yGather_SX=yGather_Zones[yGather_ZONE][1];
        yGather_SY=yGather_Zones[yGather_ZONE][2];
    else
        yGather.logger.warn("no scaling data for this zone: " .. yGather_ZONE);
        return;
    end
    
    local added=0;
    for i=1,20 do
        local icon=getglobal("MinimapFrame_Icon"..i);
        local txt=GetMinimapIconText(icon:GetID());
        yGather.logger.trace("MinimapFrame_Icon" .. i .. ": text='" .. txt .. "' id=" .. icon:GetID());

        -- if icon is a resource we know add it to the data
        if (icon:IsVisible() and yGather_DB[txt]) then
            local id, level, skill = yGather_DB[txt][1], yGather_DB[txt][2], yGather_DB[txt][3];
            yGather.logger.trace("DB: id=" .. id .. " level=" .. level .. " skill=" ..skill);
            local x,y = icon:GetCenter();
            local xx,yy = MinimapViewFrame:GetCenter();
            x = (x-xx)/rscale/minimapZoom;
            y = (y-yy)/rscale/minimapZoom;

-- computing realworld position
            local mx, my = yGather.round((px+x/yGather_SX)*1000, 2), yGather.round((py+y/yGather_SY)*1000, 2);
            local miniico={};
            miniico.zone=zone;
            miniico.id = id;
            miniico.wx = mx;
            miniico.wy = my;
            miniico.skill = skill;
            miniico.alive = 1;
            miniico.name = txt;
            yGather_mini_cnt = yGather_mini_cnt +1;
            yGather_mini[yGather_mini_cnt] = miniico;
            local existing = yGather_isInList(id, zone, mx, my);
            if (existing==0) then
                local idx = yGather.database:AddStackLocation(id,zone,mx,my);
                miniico.idx=idx;
                added = added+1;
            else
                miniico.idx=existing;
            end
            yGather.logger.trace(level .. " " .. skill .. " " .. txt .. " z:" .. zone .. " (" .. mx .. "," .. my .. ") inlist: "..existing);
        end
    end
end

function yGather_OnLoad(this)
    this:RegisterEvent("VARIABLES_LOADED");
end

function yGather.registerWithAddonManager()
    local addon = {
        name = "yGather",
        version = yGather.getVersion(),
        author = "adisadicul, skite2001, C3Y",
        description = yGather.translate("ADDON_MANAGER_DESCRIPTION"),
        icon = "Interface/Addons/WoWMap/highlights/map",
        category = "Economy",
        configFrame = yGather.config.configDialog, 
        slashCommand = nil,
        miniButton = nil,
    }
    if AddonManager.RegisterAddonTable then
        AddonManager.RegisterAddonTable(addon)
    else
        AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, 
            addon.configFrame, addon.slashCommand, addon.miniButton, addon.version, addon.author);
    end
end

function yGather_OnEvent(this,event,arg1,arg2)
    if (event == "VARIABLES_LOADED") then
        yGather.settings.HandleVariablesLoaded();
        yGather.database:HandleVariablesLoaded();
        yGatherV.Status=1;
        SaveVariables("yGatherV");
        yGatherV.Version = yGather.getVersion();
        yGather_varloaded = true;

        if AddonManager then
            yGather.registerWithAddonManager();
        else
            yGather.logger.user("|cffFFFF00" .. yGather.translate("USER_MESSAGE_ADDON_LOADED") .. ": |cff00FF00yGather " .. yGather.getVersion());
        end
    elseif (event == "SAVE_VARIABLES") then
        yGather.settings.HandleSaveVariables();
        yGather.database:HandleSaveVariables();
    end
end

function yGather_OnUpdate(this)
    if (yGather_varloaded==true) then
        local rec=0;
        if (yGatherV.Status==1 and MinimapFrame:IsVisible()) then
            local px,py = GetPlayerWorldMapPos();
            if (yGatherV.lastpx and yGatherV.lastpy and px and py) then
                if (math.abs(yGatherV.lastpx-px)>0.000001 or math.abs(yGatherV.lastpy-py)>0.000001) then -- work only if player position is changed a bit
                    rec=1;
                    yGather_CheckMinimap();
                    yGather_UpdateMinimapIcons();
                end --if
            else
                yGatherV.lastpx=px; yGatherV.lastpy=py;
            end -- if
            if (rec==1) then
                yGatherV.lastpx=px; yGatherV.lastpy=py;
            end
        end -- var loaded
    end -- if

end

local old_SetWorldMapID = WorldMapFrame_SetWorldMapID;

function WorldMapFrame_SetWorldMapID(zoneid)
    yGather_WZONE=zoneid;
    old_SetWorldMapID(zoneid);
    yGather.worldmap:UpdateIcons();
end

yGatherV.Status=2;
