yGather_MAXICONS = 20;
yGather.minimapZoom = 1;
yGather_varloaded = false;

yGatherV = {
    mini = {},
    world = {},
    options = {}
};

yGather_mini = {
};
yGather_mini_cnt=0;
yGather_DB = {};
yGather_DBID = {};
yGatherV.Status=0;
yGather_maxid = 67;

yGatherV.Directory = "Interface/AddOns/yGather/";

function yGather.getVersion()
    local headURL = "$HeadURL: file:///F:/LokalSVNRepositories/yGather/tags/v0.46/yGatherLib.lua $";
    local patternStart, patternEnd, version = string.find(headURL, "/tags/([^/]+)/yGatherLib.lua");
    if (version ~= nil) then
        return version;
    end
    
    patternStart, patternEnd, version = string.find(headURL, "/(branches/[^/]+)/yGatherLib.lua");
    if (version ~= nil) then
        return version;
    end
    
    patternStart, patternEnd, version = string.find(headURL, "/(trunk)/yGatherLib.lua");
    if (version ~= nil) then
        return "trunk";
    end
    
    return "unknown version";
end

-- minimap-to-zone ratios
-- i.e. (pseudocode) silverspring.dx * yGather_Zones[2][1] = minimap.dx
yGather_Zones = {
    [1]={858,644,"Howling Mountains"},
    [2]={1256,942,"Silverspring"},
    [3]={1550,1163,"Ravenfell"},
    [4]={1228,921,"Aslan Valley"},
    [5]={1532,1149,"Ystra Highlands"},
    [6]={1830,1373,"Dust Devil Canyon"},
    [7]={1504,1128, "Weeping Coast"},
    [8]={1755,1316, "Savage Lands"},
    [9]={1875,1406, "Aotulia Vulcano"},
    [10]={1923,1442,"Sascilia Steppes"},
    [11]={1600,1200,"Dragonfang Ridge"},
    [12]={803,602,"Elven Island"},
    [10001]={539,404,"Obsidian Stronghold City"},
}

--- Intercept RoM function SetMiniMapZoomValue() to track minimap zoom
local yGather_oldSetMiniMapZoomValue = SetMiniMapZoomValue;
SetMiniMapZoomValue = function(zoom)
    yGather_oldSetMiniMapZoomValue(zoom);
    yGather.minimapZoom = zoom;
    yGather.logger.debug("set mini zoom: " .. zoom);
end

function yGather_loadDB()
    local language = GetLanguage();

    -- try to load resource info for current client language
    local localLoaded, errorOrResult = pcall(dofile, "Interface/AddOns/yGather/lang/db.idmats." .. language .. ".lua");

    if (localLoaded) then
        yGather_DBID = errorOrResult;
    else
        yGather.logger.error("error loading resource information: language=" .. language .. " error: " .. errorOrResult);
        yGather.logger.error("loading default resource information, but yGather may not operate as expected");
        yGather_DBID = dofile("Interface/AddOns/yGather/lang/db.idmats.ENEU.lua");
    end
end

yGatherV.Language = GetLanguage();
if (yGatherV.Language ~= "DE") then
    yGatherV.Language = "ENEU"
end;

yGather_loadDB();
-- reverse id/name to lookup after name
for id, data in pairs(yGather_DBID) do
    yGather_DB[data[1]] = {id, data[2], data[3], data[4], data[5], data[6], data[7], data[8]};
    yGatherV.options[data[1]] = true;
end

--yGather_DB = loadDB(yGatherV.Directory .. "yGather.db.mats." .. yGatherV.Language .. ".lua");
if (yGather_DBID==false) then
    yGatherV.Status=90
end; --data loading error
-- old player position
yGatherV.lastpx=0.1;
yGatherV.lastpy=0.1;

function yGather_SetFilterAll(boolvalue)
    yGatherV.options["MINING"]=boolvalue;
    yGatherV.options["LUMBERING"]=boolvalue;
    yGatherV.options["HERBLISM"]=boolvalue;
    yGatherV.options["PLAYER"]=boolvalue;
    yGatherV.options["L10"]=boolvalue;
    yGatherV.options["L20"]=boolvalue;
    yGatherV.options["L30"]=boolvalue;
    yGatherV.options["L40"]=boolvalue;
    yGatherV.options["L50"]=boolvalue;
    yGatherV.options["L999"]=boolvalue;
    for id, data in pairs(yGather_DBID) do
        yGatherV.options[data[1]] = boolvalue;
    end
end

yGatherV.options["SHOWDOTS"]=true;
yGather_SetFilterAll(true);