-- coding: utf-8

-- Description:
-- typ:  1=collect,2=kill,3=not daily but repeatable,4=gather,5=rest,6=epic; +10=1perday; +20=untested
-- lvl:  quest level
-- rlvl: minimum level to get quest
-- zone: zone-id (see wow-map for example..or GetCurrentWorldMapID() )
-- items: list of [item_id]=required_count
-- giver: list of npc-id's (or single number) where to get the quest
-- taker: npc-id of quest-taker (only required if not equal first giver)
-- rew: reward in {xp,gold,token}
-- mobs: for Kill-Quest  -> list of [mob_id]=mob_count
--       for other Quests-> list of [mob_id]=item_id (item_id is only required if there are multiple items in this quests)
-- preq: required prequisit quest (single number or table)
--
-- please send any suggestions/corrections to: viertelvor12@gmx.net


DailyNotes.DB_Quests ={
--[[ [ Howling Mountains / Heulende Berge ]]
[420466]={typ= 1, lvl= 3, rlvl= 1, zone= 1, items={[201168]= 10}, giver=110583, taker=110482, rew={57,59,10}, mobs={[100052]=0}},       -- Need More Fungus Stems  // Die anhaltende Ausrottung der Fungi
[420467]={typ= 1, lvl= 4, rlvl= 2, zone= 1, items={[201169]= 10}, giver=110583, taker=110482, rew={79,94,10}, mobs={[100054]=0}},       -- Control the Wolf Population // Verringerung des Jungwolf-Nachwuchses
[420457]={typ= 1, lvl= 7, rlvl= 5, zone= 1, items={[201173]= 10}, giver=110583, taker=110482, rew={132,192,10}, mobs={[100458]=0}},     -- Reduce the Cave Crab Population / Reduzierung der Rotscheren-Höhlenkrebspopulation
[420435]={typ= 2, lvl= 7, rlvl= 5, zone= 1, mobs= {[100146]= 20}, giver=110584, taker=110078, rew={132,192,10}},                        -- Annoying Beetles // Lästige Käfer
[420417]={typ= 1, lvl= 7, rlvl= 5, zone= 1, items={[200616]=  5}, giver=110584, taker=110051, rew={132,192,10}, mobs={[100118]=0}},     -- Spider Venom // Spinnengift
[420419]={typ= 2, lvl= 8, rlvl= 6, zone= 1, mobs= {[100156]= 20}, giver=110584, taker=110078, rew={171,222,10}},                        -- Drive Off the Bats // Vertreibt die Fledermäuse
[420420]={typ= 2, lvl= 9, rlvl= 7, zone= 1, mobs= {[100203]= 20}, giver=110584, taker=110078, rew={212,250,10}},                        -- The Kobold Rampage // Raserei der Kobolde
[420129]={typ= 1, lvl=10, rlvl= 8, zone= 1, items={[200609]=  5}, giver=110584, taker=110497, rew={292,302,10}, mobs={[100063]=0,[100056]=0}}, -- Sharp Bear Claw // Scharfe Bärenklauen
[420112]={typ= 1, lvl=10, rlvl= 8, zone= 1, items={[200624]=  5}, giver=110584, taker=110052, rew={292,302,10}, mobs={[100061]=0}},     -- Collect Boar Tusks // Keiler-Hauer sammeln
[420111]={typ= 2, lvl=10, rlvl= 8, zone= 1, mobs= {[100055]= 20}, giver=110584, taker=110078, rew={292,302,10}},                        -- Starving Wolves // Die hungrigen Wölfe
[420059]={typ= 1, lvl=10, rlvl= 7, zone= 1, items={[200619]= 10}, giver=110584, taker=110078, rew={292,302,10}, mobs={[100203]=0,[100152]=0,[100153]=0,[100053]=0}},     -- Stolen Tools // Die gestohlenen Werkzeuge
[421449]={typ= 2, lvl=10, rlvl= 7, zone= 1, items={[200211]=  1}, giver=110584, taker=110491, rew={585,604,10}, mobs={[100906]=1}},     -- Wanted: Lost Soul of Tifka // Gesucht: Verlorene Seele von Tifka
[421448]={typ= 2, lvl=10, rlvl= 7, zone= 1, items={[200203]=  1}, giver=110584, taker=110060, rew={585,604,10}, mobs={[100904]=1}},     -- Wanted: Pirlanok Servant // Gesucht: Pirlanok-Diener
[421347]={typ= 2, lvl=10, rlvl= 7, zone= 1, items={[200188]=  1}, giver=110584, taker=110078, rew={585,604,10}, mobs={[100905]=1}},     -- Wanted: That Greedy Guy Caldor // Gesucht: Gefrässiger Kalod
-- [420839]={typ= 3, lvl= 1, rlvl= 1, zone= 1, items={[200230]= 20}, giver={111015}, taker=111015, rew={75,100,0}},       -- Trading Zinc Ore // Handel mit Zinkerz
-- [420840]={typ= 3, lvl= 1, rlvl= 1, zone= 1, items={[200293]= 20}, giver={111015}, taker=111015, rew={75,100,0}},       -- Trading Ash // Handel mit Eschenholz
-- [420841]={typ= 3, lvl= 1, rlvl= 1, zone= 1, items={[200335]= 20}, giver={111015}, taker=111015, rew={75,100,0}},       -- Trading Mountain Demon Grass // Handel mit Bergteufelgras
-- [420842]={typ= 3, lvl= 1, rlvl= 1, zone= 1, items={[210294]=100}, giver={111016}, taker=111016, rew={7,5,0}},          -- Trading Rocks // Handel mit Steinen
-- [420843]={typ= 3, lvl= 1, rlvl= 1, zone= 1, items={[210304]=100}, giver={111016}, taker=111016, rew={7,5,0}},          -- Trading Wooden Arrows // Handel mit Holzpfeilen
--[[ ] ]]

--[[ [ Silverspring / Silberquell ]]
[420233]={typ= 1, lvl=10, rlvl= 8, zone= 2, items={[201109]= 10}, giver={110969,110585}, taker=110022, rew={292,302,10}, mobs={[100132]=0,[100280]=0}}, -- Beetle Legs // Käferbeine
[420234]={typ= 1, lvl=10, rlvl= 8, zone= 2, items={[201110]=  8}, giver={110969,110585}, taker=110020, rew={292,302,10}, mobs={[100294]=0,[100819]=0}}, -- Shabby Shoes // Abgetragene Schuhe
[420229]={typ= 1, lvl=11, rlvl= 9, zone= 2, items={[201108]= 10}, giver={110969,110585}, taker=110611, rew={378,384,10}, mobs={[100212]=0,[100397]=0}}, -- Stable Request // Anfrage aus den Ställen
[420264]={typ= 1, lvl=12, rlvl=10, zone= 2, items={[201111]= 10}, giver={110969,110585}, taker=110210, rew={442,422,10}, mobs={[100082]=0,[100083]=0}}, -- Disease Cure // Heilung der Krankheit
[420612]={typ= 1, lvl=17, rlvl=14, zone= 2, items={[200406]=  9}, giver={110969,110585}, taker=110067, rew={800,662,10}, mobs={[100297]=0}},            -- Bat Saliva // Fledermausspeichel
[420290]={typ= 1, lvl=18, rlvl=16, zone= 2, items={[201113]= 12}, giver={110969,110585}, taker=110021, rew={942,762,10}, mobs={[100195]=0,[100210]=0}}, -- Bird Feather Jewelry // Vogelfederschmuck
[420218]={typ= 1, lvl=19, rlvl=17, zone= 2, items={[200670]= 10}, giver={110969,110585}, taker=110173, rew={1101,858,10},mobs={[100195]=0,[100210]=0}}, -- Chef's Worries // Sorgen des Kochs
[420284]={typ= 1, lvl=19, rlvl=17, zone= 2, items={[201112]= 10}, giver={110969,110585}, taker=110021, rew={1101,858,10},mobs={[100064]=0,[100065]=0}}, -- An Ancient Inheritance // Ein uraltes Erbe
[422958]={typ=15, lvl=23, rlvl=21, zone=10000,giver=114087, taker=113689, rew={880,549,0}}, -- Proceed to the Scar of Despair Camp // Begebt Euch ins Lager bei der Narbe der Verzweiflung.
-- [422627]={typ=23, lvl=52, rlvl=52, zone=, items={[205718]= 27}, giver={113354}, taker=113354, rew={0,0,0}}, -- Exploring the Nature of Nightmares // Das Wesen der Albträume erkunden
-- [422752]={typ=23, lvl=52, rlvl=52, zone=, items={[205860]=100}, giver={113354}, taker=113354, rew={0,0,0}}, -- Exploring the Nature of Nightmares // Das Wesen der Albträume erkunden
--[[ ] ]]

--[[ [ Sascilia Steppes / Sascilia-Steppe ]]
[420562]={typ= 2, lvl= 1, rlvl= 1, zone=10, mobs= {[100804]= 10}, giver=111382, taker=111034, rew={18,25,10}},                      -- Peace in the Camp // Frieden im Lager
[420563]={typ= 1, lvl= 3, rlvl= 1, zone=10, items={[202969]= 12}, giver=111382, taker=111045, rew={57,59,10},   mobs={[100750]=0}}, -- Bargain Purchase //Ein günstiges Angebot
[420564]={typ= 1, lvl= 5, rlvl= 3, zone=10, items={[202970]= 10}, giver=111382, taker=111082, rew={93,130,10},  mobs={[100740]=0}}, -- The Business of Poisonn // Giftgeschäfte
[420566]={typ= 1, lvl= 7, rlvl= 5, zone=10, items={[202971]=  8}, giver=111383, taker=111384, rew={132,192,10}, mobs={[100741]=0}}, -- Preservation Act // Konservierungsmethode
[420565]={typ= 2, lvl= 7, rlvl= 5, zone=10, mobs= {[100752]= 10}, giver=111383, taker=111082, rew={132,192,10}},                    -- Increase Production Volume // Ertragssteigerung
[420569]={typ= 2, lvl= 9, rlvl= 7, zone=10, mobs= {[100755]= 10}, giver=111088, rew={212,250,10}, preq=421102},                     -- Savage Revenge // Zeigt keine Gnade
[420567]={typ= 2, lvl= 9, rlvl= 7, zone=10, mobs= {[100820]= 10}, giver=111587, rew={212,250,10}},                                  -- Crawlers // Kriecher
[420568]={typ= 2, lvl= 9, rlvl= 7, zone=10, mobs= {[100771]= 10}, giver=111587, rew={212,250,10}},                                  -- Flyers // Flieger
[420085]={typ= 4, lvl=10, rlvl= 9, zone=10, items={[202974]= 15}, giver=111385, taker=111056, rew={292,302,10}},                    -- Ancient Stone Tablet // Alte Steine
[420570]={typ= 1, lvl=16, rlvl=13, zone=10, items={[202975]= 10}, giver=111386, taker=111022, rew={732,585,10}, mobs={[100747]=0}}, -- Refreshing the Mind // Erfrischung für den Geist
[420571]={typ= 1, lvl=16, rlvl=13, zone=10, items={[202976]= 10}, giver=111386, taker=111022, rew={732,585,10}, mobs={[100766]=0,[100768]=0}},     -- Ancient Energy Cores // Antike Energiekerne
[420572]={typ= 1, lvl=17, rlvl=15, zone=10, items={[202977]= 10}, giver=111387, taker=111388, rew={800,662,10}, mobs={[100753]=0}}, -- Beautify Art // Farbe für das Kunstwerk
[420573]={typ= 1, lvl=16, rlvl=14, zone=10, items={[202978]= 10}, giver=111387, taker=111388, rew={732,585,10}, mobs={[100004]=0}}, -- Art Materials // Kunstmaterialien
[420574]={typ= 1, lvl=18, rlvl=16, zone=10, items={[202979]= 10}, giver=111387, taker=111388, rew={942,762,10}, mobs={[100775]=0}}, -- Artistic Decoration // Künstlerische Dekoration
[422959]={typ= 3, lvl=23, rlvl=21, zone=10, items={[206422]=  5}, giver=113689, rew={2641,1647,0}, preq=422958},                    -- MINIGAME: Gather Stone Totem Fragments // Sammelt Steintotemfragmente
--[[ ] ]]

--[[ [ Aslan Valley / Aslan-Tal ]]
[420599]={typ= 1, lvl=20, rlvl=18, zone= 4, items={[201256]=  6}, giver=110711, taker=110036, rew={1502,975,10}, mobs={[100601]=0}},  -- Continuing Research // Weitere Forschungen
[420598]={typ= 1, lvl=21, rlvl=19, zone= 4, items={[201267]=  8}, giver=110711, taker=110036, rew={1959,1005,10}},                    -- Material Gathering // Materialsammlung
[420424]={typ= 1, lvl=22, rlvl=20, zone= 4, items={[201119]= 10}, giver=110711, taker=110691, rew={2256,1082,10}, mobs={[100087]=0,[100088]=0,[100094]=0,[100089]=0}},   -- Enduring Armor // Beständige Rüstung
[420425]={typ= 1, lvl=22, rlvl=20, zone= 4, items={[201120]= 10}, giver=110711, taker=110724, rew={2256,1082,10}, mobs={[100222]=0,[100223]=0,[100224]=0}}, -- Ent's Dead Branches // Abgestorbene Äste eines Ents
[420600]={typ= 1, lvl=22, rlvl=20, zone= 4, items={[201258]= 10}, giver=110711, taker=110716, rew={2256,1082,10}, mobs={[100571]=0}}, -- Another Type of Meat! // Eine weitere Fleischsorte!
[420427]={typ= 1, lvl=23, rlvl=21, zone= 4, items={[201122]=  5}, giver=110711, taker=110035, rew={2641,1098,10}},                    -- Report after report // Ein Bericht nach dem anderen
[420428]={typ= 1, lvl=26, rlvl=24, zone= 4, items={[201266]=  6}, giver=110711, taker=110033, rew={3863,1288,10}, mobs={[100099]=0,[100090]=0,[100091]=0}}, -- Weird Wild Boar // Seltsamer wilder Keiler
[420426]={typ= 1, lvl=27, rlvl=24, zone= 4, items={[201121]= 10}, giver=110711, taker=110036, rew={4325,1377,10}, mobs={[100229]=0,[100230]=0}},            -- Demon Vine // Dämonenranken
[420601]={typ= 1, lvl=28, rlvl=26, zone= 4, items={[201259]=  5,[201260]=  5}, giver=110711, taker=110035, rew={4890,1408,10}, mobs={[100226]=201259,[100227]=201260}}, -- Animal Control // Kontrolle des Tierbestands
--[[ ] ]]

--[[ [ Dragonfang Ridge / Drachzahngebirge ]]
[421615]={typ= 1, lvl=21, rlvl=19, zone=11, items={[203344]= 10}, giver=111640, taker=111122, rew={1959,1005,10}, mobs={[100822]=0}},   -- Tusk Research // Hauer-Forschung
[421616]={typ= 1, lvl=22, rlvl=20, zone=11, items={[203345]= 10}, giver=111640, taker=111163, rew={2256,1082,10}, mobs={[100824]=0}},   -- Bear Paw Stew // Bärenprankeneintopf
[421617]={typ= 1, lvl=23, rlvl=21, zone=11, items={[203346]= 10}, giver=111640, taker=111162, rew={2641,1098,10}, mobs={[100825]=0}},   -- Warm Clothing // Warme Kleidung
[421619]={typ= 1, lvl=24, rlvl=21, zone=11, items={[203348]= 10}, giver=111296, rew={3092,1109,10}, mobs={[100827]=0}},                 -- Valuable Pearls // Wertvolle Perlen
[421618]={typ= 1, lvl=25, rlvl=23, zone=11, items={[203347]= 10}, giver=111296, rew={3469,1241,10}, mobs={[100828]=0,[101006]=0}},      -- The Amulet of Fortune // Das Amulett des Schicksals
[421620]={typ= 1, lvl=27, rlvl=25, zone=11, items={[203349]= 10}, giver=111296, rew={4325,1377,10}, mobs={[100831]=0,[100832]=0,[100833]=0,[100838]=0,[101245]=0}},   -- Special Bracelets // Besondere Armreifen
[421621]={typ= 1, lvl=28, rlvl=26, zone=11, items={[203350]= 10}, giver=111296, rew={4890,1408,10}, mobs={[100739]=0,[100742]=0,[100841]=0,[100843]=0,[100844]=0}},   -- Mysterious Necklaces // Geheimnisvolle Halskette
[421622]={typ= 1, lvl=30, rlvl=28, zone=11, items={[203351]= 10}, giver=111296, rew={5941,1650,10}, mobs={[100848]=0,[100849]=0,[100852]=0,[100853]=0}},   -- Gnoll's Stones // Gnollsteine
[421623]={typ= 1, lvl=32, rlvl=30, zone=11, items={[203360]= 10}, giver=111730, taker=111729, rew={7166,1695,10}, mobs={[100865]=0}},   -- The Origin of the Bizarre Scent // Die Quelle des absonderlichen Geruchs
[421625]={typ= 1, lvl=33, rlvl=30, zone=11, items={[203353]= 10}, giver=111730, taker=111211, rew={8048,1661,10}, mobs={[100862]=0}},   -- Shana's Sweet Spot // Shanas Schwäche
[421627]={typ= 1, lvl=33, rlvl=31, zone=11, items={[203361]= 10}, giver=111730, taker=111300, rew={8048,1661,10}, mobs={[100857]=0}},   -- Revive the Economy! // Wirtschaftsaufschwung
[421624]={typ= 1, lvl=33, rlvl=31, zone=11, items={[203359]= 10}, giver=111730, taker=111607, rew={8048,1661,10}, mobs={[100872]=0}},   -- A Horn's Uses // Verwendungsarten eines Horns
[421626]={typ= 1, lvl=34, rlvl=31, zone=11, items={[203352]= 10}, giver=111730, taker=111170, rew={10174,1661,10},mobs={[100859]=0,[100860]=0,[100861]=0}},  -- Product Development // Produktforschung und -entwicklung
--[[ ] ]]

--[[ [ Ystra Highland ]]
[420632]={typ= 1, lvl=31, rlvl=29, zone= 5, items={[201463]= 10}, giver=110729, taker=110281, rew={6317,1677,10}, mobs={[100139]=0}},   -- Strong Medicine // Starke Medizin
[420436]={typ= 4, lvl=33, rlvl=31, zone= 5, items={[200881]=  1}, giver=110729, taker=110273, rew={8048,1661,10}},                      -- Supplying the Sea of Snow // Lieferung für das Schneemeer
[420437]={typ= 4, lvl=34, rlvl=32, zone= 5, items={[200686]= 10}, giver=110729, taker=110241, rew={10174,1661,10}},                     -- Supplying Winternight Valley // Lieferung in das Winternacht-Tal
[420631]={typ= 1, lvl=34, rlvl=32, zone= 5, items={[201462]= 10}, giver=110729, taker=110706, rew={10174,1661,10}, mobs={[100354]=0}},  -- Abundant Ingredients // Reichlich Zutaten
[420442]={typ= 1, lvl=35, rlvl=32, zone= 5, items={[201124]= 15}, giver=110729, taker=110257, rew={12139,1636,10}, mobs={[100269]=0}},  -- The Cyclops Menace // Die Zyklopenbedrohung
[420438]={typ= 1, lvl=35, rlvl=33, zone= 5, items={[200617]= 15}, giver=110729, taker=110281, rew={12139,1636,10}, mobs={[100592]=0}},  -- Fur Trade // Pelzhandel
[420439]={typ= 1, lvl=35, rlvl=33, zone= 5, items={[200579]= 10}, giver=110729, taker=110287, rew={12139,1636,10}, mobs={[100271]=0,[100357]=0,[100356]=0,[101024]=0}},  -- Minotaur Trinkets // Minotauren-Schmuckstücke
[420440]={typ= 2, lvl=36, rlvl=34, zone= 5, mobs= {[100124]= 15}, giver=110729, taker=110472, rew={14178,1579,10}},                     -- Annoying Snow Ferrets // Lästige Schneefrettchen
[420441]={typ= 1, lvl=37, rlvl=35, zone= 5, items={[200016]= 10}, giver=110729, taker=110474, rew={16029,1559,10}, mobs={[100368]=0}},  -- Winter Spider Specimen // Winterspinnenarten
[421187]={typ= 3, lvl=33, rlvl=31, zone= 5, items={[202364]= 20}, giver=111230, rew={0,0,0}, preq=421186},                             -- Even More Mysterious Essence // Noch mehr geheimnisvolle Essenz
[421458]={typ=12, lvl=45, rlvl=40, zone= 5, items={[203039]=  1}, giver=111443, rew={77631,7986,0}, mobs={[101022]=1}},   -- Battle for Mystery // Kampf um Mysterium
--[[ ] ]]

--[[ [ Ystra Labyrinth ]]
[422396]={typ= 1, lvl=32, rlvl=30, zone=205, items={[205003]= 10}, giver=113068, rew={7166,1695,10}, mobs={[101396]=0,[102152]=0}}, -- Treasure Hunter's Treasure // Schatzsuchers Schatz
[422410]={typ= 1, lvl=32, rlvl=30, zone=205, items={[204895]= 10}, giver=113077, rew={7166,1695,10}, mobs={[101396]=0,[102152]=0}, preq=422406}, -- More Heads // Mehr Köpfe
[422400]={typ= 1, lvl=35, rlvl=33, zone=205, items={[205002]= 10}, giver=113070, rew={12139,1636,10},mobs={[102145]=0,[102146]=0,[102147]=0,[102148]=0}},            -- Supplementary Research Material // "Zusätzliches Forschungsmaterial"
[422397]={typ=12, lvl=39, rlvl=37, zone=205, items={[205001]=  1}, giver=113069, rew={28689,2250,20},mobs={[102144]=0}},            -- Secret Aid // "Geheimer Gehilfe"
[422395]={typ= 1, lvl=38, rlvl=36, zone=205, items={[205004]= 10}, giver=113064, rew={18466,1531,10},   mobs={[102149]=0,[102154]=0,[102155]=0,[102150]=0,[102153]=0}},  -- Death Count // Die Anzahl der Toten
[422394]={typ= 1, lvl=39, rlvl=37, zone=205, items={[204980]=100}, giver=113063, rew={21516,1500,10}, preq=422393}, -- Tiny Control Equipment // Winziges Kontrollwerkzeug
[422392]={typ=11, lvl=39, rlvl=37, zone=205, items={[204981]=  5}, giver=113062, rew={28689,3000,10}},    -- Guard Control // Wachenkontrolle
[422390]={typ= 1, lvl=42, rlvl=40, zone=206, items={[205010]= 10}, giver=113084, rew={28695,1626,10}}, -- Ice Delivery! // Eislieferung!
[422387]={typ= 1, lvl=43, rlvl=41, zone=206, items={[205013]= 10}, giver=113082, rew={30579,1771,10}}, -- Complementary Property: Light // Ergänzende Eigenschaft: Licht
[422388]={typ= 1, lvl=43, rlvl=41, zone=206, items={[205014]= 10}, giver=113082, rew={30579,1771,10}}, -- Complementary Property: Darkness // Ergänzende Eigenschaft: Dunkel
[422389]={typ= 1, lvl=44, rlvl=42, zone=206, items={[205011]= 10}, giver=113083, rew={33936,1914,10}}, -- Start A Fire // Entzündet ein Feuer
[422399]={typ= 1, lvl=45, rlvl=43, zone=206, items={[205015]=  3}, giver=113083, rew={38815,1996,10}}, -- Special Venom Sample // Besondere Giftprobe
[422409]={typ= 1, lvl=45, rlvl=43, zone=206, items={[205012]= 10}, giver=113085, rew={38815,1996,10}}, -- Complex Puzzle // Kompliziertes Puzzle
[422398]={typ= 1, lvl=45, rlvl=43, zone=206, items={[205016]=  3}, giver=113082, rew={38815,1996,10}}, -- Should be Liquid // Sollte flüssig sein
[422359]={typ= 3, lvl=47, rlvl=45, zone=207, items={[204894]=  6}, giver=113046, rew={0,0,0}},         -- 6 Pieces of Solid Energy // 6 Stück feste Energie
[422360]={typ= 3, lvl=47, rlvl=45, zone=207, items={[204894]= 60}, giver=113046, rew={0,0,0}, preq=422359},         -- 60 Pieces of Solid Energy // 60 Stück feste Energie
--[[ ] ]]

--[[ [ Dustdevil Canyon ]]
[420444]={typ= 1, lvl=40, rlvl=40, zone= 6, items={[201126]= 15}, giver=110806, taker=110841, rew={33331,1519,10}, mobs={[100439]=0,[100444]=0}}, -- Scorpion // Skorpion
[420446]={typ= 1, lvl=40, rlvl=40, zone= 6, items={[201127]= 15}, giver=110806, taker=110836, rew={33331,1519,10}, mobs={[100445]=0}}, -- Ancient Magical Medicine // Alte magische Medizin
[420795]={typ= 1, lvl=40, rlvl=40, zone= 6, items={[201432]= 15}, giver=110806, taker=110839, rew={33331,1519,10}, mobs={[100658]=0}}, -- Cactus Fruit // Kaktusfrucht
[420796]={typ= 1, lvl=40, rlvl=40, zone= 6, items={[201433]= 15}, giver=110806, taker=110839, rew={33331,1519,10}, mobs={[100659]=0}}, -- Cactus Flower // Kaktusblüte
[420797]={typ= 1, lvl=40, rlvl=40, zone= 6, items={[201434]= 15}, giver=110806, taker=110839, rew={33331,1519,10}, mobs={[100660]=0}}, -- Cactus Thorn // Kaktusstachel
[420791]={typ= 1, lvl=42, rlvl=40, zone= 6, items={[201429]= 15}, giver=110806, taker=110847, rew={38260,1626,10}, mobs={[100427]=0}}, -- Heat-Powered Battle Drug // Wärme als Waffe
[420792]={typ= 1, lvl=42, rlvl=40, zone= 6, items={[201430]= 15}, giver=110806, taker=110325, rew={38260,1626,10}, mobs={[100426]=0}}, -- Lack of Fuel // Brennstoffmangel
[420794]={typ= 1, lvl=42, rlvl=40, zone= 6, items={[204355]= 20}, giver=110806, taker=110344, rew={38260,1626,10}, mobs={[100665]=0}}, -- Protecting Fun // Spaß muss sein
[420788]={typ= 1, lvl=43, rlvl=40, zone= 6, items={[201427]= 15}, giver=110806, taker=110901, rew={40772,1771,10}, mobs={[100440]=0}}, -- Never Too Late to Mend // Alles noch zu retten
[420789]={typ= 1, lvl=43, rlvl=40, zone= 6, items={[201428]= 25}, giver=110806, taker=110898, rew={40772,1771,10}, mobs={[100441]=0}}, -- Highly Efficient Investment // Lohnende Investition
[420793]={typ= 1, lvl=45, rlvl=40, zone= 6, items={[201431]= 30}, giver=110806, taker=110939, rew={51754,1996,10}, mobs={[100447]=0,[100448]=0,[100449]=0}}, -- Smuggling Businessman // Schmuggelnder Geschäftsmann
[420787]={typ= 1, lvl=44, rlvl=42, zone= 6, items={[201426]= 15}, giver=110806, taker=110827, rew={45248,1914,10}, mobs={[100422]=0}}, -- High Quality Meat Stew // Hochwertiger Fleischeintopf
[420790]={typ= 1, lvl=47, rlvl=43, zone= 6, items={[204354]= 20}, giver=110806, taker=110835, rew={58943,2106,10}, mobs={[100434]=0}}, -- A Nightmare // Ein Albtraum
--[[ ] ]]

--[[ [ Ravenfell ]]
[420450]={typ= 2, lvl=46, rlvl=45, zone= 3, mobs= {[101566]=6,[101573]=6,[101567]=6}, giver=112262, taker=112233, rew={41888,2067,10}, preq=421807}, -- If The Road Won't Turn, Change Your Path // Ändert Euren Weg, wenn die Straße nicht abzweigt
[420622]={typ= 1, lvl=46, rlvl=45, zone= 3, items={[202005]= 10}, giver=112262, taker=112198, rew={41888,2067,10}, mobs={[101571]=0}},  -- Folk Medicine Prescription // Naturmedizin
[420618]={typ=14, lvl=46, rlvl=45, zone= 3, items={[203620]= 10}, giver=112262, taker=112126, rew={41888,2067,10}, preq=421691},                     -- Is it so Tasty? // Ist das so schmackhaft?
[420451]={typ=14, lvl=46, rlvl=45, zone= 3, items={[203645]= 10}, giver=112262, taker=112140, rew={41888,2067,10}, preq=421751},                     -- Silent Concern // Stilles Gedenken
[420454]={typ= 1, lvl=47, rlvl=46, zone= 3, items={[201994]= 10}, giver=112262, taker=112240, rew={44207,2106,10}, mobs={[100334]=0,[100335]=0,[100336]=0}}, -- Steal Anything // Alles geklaut
[420455]={typ= 1, lvl=47, rlvl=46, zone= 3, items={[201995]= 10}, giver=112262, taker=112155, rew={44207,2106,10}, mobs={[100343]=0,[101578]=0}, preq=421722}, -- Cosmetic Materials // Kosmetik
[420615]={typ= 1, lvl=47, rlvl=46, zone= 3, items={[201997]= 10}, giver=112262, taker=112149, rew={44207,2106,10}, mobs={[100328]=0}},  -- Hard on the Outside, Soft on the Inside // Harte Schale, weicher Kern
[420623]={typ= 1, lvl=47, rlvl=46, zone= 3, items={[202011]= 10}, giver=112262, taker=112198, rew={44207,2106,10}, mobs={[100573]=0}},  -- Equipment Cleaner // Ausrüstungsreinigung
[420456]={typ= 1, lvl=47, rlvl=46, zone= 3, items={[201996]= 10}, giver=112262, taker=112125, rew={44207,2106,10}, mobs={[100595]=0}, preq=421700},  -- Peculiar Eating Habits // Merkwürdige Essgewohnheiten
[420453]={typ=12, lvl=47, rlvl=46, zone= 3, mobs= {[101583]= 10}, giver=112264, rew={44207,2106,10}},                     -- They Deserve It // Sie haben es verdient!
[420452]={typ=11, lvl=48, rlvl=47, zone= 3, items={[201993]=  5}, giver=112264, rew={46498,2198,10}},                     -- Powerless // Machtlos
[420616]={typ= 4, lvl=48, rlvl=47, zone= 3, items={[201998]=  5}, giver=112262, taker=112192, rew={46498,2198,10}},                     -- Pirate Superstition// Piraten-Aberglaube
[420617]={typ= 1, lvl=50, rlvl=47, zone= 3, items={[201999]= 10}, giver=112262, taker=112158, rew={79832,2249,10}, mobs={[100341]=0}},  -- Unforgettably Delicious // Unvergesslich köstlich
--[[ ] ]]

--[[ [ Weeping Coast ]]
[422238]= {typ= 1, lvl=50, rlvl=48, zone= 7, items={[204446]= 10}, giver=112680, taker=112603, rew={79832,2249,10}, mobs={[101856]=0}}, -- Trade Relations // Handelsbeziehung
[422229]= {typ= 1, lvl=50, rlvl=48, zone= 7, items={[204437]= 10}, giver=112610, rew={90476,2249,10}, mobs={[101779]=0}}, -- Selling Like Hot Cakes // Das geht wie geschnitten Brot
[422231]= {typ= 1, lvl=51, rlvl=49, zone= 7, items={[204439]= 10}, giver=112516, rew={85420,2251,10}, mobs={[101777]=0}}, -- Supply Officer's Angst // Die Angst des Nachschuboffiziers
[422230]= {typ= 1, lvl=51, rlvl=49, zone= 7, items={[204438]= 10}, giver=112611, rew={85420,2251,10}, mobs={[101747]=0}}, -- Fighting Fire with Fire // Feuer mit Feuer bekÃ¤mpfen
[422227]= {typ= 1, lvl=51, rlvl=49, zone= 7, items={[204435]= 10}, giver=112680, taker=112624, rew={85420,2251,10}, mobs={[101738]=0}}, -- Tasty Cuisine // Köstliche Küche
[422226]= {typ= 1, lvl=51, rlvl=49, zone= 7, items={[204434]= 10}, giver=112680, taker=112609, rew={85420,2251,10}, mobs={[101739]=0}}, -- Hardworking Sous Chef // Hart arbeitender Sous Chef
[422225]= {typ= 1, lvl=51, rlvl=49, zone= 7, items={[204448]= 10}, giver=112510, rew={85420,2251,10}, mobs={[101854]=0}, preq=422055}, -- When Vengeance is the Only Road
[422232]= {typ= 1, lvl=51, rlvl=49, zone= 7, items={[204440]= 10}, giver=112680, taker=112612, rew={85420,2251,10}, mobs={[101780]=0}}, -- Wings to Fly // Flügel zum Fliegen
[422228]= {typ= 1, lvl=51, rlvl=49, zone= 7, items={[204436]= 10}, giver=112623, rew={96809,2251,10}, mobs={[101776]=0}}, -- Fresh Bait // Frische Köder
[422233]= {typ= 1, lvl=52, rlvl=49, zone= 7, items={[204441]= 10}, giver=112680, taker=112605, rew={91399,2265,10}, mobs={[101794]=0}}, -- Handicraft Supplies // Handwerkermaterial
[422236]= {typ= 1, lvl=52, rlvl=50, zone= 7, items={[204444]= 10}, giver=112616, rew={103586,2265,10},mobs={[101760]=0,[101761]=0,[101762]=0,[101763]=0}},   -- A Difficult Mission // Eine schwere Mission
[422234]= {typ= 1, lvl=52, rlvl=49, zone= 7, items={[204442]= 10}, giver=112615, rew={103586,2265,10},mobs={[101786]=0}}, -- Lovely Leathers // Liebliches Leder
[422235]= {typ= 1, lvl=52, rlvl=50, zone= 7, items={[204443]= 10}, giver=112615, rew={103586,2265,10},mobs={[101792]=0}}, -- Giant Wolf Paws // Riesenwolfkrallen
[422237]= {typ= 1, lvl=52, rlvl=50, zone= 7, items={[204445]= 10}, giver=112615, rew={103586,2265,10},mobs={[101753]=0,[101735]=0}}, -- Bunga Beastology // Bungabestien-Forschung
--[[ ] ]]

--[[ [ Savage Lands ]]
[422617]= {typ= 1, lvl=54, rlvl=52, zone= 8, items={[205665]= 12}, giver=113170, rew={113052,2272,10}, mobs={[102249]=0}},  -- Ooze Fertilizer // Düngschlamm
[422611]= {typ= 1, lvl=53, rlvl=51, zone= 8, items={[205666]= 12}, giver=113278, rew={110836,2291,10}, mobs={[102217]=0}, preq=422560},  -- Great Ape Wound Hair // Das Wundenhaar der Riesenaffen
[422609]= {typ= 1, lvl=53, rlvl=51, zone= 8, items={[205667]= 15}, giver=113177, rew={110836,2291,10}, mobs={[102248]=0,[102250]=0,[102251]=0,[102252]=0}},   -- Trap Parts // Fallenkomponenten
[422608]= {typ= 1, lvl=53, rlvl=51, zone= 8, items={[205661]= 12}, giver=113178, rew={110836,2291,10}, mobs={[102259]=0}, preq=422453},  -- Deer Leg Provisions // Hirschbein-VorrÃ¤te
[422614]= {typ= 1, lvl=53, rlvl=51, zone= 8, items={[205663]= 15}, giver=113180, rew={110836,2291,10}, mobs={[102245]=0,[102246]=0,[102247]=0}, preq=422448},   -- Ruin Guardian Energy Source // Die Energiequelle der Ruinenhüter
[422612]= {typ= 2, lvl=54, rlvl=52, zone= 8, mobs= {[102275]= 15}, giver=113325, rew={113052,2272,10}},                      -- Fear of Shadows // Angst vor dem Schatten
[422613]= {typ= 1, lvl=54, rlvl=52, zone= 8, items={[205668]= 12}, giver=113325, rew={113052,2272,10}, mobs={[102256]=0}},  -- Beautiful Poisonous Mandibles // Wunderschöne Giftzähne
[422610]= {typ= 1, lvl=53, rlvl=51, zone= 8, items={[205662]= 12}, giver=113177, rew={97797,2291,10},  mobs={[102211]=0}, preq=422440},  -- Recycled Crystal Ore // Wiederverwertetes Kristallerz
[422615]= {typ= 2, lvl=56, rlvl=54, zone= 8, mobs= {[102263]= 15}, giver=113326, rew={117619,2331,10}},                     -- Kaa Marchers Must Die // Tod den Mitgliedern der Kaa-Expedition!
[422616]= {typ= 1, lvl=56, rlvl=54, zone= 8, items={[205664]= 12}, giver=113326, rew={117619,2331,10}, mobs={[102265]=0}},  -- Glory and Dishonor // Ruhm und Ehrlosigkeit
--[[ ] ]]

--[[ [ Elven Citadel ]]
[422221]= {typ= 1, lvl=4, rlvl=2, zone=12, items={[204836]=  1}, giver=112950, taker=112860, rew={79,94,10}, preq=422263},                     -- Save Plant Seeds // Rettet Pflanzensamen
[422339]= {typ= 4, lvl=4, rlvl=2, zone=12, items={[204842]=1,[204843]=1,[204844]=1}, giver=112950, taker=112868, rew={79,94,10}, preq=422263}, -- Where the Hell are They? // Wo zum Henker sind sie nur?
[422344]= {typ= 4, lvl=4, rlvl=2, zone=12, items={[204841]= 10}, giver=112950, taker=112846, rew={79,94,10}, preq=422263},                     -- Transcendence Beach // Strand der Transzendenz
[422030]= {typ= 1, lvl=4, rlvl=2, zone=12, items={[204834]=  5}, giver=112847, rew={79,94,10}, preq=422263},                     -- Alchemy Trouble // Alchemie-Probleme
[422338]= {typ= 2, lvl=5, rlvl=3, zone=12, mobs= {[101933]= 10}, giver=112950, taker=112844, rew={93,130,10}, preq=422263},                    -- Spore Mage's Peculiarity // Die Eigentümlichkeiten des Sporenmeisters
[422340]= {typ= 4, lvl=4, rlvl=2, zone=12, items={[204840]=  1}, giver=112794, rew={79,94,10}, preq=422263},                     -- Helping Them Grow // Wachstumshilfe
[422239]= {typ= 4, lvl=6, rlvl=4, zone=12, items={[204671]=  5,[204623]= 5}, giver=112950, taker=112968, rew={112,166,10}, preq={422263,422304,422293,422335}},       -- Poison Mushrooms // Giftpilze
[422240]= {typ= 1, lvl=7, rlvl=5, zone=12, items={[204837]=  5,[204838]= 5}, giver=112950, taker=112965, rew={132,192,10}, preq=422263},       -- Special Flowers // Besondere Blumen
[422219]= {typ= 1, lvl=8, rlvl=6, zone=12, items={[204835]=  1}, giver=112950, taker=112965, rew={171,222,10}, preq=422263},                   -- Those Bears Again! // Schon wieder diese Bären
[422341]= {typ= 4, lvl=8, rlvl=6, zone=12, items={[204645]= 10}, giver=112886, rew={171,222,10}, preq={422300,422263}},                   -- Even More Sabinean Food Samples // Noch mehr Nahrungsproben der Sabineaner
--[[ ] ]]

--[[ [ Coast of Opportunity / Küste der Gelegenheit ]]
[423772]= {typ=21, lvl= 4, rlvl= 2, zone=13, items={[208981]=  5},giver=117380, rew={296,141,10}},                   -- // Meine Haut leidet (NO TP ??)
[423775]= {typ=21, lvl= 3, rlvl= 1, zone=13, items={[208979]=  3,[208980]=  3},giver=117379, rew={207,89,10}, mobs= {[105390]=208979,[117282]=208980},},   -- // Neuer köstlicher Festl...
[423776]= {typ=25, lvl= 5, rlvl= 3, zone=13, mobs ={[117546]=  3},giver=117410, rew={322,195,10}},                   -- // Sich einen Ruf erarbeiten
[423826]= {typ= 1, lvl=13, rlvl=11, zone=13, items={[208985]= 10},giver=117383, rew={1592,663,10}},                  -- Even Heat Needed // Gleichmäßige Temperatur benötigt
[423902]= {typ=21, lvl= 9, rlvl= 7, zone=13, items={[208984]=  6},giver=117378, rew={707,375,10}},                   -- // Selbst die Kulanchis sind Rabauken!
[423929]= {typ=21, lvl=11, rlvl= 9, zone=13, items={[208982]=  5},giver=117381, rew={1260,576,10}},                  -- // Hilfe bei der Schalentierforschung
[423930]= {typ= 1, lvl=13, rlvl=11, zone=13, items={[208986]=  5},giver=117378, rew={1592,663,10},mobs={[105145]=0}},-- Garbage can't be recycled // Müll kann nicht wiederverwertet werden
[423931]= {typ=22, lvl=10, rlvl= 8, zone=13, mobs ={[105141]= 10},giver=117386, rew={975,453,10}},                   -- // Heldenhaft Verteidigung
[423932]= {typ= 1, lvl=16, rlvl=14, zone=13, items={[209081]= 10},giver=117384, rew={2440,878,10},mobs={[105151]=0}},-- Big Fish Eat Big Worms // Grosse Fische fressen große Würmer
[423933]= {typ=22, lvl=18, rlvl=16, zone=13, mobs ={[117387]=  5},giver=117388, rew={3142,1143,10}},                 -- Dismantle the traps // Fallen entschärfen
[423935]= {typ= 1, lvl=21, rlvl=19, zone=13, items={[209006]= 10},giver=117519, rew={6532,1508,10},mobs={[105153]=0}}, -- // Esst jetzt kein Gazellenfleisch
[423936]= {typ=21, lvl=25, rlvl=23, zone=13, items={[208996]= 10},giver=117586, rew={11565,1862,10}},                -- // Perfekt harmonierende Gewürze
[423937]= {typ=21, lvl=24, rlvl=22, zone=13, items={[209007]= 10},giver=115399, rew={10307,1664,10}},                -- // Eine Schildkröte von innerer Stärke
[423938]= {typ=21, lvl=25, rlvl=23, zone=13, items={[209008]= 10},giver=117523, rew={11565,1862,10}},                -- // Einfache Mittel zur Selbstverteidigung
[423940]= {typ=21, lvl=26, rlvl=24, zone=13, items={[209100]= 10},giver=118014, rew={12877,1932,10},mobs={[117513]=0},},                      -- // Heilige Erde
[423934]= {typ=21, lvl=18, rlvl=16, zone=13, items={[209005]=  5},giver=117497, rew={3142,1143,10}, preq=423798},                 -- // Der Geschmack von Heimat
[423939]= {typ=21, lvl=28, rlvl=26, zone=13, items={[209060]= 5,[209061]= 5},giver=117587, rew={16302,2112,10}},     -- // Herrlicher Schmuck
[423941]= {typ=21, lvl=28, rlvl=26, zone=13, items={[209062]= 10},giver=117521, rew={16302,2112,10}},                -- // 'Gewichtiges' Leder
[423942]= {typ=21, lvl=29, rlvl=27, zone=13, items={[209063]= 10},giver=117522, rew={17697,2255,10}},                -- // Hässlicher Magen
[423943]= {typ=22, lvl=31, rlvl=29, zone=13, mobs= {[105342]=  6},giver=117639, rew={21057,2414,10}},                -- // Vertreibt die Unruhestifter
[423944]= {typ=21, lvl=31, rlvl=29, zone=13, items={[209078]= 10},giver=117517, rew={21057,2414,10}},                -- // Niedlich und glitschig
[423945]= {typ=21, lvl=32, rlvl=30, zone=13, items={[208921]= 10},giver=117264, rew={23887,2440,10}},                -- // Scharlachroter Skropionpanzer voller..
[423946]= {typ= 1, lvl=32, rlvl=30, zone=13, items={[208993]= 10},giver=117215, rew={23887,2440,10},mobs={[105172]=0}}, -- // Grillfest
[423947]= {typ=21, lvl=33, rlvl=31, zone=13, items={[209053]= 10},giver=117525, rew={26827,2459,10}},                -- // Warme Pelze
[423948]= {typ=21, lvl=32, rlvl=30, zone=13, items={[209080]= 10},giver=117641, rew={23887,2440,10}},                 -- // Entschlossen wie eine Blume
[423949]= {typ=21, lvl=33, rlvl=31, zone=13, items={[208956]=  5},giver=117376, rew={26827,2459,10}},                -- // Ausgrabungen
[423950]= {typ=21, lvl=36, rlvl=34, zone=13, items={[208920]= 10},giver=117524, rew={47260,2495,10}},                -- // Süsser Saft
[423957]= {typ=25, lvl=35, rlvl=33, zone=13, giver=117281, rew={40465,2486,10}, preq=423792},                                     -- // Energie für tausende Meilen
[423958]= {typ=21, lvl=38, rlvl=36, zone=13, items={[209101]= 10}, giver=117588, rew={61555,2541,10}},               -- // Lebenshormon
[423959]= {typ= 1, lvl=41, rlvl=39, zone=13, items={[208977]= 10}, giver=117590, rew={89442,2590,10}, mobs={[105183]=0}},   -- Another Drink // Ein weiteres Getränk
[423960]= {typ=21, lvl=42, rlvl=40, zone=13, items={[209079]=  8}, giver=117590, rew={95650,2634,10}, mobs={[105182]=0}},   -- Dragon Horn Ingredients //
[423961]= {typ= 1, lvl=42, rlvl=40, zone=13, items={[208995]= 10}, giver=117589, rew={95650,2634,10}, mobs={[105187]=0}},   -- A Juicy Fruit // Eine Saftige Frucht
[423962]= {typ= 5, lvl=38, rlvl=36, zone=13, giver=117589, rew={61555,2541,10}},                                            -- Important Patrol Work // Wichtige Patrouillienarbeit
[423963]= {typ=21, lvl=40, rlvl=38, zone=13, items={[209082]=  5,[209084]= 5}, giver=117609, rew={83327,2582,10}},           -- // Waffeninspektion
[423964]= {typ=21, lvl=40, rlvl=38, zone=13, items={[209086]=  5,[209083]= 5}, giver=117609, rew={83327,2582,10},mobs={[105180]=0,[105179]=0}, preq=423963},       -- Weapon Inspection II //
[424036]= {typ=21, lvl=32, rlvl=30, zone=13, items={[209192]= 10}, giver=117588, rew={23887,2440,10}},                       -- // Neu bepflanzen
[424037]= {typ=21, lvl=42, rlvl=40, zone=13, items={[209193]= 10}, giver=117590, rew={95650,2634,10}, mobs={[105186]=0}},   -- Heat Reduction Recipe //

[423953]= {typ= 6, lvl= 7, rlvl= 5, zone=13, giver=117420, rew={141,154,0}},         -- Invaders on the Sea // Angriff auf See
[423966]= {typ=26, lvl=27, rlvl=25, zone=13, giver=117495, rew={4613,1377,0}},       -- // Angriff der rasenden Schlangen
[423967]= {typ= 6, lvl=41, rlvl=39, zone=13, giver=117585, rew={28621,1560,0},},     -- Problems Inside and Outside Fanger's Camp // Probleme innerhalb und ausserhalb...

[422831]= {typ= 2, lvl=53, rlvl=51, zone= 7, items={[206015]=  1}, giver=101772, taker=112533, rew={110836,2291,10}, mobs={[101772]=0}}, -- Event Naga Außenposten
--[[ ] ]]

--[[ [ Xaviera ]]
[424151]= {typ=14, lvl=43, rlvl=41, zone=14, items={[209455]=  5}, giver=118056, rew={142702,5314,10}, mobs={[118046]=0}},  -- Calm the Fury // Die Wut besänftigen
[424152]= {typ= 4, lvl=43, rlvl=41, zone=14, items={[209456]=  5}, giver=118056, rew={101930,3543,10}},                     -- Water Demand // Bedarf an Wasser
[424153]= {typ= 1, lvl=43, rlvl=41, zone=14, items={[209427]= 10}, giver=118056, rew={101930,3543,10}, mobs={[105477]=0}},  -- Soft Brush // Weicher Pinsel
[424154]= {typ= 4, lvl=43, rlvl=41, zone=14, items={[209428]=  5}, giver=118057, rew={101930,3543,10}, mobs={[118048]=0}},  -- Moving Fragile Artifacts // Zerbrechliche Artefakte bewegen
[424155]= {typ= 1, lvl=44, rlvl=42, zone=14, items={[209429]=  5,[209430]=5}, giver=118057, rew={113120,3828,10}, mobs={[105450]=209429,[105444]=209430}}, -- Dig Site Safety // Schutz der Ausgrabungsstelle
[424156]= {typ=24, lvl=44, rlvl=42, zone=14, items={[209431]=  5}, giver=118056, rew={113120,3828,10}, mobs={[118049]=0}},  -- The Stolen Artifacts //
[424157]= {typ= 1, lvl=44, rlvl=42, zone=14, items={[209432]=  5}, giver=118057, rew={113120,3828,10}, mobs={[105446]=0}},  -- Artifact Restoration Materials // Materalien für die Artefaktrestauration
[424158]= {typ= 1, lvl=44, rlvl=42, zone=14, items={[209457]=  5}, giver=118058, rew={113120,3828,10}, mobs={[105449]=0}},  -- Living Cultural Relics // Lebende kulturelle Relikte
[424159]= {typ= 1, lvl=45, rlvl=43, zone=14, items={[209434]=  5}, giver=117776, rew={129385,3993,10}, mobs={[105420]=0}},  -- Danger's Sweet Taste // Der süße Geschmack der Gefahr
[424160]= {typ= 1, lvl=45, rlvl=43, zone=14, items={[209435]=  5}, giver=117776, rew={129385,3993,10}, mobs={[105417]=0}},  -- Wild Taste // Wilder Geschmack
[424161]= {typ= 1, lvl=45, rlvl=43, zone=14, items={[209436]=  5}, giver=117776, rew={129385,3993,10}, mobs={[105354]=0}},  -- Crucial Ingredient for a Legendary Recipe // Entscheidende Zutat für ein legendäres Rezept
[424162]= {typ= 1, lvl=45, rlvl=43, zone=14, items={[209437]= 10}, giver=118059, rew={129385,3993,10}, mobs={[105419]=0}},  -- Miraculous Bloodclotting Effect // Wunderbarer Blutgerinnungseffekt
[424163]= {typ= 4, lvl=46, rlvl=44, zone=14, items={[209438]=  5}, giver=118059, rew={139627,4135,10}},                     -- Flu? Poisoned! // Grippe? Vergiftet!
[424164]= {typ= 4, lvl=46, rlvl=44, zone=14, items={[209458]=  5}, giver=118059, rew={139627,4135,10}, mobs={[118191]=0}},  -- Retrieve the Loot // Die Beuete wiederbeschaffen
[424166]= {typ=11, lvl=46, rlvl=44, zone=14, items={[209439]=  5}, giver=118061, rew={195478,6202,10}, mobs={[105501]=0}},  -- Magic Coloring // Magische Farben
[424165]= {typ= 2, lvl=46, rlvl=44, zone=14, mobs ={[105483]=  5}, giver=118060, rew={139627,4135,10}},                     -- Shut Them Up // Sie zum Schweigen bringen
[424167]= {typ= 1, lvl=47, rlvl=45, zone=14, items={[209440]= 10}, giver=118062, rew={147357,4213,10}, mobs={[105486]=0}},  -- Ah! One Bear, Three Dishes // Ah! Ein Bär, drei Gerichte
[424168]= {typ=21, lvl=47, rlvl=45, zone=14, items={[209441]= 10}, giver=118063, rew={147357,4213,10}, mobs={[105505]=0}},        --  // Spinnenseide kaufen
[424169]= {typ= 1, lvl=47, rlvl=45, zone=14, items={[209441]= 10}, giver=118064, rew={147357,4213,10}, mobs={[105505]=0}},  -- Purchase Spider Silk // Spinnenseide kaufen
[424170]= {typ= 2, lvl=47, rlvl=45, zone=14, mobs= {[105500]= 10}, giver=118065, rew={147357,4213,10}},                     -- Kill the Worms // Die Würmer töten
[424171]= {typ= 2, lvl=47, rlvl=45, zone=14, mobs= {[105395]=5,[105396]=5,[105397]=2}, giver=118066, rew={147357,4213,10}}, -- Cause of a Nightmare // Ursache des Albtraum
[424172]= {typ= 4, lvl=48, rlvl=46, zone=14, items={[209444]=  5}, giver=118067, rew={154995,4397,10}, mobs={[118052]=0}},  -- Destroy the Nest Worm Eggs // Zerstörung der Nestwurmeier
[424173]= {typ= 1, lvl=48, rlvl=46, zone=14, items={[209447]= 10}, giver=118067, rew={154995,4397,10}, mobs={[105510]=0,[105525]=0}},  -- The Harpies can't resist... // Die Harpyien können nicht widerstehen ...
[424174]= {typ= 1, lvl=48, rlvl=46, zone=14, items={[209445]= 10}, giver=118068, rew={154995,4397,10}, mobs={[105511]=0,[105512]=0,[105513]=0,[105489]=0,[105490]=0}},     -- Feathers of a Harpy // Federn einer Harpyie
[424175]= {typ= 1, lvl=49, rlvl=47, zone=14, items={[209448]=  5}, giver=118069, rew={166317,4477,10}, mobs={[105491]=0,[105492]=0},},      -- Rebirth // Wiedergeburt
[424176]= {typ= 4, lvl=49, rlvl=47, zone=14, items={[209459]=  5}, giver=118070, rew={166317,4477,10}, mobs={[118193]=0}},  -- The Elves' Defenses // Die Verteidigung der Elfen
[424177]= {typ= 1, lvl=49, rlvl=47, zone=14, items={[209450]=5,[209451]=5}, giver=118070, rew={166317,4477,10}, mobs={[105434]=209450,[105433]=209451},},     -- Deal with the Hard Bones // Mit den harten Knochen fertigwerden
[424178]= {typ= 4, lvl=49, rlvl=47, zone=14, items={[209452]=  5}, giver=118069, rew={166317,4477,10}, mobs={[118194]=0}},  -- Soft and Cozy // Weich und Flauschig
[424179]= {typ= 2, lvl=50, rlvl=48, zone=14, mobs= {[105415]=  5}, giver=118071, rew={266107,4498,10}},                     -- Twisted Soul // Gequälte Seele
[424180]= {typ=21, lvl=50, rlvl=48, zone=14, items={[209453]= 10}, giver=118072, rew={266107,4498,10}, mobs={[105408]=0}},  -- Difficult Supply Situation // Schwierige Vorratssituation
[424181]= {typ= 2, lvl=50, rlvl=48, zone=14, mobs= {[105413]=  5}, giver=118072, rew={266107,4498,10}},                     -- Catch Butterflies //  Schmetterlinge fangen
[424182]= {typ= 1, lvl=48, rlvl=46, zone=14, items={[209446]=  5}, giver=118068, rew={154995,4397,10}, mobs={[105506]=0}},  -- Turned into Ashes // In Asche verwandeln
--[424204]= {typ=13, lvl=50, rlvl=48, zone=14, items={[]=  }, giver=117685, rew={,,}, mobs={[105407]=0}},                   -- // Verfeinerte Kräutermischung
[424205]= {typ= 2, lvl=50, rlvl=48, zone=14, items={[209454]=  5}, giver=118071, rew={266107,4498,10}, mobs={[105407]=5}},  -- Support the Frontlines: Eliminate the Gargoyles // Unterstützung der Front: Eliminierung der Gargoyles

[424054]= {typ= 6, lvl=44, rlvl=42, zone=14, giver=117751, rew={45248,2871,0},},     --  // Festungen, Gerüchte und die Moral
[424208]= {typ= 6, lvl=44, rlvl=42, zone=14, giver=117532, taker=117480, rew={45248,2871,0},mobs={[105395]=0,[105396]=0,[105397]=0}},     --  // Angriff
[424207]= {typ= 6, lvl=44, rlvl=42, zone=14, giver=118204, taker=117448, rew={45248,2871,0}},     --  // Angriff
[424066]= {typ= 6, lvl=44, rlvl=42, zone=14, giver=117782, rew={45248,2871,0}},     --  // Der Geheime Plan des Auge der Weisheit
--[[ ] ]]

--[[ [ Land des Unheils (19) ]]
[423724]= {typ=24, lvl=64, rlvl=62, zone=19, items={[208546]= 10}, giver=117018, rew={207638,3570,10}, preq=423723},                     -- // Zweite Hilfe
[423727]= {typ= 2, lvl=64, rlvl=62, zone=19, mobs ={[104861]= 10}, giver=116990, rew={166110,2380,10}, preq=423726},                     -- The Mind is Willing but the Flesh is Weak // Der Geist ist willig, doch das Fleisch ist schwach
[423753]= {typ= 1, lvl=64, rlvl=62, zone=19, items={[208576]= 10}, giver=116834, rew={176492,2380,10}, mobs={[104701]=0}, preq=423752},  -- Food for Your Health // Heilnahrung
[423736]= {typ=21, lvl=64, rlvl=62, zone=19, items={[544661]=  1}, mobs={[104861]=1}, giver=116978, rew={166110,2380,10}, preq=423735},  -- Capture One "Alive" // Ihr müsst einen fangen, der noch "lebt"
[423738]= {typ= 4, lvl=64, rlvl=62, zone=19, items={[208549]= 10}, giver=116648, rew={207638,3570,10}, preq=423737},                     -- Unexpected Discovery // Eine unerwartete Entdeckung
[423720]= {typ= 1, lvl=64, rlvl=62, zone=19, items={[208489]= 10}, giver=117003, rew={176492,2618,10}, mobs={[104704]=0}, preq=423719},  -- Spirit of Experimentation // Experimentiergeist
[423718]= {typ= 4, lvl=64, rlvl=62, zone=19, items={[208487]= 10}, giver=117003, rew={207638,3570,10}, preq=423717},                     -- Herbal Supplies // Kräutervorräte
[423768]= {typ=22, lvl=64, rlvl=62, zone=19, mobs ={[104733]= 5, [104734]=5}, giver=117018, rew={166110,2380,10}, preq={423723,423729,423731}},         -- // Jemand, der sich auskennt
[423754]= {typ= 1, lvl=64, rlvl=62, zone=19, items={[208550]= 10}, giver=117055, rew={166110,2380,10}, mobs={[104710]=0}, preq=423691},  -- Right-hand Man // Der rechte Mann
[423710]= {typ= 2, lvl=64, rlvl=62, zone=19, mobs ={[104756]= 10}, giver=116993, rew={166110,2380,10}, preq=423709},                     -- Scarecrow // Vogelscheuche
[423708]= {typ= 5, lvl=64, rlvl=62, zone=19, items={[208551]=  8}, giver=117092, taker=116979, rew={218019,3570,10}, mobs={[104738]=0,[104736]=0,[104696]=0}, preq=423707},-- // Beharrlichkeit
[423767]= {typ=22, lvl=64, rlvl=62, zone=19, mobs ={[104722]= 10}, giver=116932, rew={176492,2380,10}, preq=423640},                     -- // Wenn zu diesem Zeitpunkt ...
[423722]= {typ=25, lvl=64, rlvl=62, zone=19, items={[208547]= 10, [208548]=5},  giver=116530, rew={290693,4284,10}, mobs={[104721]=208548}, preq=423721},-- If I Persevere // Wenn ich durchhalte
[423730]= {typ=22, lvl=64, rlvl=62, zone=19, mobs ={[104724]= 10}, giver=117017, rew={166110,2380,10}, preq=423729},                     -- // Die Bedrohung besteht weiter
[423732]= {typ=24, lvl=64, rlvl=62, zone=19, items={[208545]= 10}, giver=117017, rew={207638,3570,10}, preq=423731},                     -- // Zum Fehlerbeheben ist es nie zu spät
[423756]= {typ=21, lvl=64, rlvl=62, zone=19, items={[208548]= 5,[208522]= 5}, giver=116484, rew={176492,2618,10}, mobs={[104721]=208548,[104709]=208522}}, -- // Futter für die Tiere
[423763]= {typ=12, lvl=64, rlvl=62, zone=19, mobs ={[104852]=  1}, giver=117188, rew={726733,7140,15}, preq=423762},                     -- // Endlose Nacht
[423764]= {typ=24, lvl=64, rlvl=62, zone=19, items={[208488]= 10}, giver=116484, rew={207638,3570,10}},                                        -- // Trost spenden
[423769]= {typ=22, lvl=64, rlvl=62, zone=19, mobs ={[104729]= 5,[104730]= 5}, giver=116487, rew={166110,2380,10}, preq={423619,423770}},       -- // Offene Rechnung
[423770]= {typ=22, lvl=64, rlvl=62, zone=19, mobs ={[104726]= 10}, giver=116487, rew={166110,2380,10}},                                        -- // Gereizte Stimmung
--[[ ] ]]

--[[ [ Rothuegelberge (20) ]]
[424278]= {typ=21, lvl=65, rlvl=63, zone=20, items={[209637]= 10}, giver=118324, rew={216026,3573,10}, mobs={[105672]=0}},     -- // Der Traum eines jungen Feuerstiefels
[424279]= {typ=24, lvl=65, rlvl=63, zone=20, items={[209639]= 10}, giver=118325, rew={172820,2382,10}},                        -- // Ein Bart muss gepflegt werden
[424280]= {typ= 1, lvl=65, rlvl=63, zone=20, items={[209638]= 10}, giver=118325, rew={216026,3573,10}, mobs={[105673]=0}},     -- // Die Schätze des Sequoiawaldes
[424281]= {typ=24, lvl=65, rlvl=63, zone=20, items={[209640]= 10}, giver=118339, rew={172820,2382,10}},                        -- // Notbrennmaterial
[424284]= {typ=22, lvl=65, rlvl=63, zone=20, mobs ={[105676]= 10}, giver=118464, rew={194423,1048,10}, preq=424269},           -- // Beseitigt weiter die Felsgalidune
[424288]= {typ=21, lvl=65, rlvl=63, zone=20, items={[209071]= 10}, giver=118257, rew={216026,3573,10}, mobs={[105699]=0}},     -- // Versorgung mit Lebensmitteln
[424289]= {typ=21, lvl=65, rlvl=63, zone=20, items={[209072]=  5}, giver=118274, rew={194423,2859,10}, mobs={[105698]=0}},     -- // Der Weg zum Reichtum
[424316]= {typ=22, lvl=65, rlvl=63, zone=20, mobs ={[105766]=  5}, giver=118315, rew={172820,3573,10}},                        -- // Besänftigt den klagenden Geist
[424317]= {typ=21, lvl=65, rlvl=63, zone=20, items={[240292]= 10}, giver=118478, rew={216026,3573,10}, mobs={[105667]=0,[105756]=0,[105763]=0,[118492]=0}},-- // Zähmt die Jagdhunde
[424318]= {typ=21, lvl=65, rlvl=63, zone=20, items={[240281]= 10}, giver=118319, rew={216026,3573,10}, mobs={[105765]=0,[105850]=0}},-- // Ein wertvolles Rezept
[424319]= {typ=24, lvl=65, rlvl=63, zone=20, items={[240280]= 10}, giver=118371, rew={172820,2382,10}},                        -- // Schmerzmittel
[424245]= {typ=22, lvl=65, rlvl=63, zone=20, mobs ={[105668]=  3}, giver=118377, rew={172820,2382,10}, preq=424234},           -- // Vertreibt die aufgetauchten Unheilkünder.
[424282]= {typ=21, lvl=65, rlvl=63, zone=20, items={[209636]=  5}, giver=118328, rew={194423,2859,10}, preq=424267},           -- // Des Handwerksmeisters Gehilfe
[424283]= {typ=21, lvl=65, rlvl=63, zone=20, items={[209635]=  5}, giver=118537, rew={194423,2859,10}, preq=424270},           -- // Ewiger Winter
[424347]= {typ=22, lvl=66, rlvl=64, zone=20, mobs ={[105590]=  5}, giver=118293, rew={224753,3611,10}, preq=424249},           -- // Vertreibt die zurückgekehrten Monster
[424349]= {typ=25, lvl=66, rlvl=64, zone=20, items={[545094]=  1}, giver=118290, rew={134851,1685,10}, preq=424248},           -- // Wiederholte Salzverteilung
[424285]= {typ=21, lvl=65, rlvl=63, zone=20, mobs ={[105675]= 10}, items={[240293]= 10}, giver=118333, rew={216026,3573,10}, preq=424277},-- // Allans Trankrezept
[424344]= {typ=21, lvl=65, rlvl=63, zone=20, mobs ={[105675]= 10}, items={[240030]= 10}, giver=118755, rew={216026,3573,10}, preq=424262},-- // Großklauensuppe
[424342]= {typ=21, lvl=65, rlvl=63, zone=20, items={[240028]= 10}, giver=118301, rew={216026,3573,10}, preq=424330},           -- // Eines stolzen Bocks Horn
[424343]= {typ=21, lvl=65, rlvl=63, zone=20, items={[240029]= 10}, giver=118801, rew={216026,3573,10}, preq=424330},           -- // Beinfleisch einer weiblichen Antilope
[424360]= {typ=21, lvl=66, rlvl=64, zone=20, items={[240011]= 5,[240012]= 3}, giver=118597, rew={179802,2407 ,10}, preq=424359},-- // Sammelt Baumwolle und Flachs
[424348]= {typ=24, lvl=66, rlvl=64, zone=20, items={[240280]= 10}, giver=118293, rew={179802,2407,10}, preq=424249},           -- // Beseitigt den Müll.
[424381]= {typ=25, lvl=66, rlvl=64, zone=20, items={[544996]=  1}, giver=118608, rew={78663,963,10}, preq=424361},             -- // Fahrt mit der Beseitigung der Leichen fort
--[[ ] ]]

--[[ [ Aotulia Vulcan ]]
[422662]= {typ= 1, lvl=55, rlvl=53, zone= 9, items={[205915]=  5}, giver=113481, rew={115313,2284,10}, mobs={[102542]=0}},       -- Giant Bug Steaks // Riesenraupen-Steaks
[422621]= {typ= 2, lvl=55, rlvl=53, zone= 9, mobs= {[102498]= 12}, giver=113478, rew={115313,2284,10}},                          -- Killing the Hunter // Den Jäger töten
[422619]= {typ= 4, lvl=55, rlvl=53, zone= 9, items={[205727]= 20}, giver=113476, rew={115313,2284,10}},                          -- Flaming Volcano Mud // Hautbalsam aus Vulkanischen Schlamm
[422620]= {typ= 1, lvl=55, rlvl=53, zone= 9, items={[205833]= 10}, giver=113477, rew={115313,2284,10}, mobs={[102495]=0}},       -- Claw of Death // Klaue des Todes
[422663]= {typ=31, lvl=56, rlvl=54, zone= 9, items={[205916]=  1}, giver=113482, rew={117619,2331,15}, mobs={[102511]=0}},       -- The Study of Demon Weak Points // Erforschung der Schwachpunkt der Dämonen
[422661]= {typ=22, lvl=56, rlvl=54, zone= 9, mobs= {[102518]=6,[102519]=6,[102520]=6}, giver=113500, rew={117619,2331,10}},      -- Lava Goblin Armageddon // Schlacht gegen die Lava-Goblins
[422618]= {typ= 1, lvl=55, rlvl=53, zone= 9, items={[205954]= 10}, giver={113482,113475}, rew={115313,2284,10}, mobs={[102494]=0}}, -- Plunder Research Data // Forschungsdaten plündern
[422664]= {typ=21, lvl=56, rlvl=54, zone= 9, items={[205917]= 10}, giver=113483, rew={117619,2331,10}, mobs={[102535]=0}},       -- Fever and Bristles // Fieber und Borsten
[422622]= {typ=21, lvl=56, rlvl=54, zone= 9, items={[205834]=  7}, giver=113479, rew={117619,2331,10}, mobs={[102543]=0}},       -- Flame Feathers // Flammenfedern
--[422665]= {typ=21, lvl=56, rlvl=54, zone= 9, items={[205918]= 10}, giver={0}, taker=0, rew={117619,2331,10}}, --  // Vorräte plündern
--[[ ] ]]

--[[ [ Thunderhoof Hills ]]
[421028]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206752]=  5}, giver=114417, rew={119971,2384,10}, mobs={[103499]=0}},     -- Throw a Pango on the Spit // Wirf einen Pango auf den Grill!
[421030]= {typ= 4, lvl=57, rlvl=55, zone=15, items={[206753]= 10}, giver=114417, rew={119971,2384,10}},                        -- Pig in a Pond's Helper // Ein Helfer für das "Schwein im Teich"
[421031]= {typ= 4, lvl=57, rlvl=55, zone=15, items={[206754]= 10}, giver=114417, rew={119971,2384,10}},                        -- Special Barbecue Spices // Spezielle Grillgewürze
[421032]= {typ= 4, lvl=57, rlvl=55, zone=15, items={[206756]= 10}, giver=114418, rew={119971,2384,10}},                        -- Collect Scattered Wood // Sammelt vertsteutes Holz
[421033]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206757]=  5}, giver=114419, rew={119971,2384,10}, mobs={[103537]=0}},     -- Brain Eraser // Hirnputzer
[421034]= {typ= 4, lvl=57, rlvl=55, zone=15, items={[206759]= 10}, giver=114419, rew={119971,2384,10}},                        -- Deagonslayer Pub Helper // Gehilfe in der Drachentötung
[421039]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206188]=  5}, giver=114419, rew={119971,2384,10}, mobs={[103534]=0}},     -- Carrion helper // Aas-Gehilfe
[421210]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206189]= 10}, giver=114419, rew={119971,2384,10}, mobs={[103537]=0}},     -- Mysterious sobering liquid ingredients // Sonderbare Ausnüchterungstrank-Bestandteile
[421614]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206394]=  5}, giver=114421, rew={119971,2384,10}, mobs={[103533]=0}},     -- Giant Rat Pouch // Riesenrattenmägen
[422048]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206395]=  5}, giver=114421, rew={119971,2384,10}, mobs={[103532]=0}},     -- Hard Insect Wings // Harte Insektenflügel
[422049]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206167]=  5}, giver=114421, rew={119971,2384,10}, mobs={[103531]=0}},     -- Take the Eggs // Beschaffen der Eier
[421595]= {typ=24, lvl=57, rlvl=55, zone=15, items={[206408]=  8}, giver=114421, rew={119971,2384, 0}},                        -- Favorite of Lady and Miss // Renner bei den Damen
[422051]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206400]=  5}, giver=114423, rew={119971,2384,10}, mobs={[103540]=0}},     -- Steal Antidote // Gegengift stehlen
[422052]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206401]=5,[206402]=5}, giver=114423, rew={119971,2384,10}, mobs={[103539]=206401,[103541]=206402}},  -- Stolen Memory //
[422053]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206404]=5,[206405]=5}, giver=114424, rew={119971,2384,10}, mobs={[103548]=206405,[103503]=206404,[103549]=206404}},  -- Pie Filling // PastetenfÃ¼llung
[422112]= {typ= 4, lvl=57, rlvl=55, zone=15, items={[206406]=  1}, giver={112613,114424}, taker=114744, rew={119971,2384,10}},                     -- Love Pie Delivery // Liebespastetenlieferung
[422113]= {typ=11, lvl=57, rlvl=55, zone=15, items={[206407]=  5}, giver=114425, rew={119971,2384,10}, mobs={[103498]=0}},     -- Cutest Chupura // Die niedliche Chupura
[422857]= {typ= 4, lvl=57, rlvl=55, zone=15, items={[206868]= 10}, giver=114426, rew={119971,2384,10}},                        -- Collect Centaur Fortune Stones // Sammelt Zentauren-Glückssteine
[422858]= {typ= 2, lvl=57, rlvl=55, zone=15, giver=114426, rew={119971,2384,10}, mobs={[103549]=5,[103501]=5}},                -- Centaur Hunting // Zentaurenjagd
[422859]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[204016]= 5}, giver=114426, rew={119971,2384,10}, mobs={[103502]=0,[103501]=0}},   -- Beautiful Feathers // Schöne Federn
[421590]= {typ=22, lvl=57, rlvl=55, zone=15, giver=114744, rew={119971,2384,10}, mobs={[103104]=10}},                          -- Damn Marauding Bandits // Verdammte plündernde Banditen
[421591]= {typ=22, lvl=57, rlvl=55, zone=15, giver=114744, rew={119971,2384,10}, mobs={[103105]=10}},                          -- Leaving Hope // Hoffnung zurücklassen
[421592]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206758]= 10}, giver=114755, rew={119971,2384,10}, mobs={[103539]=0,[103541]=0}},  -- A Disgrace to the Armor of the Knights // Ritterrüstungs-Frevel
[421593]= {typ= 2, lvl=57, rlvl=55, zone=15, giver=114755, rew={119971,2384,10}, mobs={[103539]=5}},                           -- Untainted Memory // Unbefleckte Erinnerungen
[421273]= {typ= 4, lvl=57, rlvl=55, zone=15, items={[543687]=1,[543688]=1,[543689]=1,[543690]=1},giver=114420, rew={119971,2384,10}, preq=422984},  -- Daily Patrol // Tägliche Streife
[421274]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206392]=  5}, giver=114420, rew={119971,2384,10}, mobs={[103526]=0}, preq=422984},  -- Lost Wallets // Die verlorene Brieftasche
[421275]= {typ= 2, lvl=57, rlvl=55, zone=15, giver=114420, rew={119971,2384,10}, mobs={[103527]=10}, preq=422984},             -- Eliminate Evil Bandits // Schaltet die bösen Banditen aus.
[421276]= {typ= 1, lvl=57, rlvl=55, zone=15, items={[206393]=  5}, giver=114420, rew={119971,2384,10}, mobs={[103533]=0}, preq=422984},  -- Ferocious Giant Sewer Rats // Fürchterliche Riesen-Kanalratten
[421277]= {typ= 2, lvl=57, rlvl=55, zone=15, giver=114420, rew={119971,2384,10}, mobs={[103534]=5}, preq=422984},              -- Eliminate the Source of Sewer Odor // Die Quelle des Kanalisationsgeruchs ausschalten
--[[ ] ]]

--[[ [ Southern Janost Forest ]]
[422935]= {typ= 4, lvl=58, rlvl=56, zone=16, items={[207158]= 10}, giver=115027, rew={122793,2409,10}},                        -- Recipe for Jasmini No.5
[422940]= {typ= 1, lvl=58, rlvl=56, zone=16, items={[207165]= 10}, giver=115028, rew={122793,2409,10}, mobs={[103609]=0}},     -- Expensive Leather Clothes
[422938]= {typ= 1, lvl=58, rlvl=56, zone=16, items={[207171]= 10}, giver=115036, rew={122793,2409,10}, mobs={[103833]=0}},     -- Deadly Poison
[422944]= {typ= 1, lvl=58, rlvl=56, zone=16, items={[207163]= 10}, giver=115038, rew={122793,2409,10}, mobs={[103600]=0,[103601]=0}},  -- Hard Shells
[422943]= {typ= 4, lvl=58, rlvl=56, zone=16, items={[207170]= 10}, giver=115037, rew={122793,2409,10}},                        -- Scattered Timber
[422942]= {typ= 1, lvl=58, rlvl=56, zone=16, items={[207275]= 10}, giver=115037, rew={122793,2409,10}, mobs={[103604]=0,[103605]=0}},  -- The Unbearable Attack
[423215]= {typ= 4, lvl=58, rlvl=56, zone=16, items={[207168]= 10}, giver=115039, rew={122793,2409,10}},                        -- The staple food is Kado Taro
[422939]= {typ= 4, lvl=58, rlvl=56, zone=16, items={[207167]= 10}, giver=115039, rew={122793,2409,10}},                        -- Misty Grove's White Zoysia
[423218]= {typ= 4, lvl=58, rlvl=56, zone=16, items={[207164]= 10}, giver=115039, rew={122793,2409,10}},                        -- Fishing
[423216]= {typ= 1, lvl=58, rlvl=56, zone=16, items={[207169]= 10}, giver=115039, rew={122793,2409,10}, mobs={[103599]=0}},     -- Sharptooth Meat Preparation
[423217]= {typ= 4, lvl=58, rlvl=56, zone=16, items={[207187]= 10}, giver=115041, rew={122793,2409,10}},                        -- The Lost Kingdom
[423219]= {typ= 2, lvl=58, rlvl=56, zone=16, giver=115041, rew={122793,2409,10}, mobs={[103843]=10}},                          -- Graverobbers Punishment
[422941]= {typ= 1, lvl=58, rlvl=56, zone=16, items={[207166]= 10}, giver=115040, rew={122793,2409,10}, mobs={[103843]=0}},     -- Magnork Gold Coin
[423223]= {typ= 5, lvl=58, rlvl=56, zone=16, giver=115042, rew={147352,2409,10}},                                              -- Redemption
[423221]= {typ= 5, lvl=58, rlvl=56, zone=16, giver=115042, rew={229215,4819,10}},                                              -- Rescue
[423224]= {typ= 1, lvl=58, rlvl=56, zone=16, items={[207190]= 10}, giver=115042, rew={122793,2409,10}, mobs={[103837]=0,[103838]=0,[103850]=0}}, -- Heartless Demons
[423297]= {typ=21, lvl=58, rlvl=56, zone=16, items={[207417]= 10}, giver=115300, rew={122793,2409,10}, mobs={[103846]=0}},     -- Even More Lavender Sprigs //
[423298]= {typ=21, lvl=58, rlvl=56, zone=16, items={[207418]= 10}, giver=115300, rew={122793,2409,10}, mobs={[103847]=0}},     -- // Mehr Wäscheleinen
[423299]= {typ=21, lvl=58, rlvl=56, zone=16, items={[207419]= 10}, giver=115300, rew={122793,2409,10}, mobs={[103848]=0}},     -- // Noch mehr widerliche Insekten loswerden
--[[ ] ]]

--[[ [ Northern Janost Forest ]]
[422079]= {typ= 2, lvl=59, rlvl=57, zone=17, mobs= {[103988]=  5}, giver=115613, rew={127754,2424,10}},                        -- Pest Control Op
[422080]= {typ=24, lvl=59, rlvl=57, zone=17, items={[207432]=  7}, giver=115610, rew={127754,2424,10}, preq=423302},           -- Poisonous Frog Spawn Are Nutritious // Giftfroschlaich ist nahrhaft
[422081]= {typ=24, lvl=59, rlvl=57, zone=17, items={[207433]=  6}, giver=115610, rew={127754,2424,10}, preq=423302},           -- Incubation Is the Key // Das Ausbrüten ist der Schlüssel
[422898]= {typ= 4, lvl=59, rlvl=57, zone=17, items={[207434]=  5}, giver=115611, rew={127754,2424,10}, mobs={[103997]=0}},     -- Tasty Bloodwing Fruit Bats
[422899]= {typ= 4, lvl=59, rlvl=57, zone=17, items={[207435]=  5}, giver=115611, rew={127754,2424,10}},                        -- Effective Deterrent // Effektive Abschreckung
[422900]= {typ= 1, lvl=59, rlvl=57, zone=17, items={[207443]= 5, [207436]= 5}, giver=115611, rew={127754,2424,10}, mobs={[103983]=207443}},  -- Effective Anti-Itching Lotion
[422901]= {typ= 1, lvl=59, rlvl=57, zone=17, items={[207438]=  6}, giver=115612, rew={127754,2424,10}, mobs={[103981]=0}},     -- Chewy Thighs
[422902]= {typ= 1, lvl=59, rlvl=57, zone=17, items={[207439]=  5}, giver=115612, rew={127754,2424,10}, mobs={[103984]=0}},     -- Pukari Fur
[422903]= {typ= 1, lvl=59, rlvl=57, zone=17, items={[207440]=  5}, giver=115612, rew={127754,2424,10}, mobs={[103986]=0}},     -- The Grotesque Mask
[422904]= {typ= 1, lvl=59, rlvl=57, zone=17, items={[207446]= 10}, giver=115613, rew={127754,2424,10}, mobs={[103998]=0}},     -- Sharptooth Hunt
[422905]= {typ= 1, lvl=59, rlvl=57, zone=17, items={[207441]=  6}, giver=115613, rew={127754,2424,10}, mobs={[104000]=0}},     -- Delicious Python Meat // Köstliches Pythonfleisch
[422906]= {typ= 4, lvl=59, rlvl=57, zone=17, items={[207444]= 10}, giver=115613, rew={127754,2424,10}},                        -- Sparkly Moon Breath Grass
[422907]= {typ= 4, lvl=59, rlvl=57, zone=17, items={[207445]=  5}, giver=115614, rew={127754,2424,10}},                        -- Rare Orchid of Beauty
[422908]= {typ= 1, lvl=59, rlvl=57, zone=17, items={[207442]=  5}, giver=115614, rew={127754,2424,10}, mobs={[103988]=0}},     -- Rotwood Bug Acid
[422909]= {typ= 1, lvl=59, rlvl=57, zone=17, items={[207437]=  8}, giver=115614, rew={127754,2424,10}, mobs={[103980]=0}},     -- Dimstar Bolmu Poison
[422910]= {typ=32, lvl=59, rlvl=57, zone=17, mobs= {[104010]=  1}, giver=115613, rew={170339,3636,10}},                        -- Tötet den Riesenscharfzahn
[422911]= {typ=22, lvl=59, rlvl=57, zone=17, mobs= {[104149]= 10}, giver=115613, rew={127754,2424,10}},                        -- Feuerkraut ohne Ende
--[[ ] ]]

--[[ [ Limo desert (18) ]]
[423161]= {typ=24, lvl=61, rlvl=59, zone=18, items={[208089]=  8}, mobs={[116762]=0}, giver=116151, rew={138284,2445,10}},     -- // Brutplan
[423162]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208090]=  6}, mobs={[104286]=0}, giver=116151, rew={156722,2934,10}},     -- // Reichhaltige Ernährung
[423163]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208091]=  6}, mobs={[104296]=0}, giver=116151, rew={193597,3912,10}},     -- // Wüstenkönig-Ökosystem
[423164]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208082]=  8}, mobs={[104274]=0}, giver=116148, rew={156722,2934,10}},     -- // Diebesjagd
[423165]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208083]=  6}, mobs={[104273]=0}, giver=116148, rew={138284,2445,10}},     -- // Nicht einfach nur Steinsalz
[423166]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208084]=  8}, mobs={[104272]=0}, giver=116740, rew={147503,2690,10}},     -- // Schutz gegen Sandstürme
[423167]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208085]=  8}, mobs={[104278]=0}, giver=116149, rew={156722,2934,10}},     -- // Der Drache und das Mädchen
[423168]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208086]=  6}, mobs={[104282]=0}, giver=116150, rew={138284,2445,10}},     -- // Weg in den Himmel
[423169]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208087]=  6}, mobs={[104289]=0}, giver=116152, rew={175160,3423,10}},     -- // Das Geheimnis der Ruinen
[423170]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208088]=  6}, mobs={[104293]=0}, giver=116152, rew={156722,2934,10}},     -- // Zeichen der Verdammten
[423171]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208080]=  8}, mobs={[104263]=0}, giver=116146, rew={147503,2934,10}},     -- // Wassersparmaßnahmen
[423172]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208081]=  6}, mobs={[104264]=0}, giver=116147, taker=116146, rew={175160,3423,10}},    -- // Regungslos vor Hunger
[423173]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208092]=  6}, mobs={[104488]=0}, giver=116153, rew={138284,2445,10}, preq=423547},    -- // In heißen Quellen
[423174]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208093]=  8}, mobs={[104310]=0}, giver=116760, rew={147503,2934,10}},     -- // Erlebt ein Wunder
[423175]= {typ=21, lvl=61, rlvl=59, zone=18, items={[208094]=  6}, mobs={[104314]=0}, giver=116153, rew={138284,2445,10}, preq=423542},    -- // Beneidenswerte Stärke
[423674]= {typ=22, lvl=61, rlvl=59, zone=18, mobs= {[104262]= 10}, giver=116608, rew={138284,2445,10}},                        -- // Eine Lektion
[423486]= {typ=24, lvl=61, rlvl=59, zone=18, items={[208199]= 10}, mobs={[104286]=10}, giver=116398, taker=116400, rew={165941,2934,10}},  -- // Besonders köstliches Fleisch im Sand
[423487]= {typ=32, lvl=61, rlvl=59, zone=18, mobs= {[104487]=  1}, giver=116640, rew={368758,9782,15}},                              -- // Roter Dämon der Wüste
--[[ ] ]]

--[[ [ Tergothen Bay (21) ]]
[424424]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106073]=  5, [106074]=  5}, giver=119230, rew={189830,2796,10}, preq=424423},    -- Ease of Delivery // Einfache Lieferung
[424428]={typ=21, lvl=69, rlvl=67, zone=21, items={[240548]= 10}, giver=118980, rew={177174,2796,10}, preq=424427}, -- Collecting More // Mehr Korn
[424430]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[105908]= 10}, giver=118980, rew={189830,2796,10}, preq=424429},  -- Clean Out More Mutant Tree Frogs // Vernichtet mehr Mutierte Baumfrösche
[424432]={typ=21, lvl=67, rlvl=65, zone=21, items={[240550]= 10, [240551]=  6}, giver=118981, rew={187066,2841,10}, preq=424431},   -- Amden's Request // Amdens Forderung
[424434]={typ=21, lvl=69, rlvl=67, zone=21, items={[240340]= 10}, giver=119494, rew={177174,2796,10}},              -- A Rare Taste // Ein seltener Genuss
[424436]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106061]=  7, [106062]=  7}, giver=118980, rew={189830,2796,10}, preq=424435},    -- Eggs Can't Hatch Without the Nest // Wo kein Nest, da kein Ei
[424437]={typ=21, lvl=69, rlvl=67, zone=21, items={[240562]=  1}, giver=118981, rew={177174,2796,10}},              -- Giant Frog // Riesenfrosch
[424438]={typ=21, lvl=69, rlvl=67, zone=21, items={[240431]= 10}, giver=119449, rew={177174,2796,10}},              -- Pick Up the Pieces // Die Guten ins Töpfchen ...
[424443]={typ=21, lvl=69, rlvl=67, zone=21, items={[240558]= 10}, giver=119190, rew={189830,2796,10}, preq=424442}, -- Explore more Inscriptions // Untersucht weitere Inschriften
[424446]={typ=21, lvl=69, rlvl=67, zone=21, items={[240560]= 10}, giver=119191, rew={177174,2796,10}, preq=424445}, -- Placate the Tergothen Female Horned Beast // BesÃ¤nftigt das Tergothen-Hornbestienweibchen
[424447]={typ=21, lvl=69, rlvl=67, zone=21, items={[240596]= 10}, giver=119193, rew={177174,2796,10}},              -- Growth Potion for the Frogs Polluting Tergothen // Wachstumstrank für die Frösche von Tergothen
[424448]={typ=21, lvl=69, rlvl=67, zone=21, items={[240598]= 10}, giver=119192, rew={189830,2796,10}, preq=424427}, -- Polk Corn Research // Kermesmaisforschung
[424449]={typ=21, lvl=69, rlvl=67, zone=21, items={[240597]= 10}, giver=119081, taker=119086, rew={177174,2796,10}, preq=424514},   -- Unspeakable // Unaussprechlich
[424481]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[105957]= 10}, giver=118906, rew={189830,2796,10}},               -- Ruined Fish Net // Zerstörtes Fischernetz
[424482]={typ=21, lvl=69, rlvl=67, zone=21, items={[240229]= 10}, giver=118907, rew={202485,2796,10}},              -- Dealing with Stolen Fish // Gelegenheit macht Fischdiebe
[424483]={typ=21, lvl=69, rlvl=67, zone=21, items={[240526]= 10}, giver=118908, rew={202485,2796,10}},              -- Throwing Fish // Fischhandel
[424484]={typ=21, lvl=69, rlvl=67, zone=21, items={[240527]= 10}, giver=119120, rew={177174,2796,10}},              -- The Spirit of Food // Die Seele des Essens
[424485]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[105971]= 10}, giver=119048, rew={177174,2796,10}},               -- Cleaning the Fishing Boat is a Difficult Job // Ein Fischerboot zu reinigen ist nicht leicht
[424486]={typ=21, lvl=69, rlvl=67, zone=21, items={[240543]= 10, [240606]= 10}, giver=119076, rew={202485,2796,10}, preq=424498},   -- Obtain an Analysis Sample // Besorgt eine Analyseprobe
[424487]={typ=21, lvl=69, rlvl=67, zone=21, items={[240542]= 10}, giver=119045, rew={177174,2796,10}, preq=424493}, -- Favorite Food // Lieblingsspeise
[424488]={typ=21, lvl=69, rlvl=67, zone=21, items={[240591]= 10}, giver=119153, rew={202485,2796,10}, preq=424476}, -- The Other Side of the Cave // Auf der anderen Seite des Käfigs
[424489]={typ=21, lvl=69, rlvl=67, zone=21, items={[240594]= 10}, giver=119157, rew={202485,2796,10}, preq=424501}, -- Beacon of Light // Leuchtfeuer
[424490]={typ=21, lvl=69, rlvl=67, zone=21, items={[240592]= 10}, giver=119168, rew={177174,2796,10}},              -- Rush of Beach Treasures // Jagd nach Strandschätzen
[424563]={typ=21, lvl=69, rlvl=67, zone=21, items={[545536]=  1}, giver=119231, rew={177174,2796,10}, preq=424425}, -- Bodyguard of Fishing Goods // WÃ¤chter der Fischwaren
[424565]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106079]= 10}, giver=119233, rew={189830,2796,10}, preq=424564},  -- Maintain Privacy // Schutz der Privatsphäre
[424581]={typ=21, lvl=69, rlvl=67, zone=21, items={[240653]= 10}, giver=119053, rew={202485,2796,10}, preq=424569}, -- An Even More Mysterious Power // Eine noch mysteriösere Macht
[424582]={typ=21, lvl=69, rlvl=67, zone=21, items={[240654]= 10}, giver=119131, rew={202485,2796,10}, preq=424567}, -- For More Materials // FÃ¼r mehr Rohstoffe
[424583]={typ=21, lvl=69, rlvl=67, zone=21, items={[240655]= 20}, giver=119132, rew={202485,2796,10}, preq=424479}, -- Ekan Nors' Gift // Ekan Nors' Geschenk
[424584]={typ=21, lvl=69, rlvl=67, zone=21, items={[240656]=  5}, giver=119055, rew={202485,2796,10}, preq=424568}, -- Bart's Commission // Barts Auftrag
[424585]={typ=21, lvl=69, rlvl=67, zone=21, items={[240282]= 10}, giver=119065, rew={202485,2796,10}, preq=424620}, -- Reason for the Animal Mutations // Die Ursache für die mutierten Tiere
[424586]={typ=21, lvl=69, rlvl=67, zone=21, items={[240657]= 10}, giver=119133, rew={202485,2796,10}, preq=424572}, -- Dangerous Dye // GefÃ¤hrlicher Farbstoff
[424587]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106060]= 10}, giver=119059, rew={189830,2796,10}, preq=424572},  -- Annoying Noise // LÃ¤rmbelÃ¤stigung
[424588]={typ=21, lvl=69, rlvl=67, zone=21, items={[240658]= 10}, giver=119134, rew={202485,2796,10}, preq=424572}, -- Troublesome Building Materials // Viel Mühe um Baumaterial
[424589]={typ=21, lvl=69, rlvl=67, zone=21, items={[240659]= 10}, giver=119064, rew={202485,2796,10}, preq=424572}, -- The Best Tonic // Das beste Tonikum
[424590]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[105996]= 10, [105997]=  5}, giver=119149, rew={189830,2796,10}, preq=424572},    -- The Fishermen's Trouble // Das Problem der Fischer
[424591]={typ=21, lvl=69, rlvl=67, zone=21, items={[240629]= 10}, giver=119234, rew={202485,2796,10}, preq=424566}, -- Heart of the Ocean // Herz des Ozeans
[424593]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106079]= 10}, giver=119235, rew={189830,2796,10}, preq=424592},  -- Eager Protection // Eifriger Schutz
[424625]={typ=21, lvl=69, rlvl=67, zone=21, items={[240634]=  1}, mobs={[106117]= 10}, giver=119236, rew={189830,2796,10}, preq=424594},    -- Being Prepared // Seid vorbereitet
[424627]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106118]= 10}, giver=119237, rew={202485,2796,10}, preq=424626},  -- Using Natural Enemies // Benutzt natÃ¼rliche Feinde
[424629]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106075]= 10}, giver=119238, rew={189830,2796,10}, preq=424628},  -- Pets Forbidden Inside // Haustiere verboten
[424631]={typ=21, lvl=69, rlvl=67, zone=21, items={[240636]=  5}, giver=119238, rew={202485,2796,10}, preq=424630}, -- It's just picking up a Nest Crystal... // Einfach nur Nest-Kristalle sammeln ...
[424633]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106121]=  5}, giver=119241, rew={202485,2796,10}, preq=424632},  -- Equipment Replacement // Ersatzapparat
[424635]={typ=21, lvl=69, rlvl=67, zone=21, items={[240630]=  5}, giver=119234, rew={189830,2796,10}, preq=424634}, -- Acting Props // Requisiten
--[[ ] ]]

--[[ [ Rorazon (22) ]]
[424605]={typ=21, lvl=71, rlvl=69, zone=22, items={[240847]= 10}, giver=119360, rew={0,0,0,100}},   -- Elf Medicine // Elfenmedizin
[424606]={typ=21, lvl=71, rlvl=69, zone=22, items={[240851]= 10}, giver=119363, rew={0,0,0,235}},   -- Guardian Energy Core // WÃ¤chter-Energiekern
[424607]={typ=21, lvl=71, rlvl=69, zone=22, items={[240853]=  1, [240855]=  1, [240854]=  1}, giver=119726, rew={0,0,0,150}, preq=424930},  -- Investigator's Report // Bericht des Ermittlers
[424608]={typ=21, lvl=71, rlvl=69, zone=22, items={[240856]= 10}, giver=119917, rew={0,0,0,200}, preq=424957},  -- Resource Disappearance // Ressourcenschwund
[424609]={typ=21, lvl=71, rlvl=69, zone=22, items={[545867]=  1}, giver=119917, rew={0,0,0,30}},    -- Energy Detection // Energie-Entdeckung
[424666]={typ=22, lvl=69, rlvl=67, zone=0, mobs={[103003]=  3}, giver=0, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,80}}, -- Give them out to the residents // Gebt sie den Bewohnern
[422665]={typ=21, lvl=56, rlvl=54, zone=0, items={[205918]= 10}, giver=0, GIVER_MIGHT_BE_INVALID=1, rew={117619,2331,10}},  -- Plundering Supplies // VorrÃ¤te plÃ¼ndern
[420619]={typ=21, lvl=48, rlvl=47, zone=3, items={[202002]=  5, [203709]=  5}, giver={112262, 112562}, taker=112267, rew={46498,2198,10}, preq=421796}, -- Ailic's Community // Ailics Gemeinschaft
[424768]={typ=21, lvl=71, rlvl=69, zone=22, items={[240766]=  1}, giver=119727, rew={0,0,0,300}},   -- Reinstallation of Recording Equipment // Neuinstallation der MessgerÃ¤te
[424769]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106377]= 10}, giver=119923, rew={0,0,0,230}},    -- Keep Slowing Down the Production Process // Verlangsamt weiterhin den Herstellungsprozess
[424770]={typ=21, lvl=71, rlvl=69, zone=22, items={[240979]=  5, [240825]=  5, [240978]=  5}, giver=119616, rew={0,0,0,230}},   -- Research the Strange Ore // Erforscht das seltsame Erz
[424772]={typ=21, lvl=71, rlvl=69, zone=22, items={[240751]=  5, [240752]=  5}, giver=119727, taker=119613, rew={0,0,0,150}, preq=424768},  -- Piping Hot Lunch // Kochend heiÃŸes Mittagessen
[424778]={typ=21, lvl=71, rlvl=69, zone=22, items={[545877]=  1, [240756]=  1, [240755]=  1, [545876]=  1}, giver=119605, rew={301367,2805,10}, preq=424775},   -- Experiment Materials // Experiment-Materialien
[424780]={typ=21, lvl=71, rlvl=68, zone=22, items={[240297]= 10}, giver=119680, rew={273970,2805,10}, preq=424812}, -- Fire Flower // Feuerblume
[424781]={typ=21, lvl=71, rlvl=69, zone=22, items={[240296]=  1}, giver=119680, taker=119612, rew={273970,2805,10}, preq=424780},  -- Fireproof Potion // FeuerbestÃ¤ndiger Trank
[424825]={typ=21, lvl=71, rlvl=69, zone=22, items={[545798]=  1}, giver=119650, taker=119651, rew={273970,2805,10}, preq=424824},   -- Continue to Escort the Injured // Weiterhin sicheres Geleit fÃ¼r die Verletzten
[424826]={typ=21, lvl=71, rlvl=69, zone=22, items={[545798]=  1}, giver=119650, taker=119651, rew={0,0,0,300}, preq=424824},    -- Continue to Escort the Injured // Weiterhin sicheres Geleit fÃ¼r die Verletzten
[424838]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106438]=  5}, giver=119652, rew={0,0,0,20}, preq=424827},    -- Continue to Save the Wounded // Mehr Verletzte retten
[424839]={typ=21, lvl=71, rlvl=69, zone=22, items={[240877]=  5, [240878]=  5}, giver=119653, rew={0,0,0,330}, preq=424828},    -- Accelerated Speed // ErhÃ¶hte Geschwindigkeit
[424840]={typ=21, lvl=71, rlvl=69, zone=22, items={[240879]=  5}, giver=119656, rew={0,0,0,150}, preq=424829},  -- Even More Red Flame Grass // Noch mehr Rotflammengras
[424841]={typ=21, lvl=71, rlvl=69, zone=22, items={[240880]=  5}, giver=119664, rew={0,0,0,60}, preq=424830},   -- Bring some more fresh ones! // Bringt noch ein paar frische GrÃ¤ser!
[424842]={typ=21, lvl=71, rlvl=69, zone=22, items={[545799]=  1, [545801]=  1, [545800]=  1, [545802]=  1}, giver=119682, rew={0,0,0,130}, preq=424831},    -- Be More Vigilant // Noch wachsamer sein
[424843]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106439]= 10}, giver=119928, rew={0,0,0,300}, preq=424832},   -- Still a Mess // Immer noch Chaos
[424844]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106440]=  5, [106472]=  5}, giver=119666, rew={0,0,0,55}, preq=424833},  -- Help Again with Equipment Repair // Noch einmal bei der Reparatur der AusrÃ¼stung helfen
[424845]={typ=21, lvl=71, rlvl=69, zone=22, items={[240885]= 10}, giver=119666, rew={0,0,0,150}, preq=424834},  -- Even More Sturdy Wood // Noch stabileres Holz
[424846]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106510]= 10}, giver=119934, rew={0,0,0,300}, preq=424835},   -- Continue to Consolidate Forces // Die KrÃ¤fte weiter bÃ¼ndeln
[424847]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106441]=  5}, giver=119730, rew={0,0,0,100}, preq=424836},   -- Secret Weapon Modification // Modifikation der Geheimwaffe
[424848]={typ=21, lvl=71, rlvl=69, zone=22, items={[240887]= 10}, giver=119730, rew={0,0,0,83}, preq=424837},   -- More Mutual Benefits // Weiterer gegenseitiger Nutzen
[424849]={typ=21, lvl=71, rlvl=69, zone=22, items={[240886]=  1}, giver=119730, taker=119937, rew={0,0,0,120}, preq=424850},    -- Continue to Meet Each Other's Needs // Weiter gegenseitig BedÃ¼rfnisse erfÃ¼llen
[424860]={typ=21, lvl=71, rlvl=69, zone=22, items={[240338]=  1}, giver=119605, rew={0,0,0,780}, preq=424777},  -- More Magical Feathers // Mehr magische Federn
[424861]={typ=21, lvl=71, rlvl=69, zone=22, items={[546252]=  1, [240756]=  1, [240755]=  1, [546253]=  1}, giver=119605, rew={0,0,0,780}, preq=424775},    -- Experiment Materials // Experiment-Materialien
[424863]={typ=21, lvl=70, rlvl=68, zone=22, items={[240297]= 10}, giver=119680, rew={0,0,0,70}, preq=424812},   -- Fire Flower // Feuerblume
[424864]={typ=21, lvl=71, rlvl=69, zone=22, items={[240296]=  1}, giver=119680, taker=119612, rew={0,0,0,70}, preq=424863},    -- Fireproof Potion // FeuerbestÃ¤ndiger Trank
[424865]={typ=21, lvl=71, rlvl=69, zone=22, items={[240337]=  1}, giver=119605, rew={315065,2805,10}, preq=424777}, -- More Magical Feathers // Mehr magische Federn
[424866]={typ=21, lvl=71, rlvl=69, zone=22, items={[240766]=  1}, giver=119727, rew={273970,2805,10}},  -- Setup of Recording Equipment // Aufstellen der Aufzeichnungsinstrumente
[424867]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106377]= 10}, giver=119923, rew={273970,2805,10}},   -- Slowing Down the Production Process // Verlangsamt den Herstellungsprozess
[424868]={typ=21, lvl=71, rlvl=69, zone=22, items={[240979]=  5, [240825]=  5, [240978]=  5}, giver=119616, rew={273970,2805,10}},  -- Research the Strange Ore // Erforscht das seltsame Erz
[424870]={typ=21, lvl=71, rlvl=69, zone=22, items={[240751]=  5, [240752]=  5}, giver=119727, taker=119613, rew={273970,2805,10}, preq=424866}, -- Piping Hot Lunch // Kochend heiÃŸes Mittagessen
[424878]={typ=21, lvl=70, rlvl=68, zone=22, items={[240032]=  5}, giver=119635, rew={0,0,0,100}, preq=424871},  -- Secret Worries of the Forest // Geheime Sorgen des Waldes
[424879]={typ=21, lvl=70, rlvl=68, zone=22, items={[240754]= 10}, giver=119635, rew={0,0,0,83}, preq=424872},   -- Self-Sufficiency // Selbstversorgung
[424880]={typ=21, lvl=70, rlvl=68, zone=22, items={[240786]=  5}, giver=119646, rew={0,0,0,90}, preq=424873},   -- Calm Heart // Gelassenheit
[424881]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106368]=  3}, giver=119647, rew={0,0,0,100}, preq=424874},   -- Suffering Spirits // Notleidende Geister
[424882]={typ=21, lvl=70, rlvl=68, zone=22, items={[240790]=  1}, giver=119634, rew={0,0,0,150}, preq=424875},  -- Affected Earth // Betroffene Erde
[424884]={typ=21, lvl=71, rlvl=68, zone=22, items={[240032]=  5}, giver=119635, rew={273970,2805,10}, preq=424871}, -- Secret Worries of the Forest // Geheime Sorgen des Waldes
[424885]={typ=21, lvl=71, rlvl=68, zone=22, items={[240754]= 10}, giver=119635, rew={273970,2805,10}, preq=424872}, -- Self-Sufficiency // Selbstversorgung
[424886]={typ=21, lvl=71, rlvl=68, zone=22, items={[240786]=  5}, giver=119646, rew={273970,2805,10}, preq=424873}, -- Calm Heart // Gelassenheit
[424887]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106368]=  3}, giver=119647, rew={273970,2805,10}, preq=424874},  -- Suffering Spirits // Notleidende Geister
[424888]={typ=21, lvl=71, rlvl=68, zone=22, items={[240790]=  1}, giver=119634, rew={273970,2805,10}, preq=424875}, -- Affected Earth // Betroffene Erde
[424907]={typ=21, lvl=71, rlvl=68, zone=22, items={[241030]= 10}, giver=119625, rew={273970,2805,10}, preq=424894}, -- Starting With Food // Mit dem Essen beginnen
[424908]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106402]=  5}, giver=119625, rew={273970,2805,10}, preq=424894},  -- Provide Calming Power // Beruhigende Energie liefern
[424909]={typ=21, lvl=71, rlvl=68, zone=22, items={[241031]=  5}, giver=119625, rew={273970,2805,10}, preq=424894}, -- Scorched Earth // Verbrannte Erde
[424910]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[100394]=  5}, giver=119625, rew={273970,2805,10}, preq=424894},  -- Random Fires // WillkÃ¼rliche Feuer
[424911]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106637]=  3}, giver=119625, rew={273970,2805,10}, preq=424894},  -- Boundaries // Schneise
[424912]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106415]= 10}, giver=119627, rew={273970,2805,10}, preq=424899},  -- Affected Spirits // Betroffene Geister
[424913]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106420]= 10}, giver=119627, rew={273970,2805,10}, preq=424899},  -- The Spirits' Way Out // Der Ausweg der Geister
[424914]={typ=21, lvl=71, rlvl=68, zone=22, items={[241024]= 10}, giver=119627, rew={273970,2805,10}, preq=424899}, -- Flame Messenger // Flammenbote
[424915]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106398]= 10}, giver=119631, rew={273970,2805,10}, preq=424906},  -- Clean the Gatefront // Reinigt die Front des Tores
[424916]={typ=21, lvl=71, rlvl=68, zone=22, items={[241033]=  1, [241032]=  1, [241034]=  1}, giver=119631, rew={273970,2805,10}, preq=424906}, -- Investigate the Great Gate // Untersuchung des GroÃŸen Tors
[424917]={typ=21, lvl=71, rlvl=68, zone=22, items={[241027]=  5}, giver=119631, rew={273970,2805,10}, preq=424906}, -- Rock Samples // Gesteinsproben
[424918]={typ=21, lvl=71, rlvl=68, zone=22, items={[241028]= 10}, giver=119631, rew={273970,2805,10}, preq=424906}, -- Energy Source // Energiequelle
[424919]={typ=21, lvl=71, rlvl=69, zone=22, items={[545835]=  1}, giver=119731, rew={273970,2805,10}, preq=424782}, -- Find an Ailic's Researcher // Einen Ailics Forscher finden
[424931]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106375]=  5, [106376]=  5}, giver=119727, rew={0,0,0,235}, preq=424930}, -- Clean Up Operations // ReinigungsmaÃŸnahmen
[424932]={typ=21, lvl=71, rlvl=69, zone=22, items={[240857]=  5}, giver=119950, rew={0,0,0,150}, preq=424957},  -- Components Scavenger // Teilesammler
[424933]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106452]=  5, [106426]=  5}, giver=119951, rew={0,0,0,200}, preq=424921}, -- Keep on Wrecking // Weitere ZerstÃ¶rung
[424934]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106374]= 10}, giver=119951, rew={0,0,0,235}, preq=424923},   -- Disrupting Energy Supply // Unterbrochene Energieversorgung
[424935]={typ=21, lvl=71, rlvl=69, zone=22, items={[240891]=  5, [240892]=  5}, giver=119923, rew={0,0,0,200}}, -- Components War // Krieg um Bauteile
[424936]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106425]= 10}, giver=119951, rew={0,0,0,200}, preq=424924},   -- Cutting Repair Lines // Reparaturnachschub verhindern
[424937]={typ=21, lvl=71, rlvl=69, zone=22, items={[240893]= 10}, giver=119950, rew={0,0,0,235}, preq=424957},  -- Interceptor Plans // AbfÃ¤ngerplÃ¤ne
[424938]={typ=21, lvl=71, rlvl=69, zone=22, items={[240862]=  1, [240861]=  1, [240860]=  1}, giver=119950, rew={0,0,0,150}, preq=424957},  -- Rejected Blueprints // Abgelehnte PlÃ¤ne
[424942]={typ=21, lvl=71, rlvl=69, zone=22, items={[240817]= 10}, giver=119360, rew={273970,2805,10}},  -- For the Forest's Future // FÃ¼r die Zukunft des Waldes
[424943]={typ=11, lvl=71, rlvl=69, zone=22, items={[240818]=  5, [240819]=  5}, giver=119362, rew={273970,2805,10}},    -- Spell Components // Komponenten des Zaubers
[424944]={typ=21, lvl=71, rlvl=69, zone=22, items={[545807]=  1}, giver=119363, taker=119730, rew={273970,2805,10}},    -- Energy Transfer // Energietransfer
[424945]={typ=21, lvl=71, rlvl=69, zone=22, items={[240821]= 10}, giver=119364, rew={273970,2805,10}},  -- Adventurer's Little Helper // Kleiner Helfer fÃ¼r Abenteurer
[424946]={typ=11, lvl=71, rlvl=69, zone=22, items={[240822]= 10}, giver=119362, rew={273970,2805,10}},  -- Ingredients Sweep // Zutatensuche
[424947]={typ=21, lvl=71, rlvl=69, zone=22, items={[240823]= 10}, giver=119725, rew={273970,2805,10}},  -- Detoxifying Smelly Fish Grass // Entgiftendes Stinkefischgras
[424948]={typ=21, lvl=71, rlvl=69, zone=22, items={[240824]= 10}, giver=119721, rew={273970,2805,10}},  -- Maintaining Camp Security // Sorge um die Sicherheit des Lagers
[424949]={typ=21, lvl=71, rlvl=69, zone=22, items={[240825]= 10}, giver=119722, rew={273970,2805,10}},  -- Using Minerals // Verwendung von Mineralien
[424950]={typ=31, lvl=71, rlvl=69, zone=22, items={[545808]=  1, [545812]=  1, [545809]=  1, [545810]=  1, [545811]=  1}, giver=119722, rew={273970,2805,10}, preq=424930}, -- The Hrodnor List // Die Hrodnor-Liste
[424985]={typ=22, lvl=71, rlvl=1, zone=22, mobs={[106518]= 10}, giver=119682, rew={273970,2805,10}, preq=424995},   -- Concerned Note // Besorgte Notiz
[424986]={typ=22, lvl=71, rlvl=1, zone=22, mobs={[106364]= 10}, giver=120042, rew={273970,2805,10}, preq=424996},   -- Pulling Weeds // Unkraut jÃ¤ten
[424990]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106518]= 10}, giver=119682, rew={0,0,0,150}, preq=424995},   -- Concerned Note // Besorgte Notiz
[424991]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106364]= 10}, giver=120042, rew={0,0,0,250}, preq=424996},   -- Pulling Weeds // Unkraut jÃ¤ten
[425001]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106438]=  5}, giver=119652, rew={273970,2805,10}, preq=424827},  -- Continue to Save the Wounded // Mehr Verletzte retten
[425002]={typ=21, lvl=71, rlvl=69, zone=22, items={[240877]=  5, [240878]=  5}, giver=119653, rew={273970,2805,10}, preq=424828},   -- Accelerated Speed // ErhÃ¶hte Geschwindigkeit
[425003]={typ=21, lvl=71, rlvl=69, zone=22, items={[240879]=  5}, giver=119656, rew={273970,2805,10}, preq=424829}, -- Even More Red Flame Grass // Noch mehr Rotflammengras
[425004]={typ=21, lvl=71, rlvl=69, zone=22, items={[240880]=  5}, giver=119664, rew={273970,2805,10}, preq=424830}, -- Bring some more fresh ones! // Bringt noch ein paar frische GrÃ¤ser!
[425005]={typ=21, lvl=71, rlvl=69, zone=22, items={[545799]=  1, [545801]=  1, [545800]=  1, [545802]=  1}, giver=119682, rew={273970,2805,10}, preq=424831},   -- Be More Vigilant // Noch wachsamer sein
[425006]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106439]= 10}, giver=119928, rew={273970,2805,10}, preq=424832},  -- Still a Mess // Immer noch Chaos
[425007]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106440]=  5, [106472]=  5}, giver=119666, rew={273970,2805,10}, preq=424833},    -- Help Again with Equipment Repair // Noch einmal bei der Reparatur der AusrÃ¼stung helfen
[425008]={typ=21, lvl=71, rlvl=69, zone=22, items={[240885]= 10}, giver=119666, rew={273970,2805,10}, preq=424834}, -- Even More Sturdy Wood // Noch stabileres Holz
[425009]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106510]= 10}, giver=119934, rew={273970,2805,10}, preq=424835},  -- Continue to Consolidate Forces // Die KrÃ¤fte weiter bÃ¼ndeln
[425010]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106441]=  5}, giver=119730, rew={273970,2805,10}, preq=424836},  -- Secret Weapon Modifications // Modifikation der Geheimwaffe
[425011]={typ=21, lvl=71, rlvl=69, zone=22, items={[240887]= 10}, giver=119730, rew={273970,2805,10}, preq=424837}, -- More Mutual Benefits // Weiterer gegenseitiger Nutzen
[425012]={typ=25, lvl=71, rlvl=69, zone=22, giver=119730, taker=119937, rew={273970,2805,10}, preq=424850}, -- Continue to Meet Each Other's Needs // Weiter gegenseitig BedÃ¼rfnisse erfÃ¼llen
[425121]={typ=21, lvl=71, rlvl=68, zone=22, items={[545795]=  1}, giver=119872, rew={273970,2805,10}, preq=425101}, -- Standard Procedure // Standardverfahren
[425122]={typ=21, lvl=71, rlvl=68, zone=22, items={[545791]=  1}, giver=119872, rew={273970,2805,10}, preq=425102}, -- Mission Delivery // MissionserfÃ¼llung
[425123]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106478]= 10}, giver=119857, rew={273970,2805,10}, preq=425103},  -- Unique Environment // Einzigartige Umgebung
[425124]={typ=23, lvl=71, rlvl=68, zone=22, items={[545792]=  1}, giver=119856, rew={273970,2805,10}, preq=425104}, -- Demonstration Battle // Schaukampf
[425125]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106423]= 10}, giver=119862, rew={273970,2805,10}, preq=425105},  -- Another Battlefield // Ein anderes Schlachtfeld
[425126]={typ=21, lvl=71, rlvl=68, zone=22, items={[545793]=  1}, giver=119860, rew={273970,2805,10}, preq=425106}, -- The Real Situation // Die wahre Lage
[425127]={typ=21, lvl=71, rlvl=68, zone=22, items={[545794]=  1}, giver=119862, rew={273970,2805,10}, preq=425107}, -- Too Busy To Eat or Sleep // Keine Zeit zum Essen und Schlafen
[425128]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106424]= 10}, giver=120071, rew={273970,2805,10}, preq=425108},  -- Unbearable Heat // UnertrÃ¤gliche Hitze
[425129]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106501]= 10}, giver=120072, rew={273970,2805,10}, preq=425109},  -- Take Good Care // Gute Pflege
[425130]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106502]= 10}, giver=120073, rew={273970,2805,10}, preq=425110},  -- Air Raid Warning // Luftalarm
[425131]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106503]= 10}, giver=119858, rew={273970,2805,10}, preq=425111},  -- Seed of Life // Samen des Lebens
[425132]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106504]= 10}, giver=119858, rew={273970,2805,10}, preq=425112},  -- Moderation // MÃ¤ÃŸigung
[425133]={typ=21, lvl=71, rlvl=68, zone=22, items={[240909]= 10}, giver=119873, rew={273970,2805,10}, preq=425113}, -- Water of Blessing // Segenswasser
[425134]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106505]= 10}, giver=119858, rew={273970,2805,10}, preq=425114},  -- Camp Security // Sicherheit des Lagers
[425135]={typ=21, lvl=71, rlvl=68, zone=22, items={[240955]= 10}, giver=119732, rew={273970,2805,10}, preq=425115}, -- Prisoner Battle // Kampf der Gefangenen
[425136]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106466]= 10}, giver=119946, taker=119871, rew={273970,2805,10}, preq=425116},    -- Next Time Will Be Better // NÃ¤chstes Mal wird es besser
[425137]={typ=22, lvl=71, rlvl=68, zone=22, mobs={[106506]= 10}, giver=119733, rew={273970,2805,10}, preq=425117},  -- Prison // GefÃ¤ngnis
[425138]={typ=21, lvl=71, rlvl=68, zone=22, items={[240967]= 10}, giver=119871, rew={273970,2805,10}, preq=425118}, -- Self Reliance // EigenstÃ¤ndigkeit
[425141]={typ=21, lvl=70, rlvl=68, zone=22, items={[545795]=  1}, giver=119872, rew={0,0,0,80}, preq=425101},   -- Standard Procedure // Standardverfahren
[425142]={typ=21, lvl=70, rlvl=68, zone=22, items={[545791]=  1}, giver=119872, rew={0,0,0,100}, preq=425102},  -- Mission Delivery // MissionserfÃ¼llung
[425143]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106478]= 10}, giver=119857, rew={0,0,0,330}, preq=425103},   -- Unique Environment // Einzigartige Umgebung
[425144]={typ=23, lvl=70, rlvl=68, zone=22, items={[545792]=  1}, giver=119856, rew={0,0,0,25}, preq=425104},   -- Demonstration Battle // Schaukampf
[425145]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106423]= 10}, giver=119862, rew={0,0,0,120}, preq=425105},   -- Another Battlefield // Ein anderes Schlachtfeld
[425146]={typ=21, lvl=70, rlvl=68, zone=22, items={[545793]=  1}, giver=119860, rew={0,0,0,150}, preq=425106},  -- The Real Situation // Die wahre Lage
[425147]={typ=21, lvl=70, rlvl=68, zone=22, items={[545794]=  1}, giver=119862, rew={0,0,0,100}, preq=425107},  -- Too Busy To Eat or Sleep // Keine Zeit zum Essen und Schlafen
[425148]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106424]= 10}, giver=120071, rew={0,0,0,75}, preq=425108},    -- Unbearable Heat // UnertrÃ¤gliche Hitze
[425149]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106501]= 10}, giver=120072, rew={0,0,0,160}, preq=425109},   -- Take Good Care // Gute Pflege
[425150]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106502]= 10}, giver=120073, rew={0,0,0,80}, preq=425110},    -- Air Raid Warning // Luftalarm
[425151]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106503]= 10}, giver=119858, rew={0,0,0,150}, preq=425111},   -- Seed of Life // Samen des Lebens
[425152]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106504]= 10}, giver=119858, rew={0,0,0,100}, preq=425112},   -- Moderation // MÃ¤ÃŸigung
[425153]={typ=21, lvl=70, rlvl=68, zone=22, items={[240909]= 10}, giver=119873, rew={0,0,0,100}, preq=425113},  -- Water of Blessing // Segenswasser
[425154]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106505]= 10}, giver=119858, rew={0,0,0,150}, preq=425114},   -- Camp Security // Sicherheit des Lagers
[425155]={typ=21, lvl=70, rlvl=68, zone=22, items={[240955]= 10}, giver=119732, rew={0,0,0,330}, preq=425115},  -- Prisoner Battle // Kampf der Gefangenen
[425156]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106466]= 10}, giver=119946, taker=119871, rew={0,0,0,330}, preq=425116}, -- Next Time Will Be Better // NÃ¤chstes Mal wird es besser
[425157]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106506]= 10}, giver=119733, rew={0,0,0,150}, preq=425117},   -- Prison // GefÃ¤ngnis
[425158]={typ=21, lvl=70, rlvl=68, zone=22, items={[240967]= 10}, giver=119871, rew={0,0,0,83}, preq=425118},   -- Self Reliance // EigenstÃ¤ndigkeit
[425178]={typ=21, lvl=70, rlvl=68, zone=22, items={[545835]=  1}, giver=119731, rew={0,0,0,25}, preq=424782},   -- Find an Ailic's Researcher // Einen Ailics Forscher finden
[425179]={typ=21, lvl=70, rlvl=68, zone=22, items={[240757]=  1, [240761]=  2, [240758]=  1, [240760]=  2}, giver=119732, rew={0,0,0,100}, preq=424783},    -- Further Rune Study // Weiteres Runenstudium
[425180]={typ=21, lvl=70, rlvl=68, zone=22, items={[545787]=  1}, giver=119946, rew={0,0,0,160}, preq=424784},  -- Sleepwalk Again // Wieder schlafwandeln
[425181]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106457]=  3, [106458]=  3}, giver=119733, rew={0,0,0,50}, preq=424785},  -- Heart of Nature and Life // Das Herz der Natur und des Lebens
[425182]={typ=22, lvl=70, rlvl=68, zone=22, mobs={[106454]=  3}, giver=119733, rew={0,0,0,100}, preq=424786},   -- Extinguish More Flames // LÃ¶scht mehr Flammen
[425183]={typ=21, lvl=71, rlvl=69, zone=22, items={[240757]=  1, [240761]=  2, [240758]=  1, [240760]=  2}, giver=119732, rew={273970,2805,10}, preq=424783},   -- Further Rune Study // Weiteres Runenstudium
[425184]={typ=21, lvl=71, rlvl=69, zone=22, items={[545787]=  1}, giver=119946, rew={273970,2805,10}, preq=424784}, -- Sleepwalk Again // Wieder schlafwandeln
[425185]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106457]=  3, [106458]=  3}, giver=119733, rew={273970,2805,10}, preq=424785},    -- Heart of Nature and Life // Das Herz der Natur und des Lebens
[425186]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106454]=  3}, giver=119733, rew={273970,2805,10}, preq=424786},  -- Extinguish More Flames // LÃ¶scht mehr Flammen
[425190]={typ=21, lvl=71, rlvl=69, zone=22, items={[241030]= 10}, giver=119625, rew={0,0,0,70}, preq=424894},   -- Starting With Food // Mit dem Essen beginnen
[425191]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106402]= 10}, giver=119625, rew={0,0,0,70}, preq=424894},    -- Provide Calming Power // Beruhigende Energie liefern
[425192]={typ=21, lvl=71, rlvl=69, zone=22, items={[241031]=  5}, giver=119625, rew={0,0,0,80}, preq=424894},   -- Scorched Earth // Verbrannte Erde
[425193]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[100394]=  5}, giver=119625, rew={0,0,0,70}, preq=424894},    -- Random Fires // WillkÃ¼rliche Feuer
[425194]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106637]=  3}, giver=119625, rew={0,0,0,50}, preq=424894},    -- Boundaries // Schneise
[425195]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106415]= 10}, giver=119627, rew={0,0,0,100}, preq=424899},   -- Affected Spirits // Betroffene Geister
[425196]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106420]= 10}, giver=119627, rew={0,0,0,100}, preq=424899},   -- The Spirits' Way Out // Der Ausweg der Geister
[425197]={typ=21, lvl=71, rlvl=69, zone=22, items={[241024]= 10}, giver=119627, rew={0,0,0,110}, preq=424899},  -- Flame Messenger // Flammenbote
[425198]={typ=22, lvl=71, rlvl=69, zone=22, mobs={[106398]= 10}, giver=119631, rew={0,0,0,100}, preq=424906},   -- Clean the Gatefront // Reinigt die Front des Tores
[425199]={typ=21, lvl=71, rlvl=69, zone=22, items={[241033]=  1, [241032]=  1, [241034]=  1}, giver=119631, rew={0,0,0,90}, preq=424906},   -- Investigate the Great Gate // Untersuchung des GroÃŸen Tors
[425200]={typ=21, lvl=71, rlvl=69, zone=22, items={[241027]=  5}, giver=119631, rew={0,0,0,80}, preq=424906},   -- Rock Samples // Gesteinsproben
[425201]={typ=21, lvl=71, rlvl=69, zone=22, items={[241028]= 10}, giver=119631, rew={0,0,0,100}, preq=424906},  -- Energy Source // Energiequelle

[424779]={typ=21, lvl=71, rlvl=69, zone=-1, items={[546247]=1}, giver=119606, taker=119605, rew={287668,2805,10}, preq=424774},   -- Massive Guard // Gewaltiger Wächter
[424862]={typ=21, lvl=71, rlvl=69, zone=-1, items={[546254]=1}, giver=119606, taker=119605, rew={0,0,0,780}, preq=424774},    -- Massive Guard // Gewaltiger Wächter
[424771]={typ=25, lvl=71, rlvl=69, zone=-1, giver={119617, 119618}, rew={0,0,0,100}},               -- Tired Guard // Müde Wache
[424869]={typ=25, lvl=71, rlvl=69, zone=-1, giver={119617, 119618}, rew={273970,2805,10}},          -- Tired Guard // Müde Wache
--[[ ] ]]

--[[ [ Chrysalia (23) ]]
[425446]={typ=21, lvl=74, rlvl=72, zone=23, items={[546242]=  1}, giver=120518, rew={308533,3485,10}, preq=424958},  -- Killer in the Midst // Mörder in der Mitte
[425447]={typ=21, lvl=74, rlvl=72, zone=23, items={[240980]= 10}, giver=120520, rew={308533,3485,10}, preq=424959},  -- More Simulations // Mehr Simulationen
[425448]={typ=21, lvl=74, rlvl=72, zone=23, items={[240895]= 10}, giver=120521, rew={308533,3485,10}, preq=425235},  -- Myrmex Eating Art // Die Kunst der Myrmexernährung
[425449]={typ=21, lvl=74, rlvl=72, zone=23, items={[241194]=  5}, giver=120562, rew={308533,3485,10}, preq=425236},  -- Partner Potion // Freundschaftstrank
[425450]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106733]=  5}, giver=120563, rew={308533,3485,10}, preq=425237},   -- Adjust The Instrument // Instrumenteneinstellung
[425451]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106533]= 10}, giver=120564, rew={308533,3485,10}, preq=425238},   -- Feeding, Do Not Disturb // Fütterung - Bitte nicht stören!
[425452]={typ=21, lvl=74, rlvl=72, zone=23, items={[241203]=  5}, giver=120565, rew={308533,3485,10}, preq=425239},  -- Hotbed of Incubation // Brutstätte
[425453]={typ=21, lvl=74, rlvl=72, zone=23, items={[241195]= 10}, giver=120575, rew={308533,3485,10}, preq=425240},  -- Local Medicine // Heilmittel aus der Gegend
[425454]={typ=21, lvl=74, rlvl=72, zone=23, items={[241201]=  1}, giver=120496, rew={308533,3485,10}, preq=425241},  -- Busy, But Still Need To Eat // Beschäftigt, muss aber immer noch essen
[425455]={typ=21, lvl=74, rlvl=72, zone=23, items={[241266]=  5}, giver=120575, rew={308533,3485,10}, preq=425242},  -- Protect Oneself Before Saving Others // Man schütze sich selbst, bevor man andere rettet.
[425456]={typ=21, lvl=74, rlvl=72, zone=23, items={[241267]= 10}, giver=120700, rew={308533,3485,10}, preq=425270},  -- Myrmex Queen's Health // Die Gesundheit der Myrmex-Königin
[425457]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106830]=  3}, giver=120521, rew={308533,3485,10}, preq=425271},   -- Nutrients For Growth // Wachstumsnährstoffe
[425458]={typ=21, lvl=74, rlvl=72, zone=23, items={[241272]=  1}, giver=120700, rew={308533,3485,10}, preq=425272},  -- Reciprocity // Wechselwirkung
[425459]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[107058]= 10}, giver=120678, rew={308533,3485,10}, preq=425273},   -- Garon Funeral // Garon-Beerdigung
[425494]={typ=21, lvl=74, rlvl=72, zone=23, items={[241193]= 10, [546243]=  1}, giver=120581, rew={308533,3485,10}, preq=425248},    -- Speed Is The Winner // Schnelligkeit gewinnt
[425495]={typ=21, lvl=74, rlvl=72, zone=23, items={[546245]=  1}, giver=120577, rew={308533,3485,10}, preq=425249},  -- Veiled Encampment Cover-Up // Schattenlager-Täuschung
[425496]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106719]= 10}, giver=120578, rew={308533,3485,10}, preq=425250},   -- Kulech Food // Kulech-Nahrung
[425497]={typ=21, lvl=74, rlvl=72, zone=23, items={[241202]= 10}, giver=120579, rew={308533,3485,10}, preq=425251},  -- Extracted From Blood // Blutextrakt
[425498]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106722]=  5, [106723]=  2}, giver=120578, rew={308533,3485,10}, preq=425252}, -- Continued Assistance: Kill Enemies // Weitere Hilfe: Tötet Feinde.
[425499]={typ=21, lvl=74, rlvl=72, zone=23, items={[546256]=  1}, giver=120579, rew={308533,3485,10}, preq=425253},  -- Continued Assistance: Research // Weitere Hilfe: Forschung
[425500]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106728]= 10}, giver=120578, rew={308533,3485,10}, preq=425254},   -- Myrmex Backstab // Myrmex-Stoß in den Rücken
[425501]={typ=21, lvl=74, rlvl=72, zone=23, items={[546283]=  1}, giver=120649, rew={308533,3485,10}, preq=425255},  -- Supreme Efficiency // Höchste Effizienz
[425502]={typ=21, lvl=74, rlvl=72, zone=23, items={[546284]=  1}, giver=120649, rew={308533,3485,10}, preq=425256},  -- Enter the Myrmex initiating team // Schließt Euch dem Myrmex-Startteam an.
[425503]={typ=21, lvl=74, rlvl=72, zone=23, items={[241270]= 10}, giver=120577, rew={308533,3485,10}, preq=425257},  -- Insistence on Materials // Bestehen auf Materialien
[425504]={typ=21, lvl=74, rlvl=72, zone=23, items={[241271]= 10}, giver=120578, GIVER_MIGHT_BE_INVALID=1, rew={308533,3485,10}, preq=425274},    -- Last Luck // Letztes Glück
[425505]={typ=21, lvl=74, rlvl=72, zone=23, items={[241330]= 10}, giver=120709, rew={308533,3485,10}, preq=425275},  -- Recycle and Reuse // Aufbereitung und Wiederverwertung
[425506]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106828]=  4}, giver=120581, rew={308533,3485,10}, preq=425276},   -- Plan Destroyer // Planzerstörer
[425507]={typ=21, lvl=74, rlvl=72, zone=23, items={[241329]=  5}, giver=120649, GIVER_MIGHT_BE_INVALID=1, rew={308533,3485,10}, preq=425277},    -- Smuggled Myrmex Eggs // Geschmuggelte Myrmex-Eier
[425510]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106533]=  5, [106515]=  5}, giver=120673, rew={308533,3485,10}, preq=425265}, -- Cleaning Plan // Reinigungsplan
[423488]={typ=21, lvl=74, rlvl=72, zone=23, items={[241296]= 10}, giver=120717, rew={308533,3485,10}, preq=425431},  -- Trade // Handel
[423489]={typ=21, lvl=74, rlvl=72, zone=23, items={[241297]= 10}, giver=120717, rew={308533,3485,10}, preq=425432},  -- Trade II // Handel II
[423490]={typ=21, lvl=74, rlvl=72, zone=23, items={[241298]= 10}, giver=120717, rew={308533,3485,10}, preq=425433},  -- Trade III // Handel III
[425604]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106473]= 10}, giver=120284, rew={308533,3485,10}, preq={425395,425396,425397}},   -- Instant Interception // Sofortige Intervention
[425605]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106805]= 10}, giver=120284, rew={308533,3485,10}, preq={425396,425604}},  -- Watertight // Wasserdicht
[425606]={typ=31, lvl=74, rlvl=72, zone=23, items={[546290]=  1}, giver=120284, taker=119857, rew={308533,3485,10}, preq={425397,425605}},   -- Accidental Reception // Zufälliger Empfang
[425607]={typ=31, lvl=74, rlvl=72, zone=23, items={[241322]= 10}, giver=120281, rew={308533,3485,10}, preq={425398,425399}}, -- Ruins Research // Ruinenforschungen
[425608]={typ=31, lvl=74, rlvl=72, zone=23, items={[241323]=  5}, giver=120281, rew={308533,3485,10}, preq={425399,425607}}, -- Research Obstruction // Behinderung der Untersuchung
[425609]={typ=31, lvl=74, rlvl=72, zone=23, items={[546711]=  1, [546710]=  1, [546298]=  1}, giver=120722, rew={308533,3485,10}, preq={425402,425403,425404}},  -- Support the Front Lines // Die Front unterstützen
[425610]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106611]= 10}, giver=120722, rew={308533,3485,10}, preq={425403,425609}},  -- Hold Ground // Standortverteidigung
[425611]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106613]= 10}, giver=120722, rew={308533,3485,10}, preq={425404,425610}},  -- Fireline Mission // Mission in der Schusslinie
[425612]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106808]= 10}, giver=120736, rew={308533,3485,10}, preq={425405,425406,425407,425408}},    -- Immediate Treatment // Sofortige Behandlung
[425613]={typ=31, lvl=74, rlvl=72, zone=23, items={[241280]= 10}, giver=120736, rew={308533,3485,10}, preq={425406,425612}}, -- Special Medicine // Spezialmedikament
[425614]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106619]= 10}, giver=120736, rew={308533,3485,10}, preq={425407,425613}},  -- Wonderful Effect // Wunderbarer Effekt
[425615]={typ=35, lvl=74, rlvl=72, zone=23, giver=120736, taker=119857, rew={308533,3485,10}, preq={425408,425614}}, -- Healer's Heart // Herz eines Heilers
[425616]={typ=31, lvl=74, rlvl=72, zone=23, items={[241324]=  1}, giver=120273, rew={308533,3485,10}, preq={425409,425410,425411,425412}},   -- Unknown Energy // Unbekannte Energie
[425617]={typ=31, lvl=74, rlvl=72, zone=23, items={[546297]=  1}, giver=120273, taker=120281, rew={308533,3485,10}, preq={425410,425616}},   -- Final Analysis // Finale Analyse
[425618]={typ=31, lvl=74, rlvl=72, zone=23, items={[241325]= 10}, giver=120281, rew={308533,3485,10}, preq={425411,425617}}, -- Local Resources // Lokale Ressourcen
[425619]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106807]=  5}, giver=120281, taker=120273, rew={308533,3485,10}, preq={425412,425618}},    -- Crush the Conspiracy // Die Verschwörung zerschlagen
[425620]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106612]= 10}, giver=120273, rew={308533,3485,10}, preq={425413,425414}},  -- Key Moment // Schlüsselmoment
[425621]={typ=31, lvl=74, rlvl=72, zone=23, items={[241279]= 10}, giver=120273, rew={308533,3485,10}, preq={425414,425620}}, -- Potential Threat // Potenzielle Bedrohung
[425622]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106620]=  1}, giver=120273, rew={308533,3485,10}, preq=425415},   -- Decapitation // Enthauptung
[422918]={typ=21, lvl=74, rlvl=72, zone=23, items={[241288]= 10}, giver=120489, taker=120475, rew={308533,3485,10}, preq=425426},    -- Wing and a Prayer // Hals- und Beinbruch
[422919]={typ=21, lvl=73, rlvl=71, zone=23, items={[241293]= 10}, giver=120762, rew={296553,3222,10}},   -- The Treasure Within // Der Schatz im Inneren
[422920]={typ=21, lvl=74, rlvl=72, zone=23, items={[241290]= 10}, giver=120489, taker=120790, rew={308533,3485,10}, preq=425442},    -- Chunky Lizard Skin Armor // Grobe Echsenhaut-Rüstung
[422921]={typ=21, lvl=74, rlvl=72, zone=23, items={[241291]= 10}, giver=120790, rew={308533,3485,10}, preq=425445},  -- Custom-made Armor // Maßgefertigte Rüstung
[422922]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106798]= 10}, giver=120489, taker=120791, rew={308533,3485,10}},  -- Beetle Control // Käferbekämpfung
[422923]={typ=21, lvl=74, rlvl=72, zone=23, items={[241287]= 10}, giver=120489, taker=120473, rew={308533,3485,10}, preq=425443},    -- Greeny Yellow // Grünliches Gelb
[425278]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106801]= 10}, giver=120842, rew={308533,3485,10}, preq=425438},   -- Dangerous Yasheedees // Gefährliche Yasheedees
[425279]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101238]= 10}, giver=120792, rew={308533,3485,10}, preq=425440},   -- Myrmex Observation Records // Myrmex-Beobachtungsaufzeichnungen
[425280]={typ=21, lvl=74, rlvl=72, zone=23, items={[241285]=  7, [241286]=  2}, giver=120714, rew={308533,3485,10}, preq=425435},    -- Heaven and Earth Dragon Banquet // Himmlisches Drachenbankett
[425303]={typ=31, lvl=74, rlvl=72, zone=23, items={[241227]=  3, [241228]=  3}, giver=120771, rew={308533,3485,10}, preq=425297},    -- More Backup Supplies // Weitere Hilfsvorräte
[425304]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106862]=  1, [106886]=  1}, giver=120492, rew={308533,3485,10}, preq=425297}, -- Deal With Death // Sich des Todes annehmen
[425305]={typ=31, lvl=74, rlvl=72, zone=23, items={[241229]=  3}, giver=120492, taker=120575, rew={308533,3485,10}, preq=425297},    -- Ongoing Research // Forschungen fortsetzen
[425306]={typ=32, lvl=74, rlvl=72, zone=23, mobs={[106860]= 10}, giver=120492, rew={308533,3485,10}, preq=425297},   -- Endless Supply of Morale // Endloser Vorrat an Kampfmoral
[425307]={typ=31, lvl=74, rlvl=72, zone=23, items={[546503]=  1}, mobs={[106861]=  1}, giver=120492, rew={308533,3485,10}, preq=425297}, -- Friendly Partner // Freundliche Partner
[425321]={typ=21, lvl=74, rlvl=71, zone=23, items={[241181]=  3}, giver=120492, rew={308533,3485,10}, preq=425175},  -- Scorched Earth // Verbrannte Erde
[425322]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101244]=  8}, giver=120606, rew={308533,3485,10}, preq=425308},   -- Dignity of the Fallen // Würde der Gefallenen
[425323]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106772]=  7}, giver=120634, rew={308533,3485,10}, preq=425313},  -- Greasing the Gears // Wie geschmiert
[425324]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106773]=  2}, giver=120634, rew={308533,3485,10}},    -- The Omega Platform Cannot Fall // Die Omega-Plattform darf nicht fallen
[425325]={typ=21, lvl=74, rlvl=72, zone=23, items={[240797]= 30}, giver=120634, rew={308533,3485,10}, preq=425313}, -- The Key Crystal // Der Schlüsselkristall
[425326]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101240]= 10}, giver=120634, rew={308533,3485,10}},    -- Charge up: Alliance Warriors // Aufladen: Bündniskrieger
[425327]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101241]=  5}, giver=120634, rew={308533,3485,10}},    -- Charge Up: Defense Crystal // Aufladen: Verteidigungskristall
[425328]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101242]= 10}, giver=120606, rew={308533,3485,10}, preq=425319},  -- Kill Them All! // Tötet sie alle!
[425329]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101242]=  5}, giver=120492, rew={308533,3485,10}},    -- Intense Strike // Harter Schlag
[425330]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101243]=  5}, giver=120606, rew={308533,3485,10}, preq=425319},  -- Maintaining Battle Capacity // Erhaltung der Kampfkraft
[425331]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106865]=  1}, giver=120606, rew={308533,3485,10}},    -- Stomp It! // Zermalmt sie!
[425332]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[102374]=  8}, giver=120606, rew={308533,3485,10}, preq=425319},  -- Beacon on a Bloody Path // Leuchtfeuer auf einem blutigen Pfad
[425333]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[102375]=  8}, giver=120606, rew={308533,3485,10}},    -- Standing Amongst the Corpses // Aufrecht zwischen Leichen
[425334]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[107202]=  1}, giver=120605, rew={308533,3485,10}, preq=425320},  -- The Truth Behind the Kulech Myrmex Attack // Die Wahrheit über den Kulech-Myrmex-Angriff
[425364]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106895]=  8}, giver=119111, rew={308533,3485,10}, preq=425359},   -- Gaining the Upper Hand // Die Oberhand gewinnen
[425365]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[107118]=  5}, giver=119111, rew={308533,3485,10}, preq=425359},   -- Routing the Enemy // Den Feind überwältigen
[425366]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106722]=  8}, giver=119111, rew={308533,3485,10}, preq=425359},   -- Fortune Favors the Bold // Das Glück ist mit den Tapferen
[425367]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106739]=  4}, giver=119111, rew={308533,3485,10}, preq=425359},   -- False Trail // Falsche Spuren
[425368]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[107117]=  5}, giver=120574, rew={308533,3485,10}, preq=425359},   -- Last Line of Defense // Letzte Verteidigungslinie
[425369]={typ=21, lvl=74, rlvl=72, zone=23, items={[209471]= 10}, giver=120574, taker=120579, rew={308533,3485,10}, preq=425359},    -- Enemy Disguises // Tarnung der Gegner
[425370]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106726]= 10}, giver=121027, rew={308533,3485,10}, preq=425362},   -- Unwanted Enemy // Unerwünschte Feinde
[425371]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106722]=  8}, giver=121027, rew={308533,3485,10}, preq=425362},  -- Pushback // Den Feind zurückdrängen
[425372]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106723]=  8}, giver=121027, rew={308533,3485,10}},    -- Surprise Attack // Überraschungsangriff
[425373]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101499]=  3}, giver=119111, rew={308533,3485,10}, preq=425359},   -- Rebuilding Defenses // Verteidigung wieder aufbauen
[425374]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101299]=  4}, giver=121027, rew={308533,3485,10}, preq=425362},   -- Cutting Off Troop Supply // Den Nachschub unterbrechen
[425375]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101300]=  4}, giver=121027, rew={308533,3485,10}, preq=425362},   -- Nipping It in the Bud // Im Keim ersticken
[425376]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101301]=  1}, giver=121027, rew={308533,3485,10}, preq=425362},   -- Attack Preparations // Angriffsvorbereitungen
[425377]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106887]=  1}, giver=120577, rew={308533,3485,10}, preq=425363},  -- Sacrifice // Opfer
[425203]={typ=21, lvl=74, rlvl=72, zone=23, items={[546144]=  1, [546143]=  1, [546145]=  1}, giver=120280, rew={308533,3485,0}, preq={425245,425246}},  -- Treating the Oriel Brothers // Die Oriel-BrÃ¼der versorgen
[425202]={typ=21, lvl=74, rlvl=72, zone=23, items={[241205]= 10}, giver=120280, rew={308533,3485,0}, preq=425245},   -- The Waterfall's Secret // Das Geheimnis des Wasserfalls

--[[ ] ]]

--[[ [ Yrvandis (31) ]]
[425221]={typ=22, lvl=7, rlvl=5, zone=31, mobs={[106684]=  5}, giver=120441, rew={177,385,10}, preq=425032},   -- No.1 Chef Assistant // Erster Kochgehilfe
[425226]={typ=21, lvl=7, rlvl=5, zone=31, items={[241083]=  5}, giver=120451, rew={177,385,10}, preq=425027},  -- More Shadow Hearts // Mehr Schattenherz
[425222]={typ=22, lvl=8, rlvl=6, zone=31, mobs={[106566]= 10}, giver=120457, rew={228,445,10}, preq=425043},   -- Needs more focus // Braucht mehr Fokus
[425227]={typ=21, lvl=8, rlvl=6, zone=31, items={[240802]= 15}, giver=120446, rew={228,445,10}, preq=425037},  -- Reserve Tool Maintenance Oil // Reservewerkzeug-Wartungsöl
[425228]={typ=21, lvl=8, rlvl=6, zone=31, items={[240804]=  5}, giver=120445, rew={228,445,10}, preq=425038},  -- Technique of Capturing Alive // Fangtechnik
[425224]={typ=21, lvl=9, rlvl=7, zone=31, items={[241116]= 10}, giver=120455, rew={283,501,10}, preq=425052},  -- Extra Recycling // Wiederverwertung
[425230]={typ= 2, lvl=9, rlvl=7, zone=31, mobs={[106567]= 10}, giver=120447, rew={283,501,10}, preq=425050},   -- Tarhanis' Revenge // Tarhanis' Rache
[425223]={typ=22, lvl=9, rlvl=7, zone=31, mobs={[106687]=  5}, giver=120458, rew={283,501,10}, preq=425046},   -- Temperature Control // Temperaturkontrolle
[425229]={typ= 2, lvl=9, rlvl=7, zone=31, mobs={[106563]= 10}, giver=120449, rew={283,501,10}, preq=425048},   -- Punish Food Thieves // Strafe den Nahrungsdieben
[425225]={typ=22, lvl=9, rlvl=7, zone=31, mobs={[106688]=  5}, giver=120456, rew={283,501,10}, preq=425054},   -- Resisting the Outside Threat // Der äußeren Bedrohung widerstehen
--[[ ] ]]

----------------------------------------------------------
-- Energy-Quests
----------------------------------------------------------
--[[ [ Tergothen Bay (21) ]]
[424457]={typ=22, lvl=67, rlvl=65, zone=21, mobs={[105902]=  3, [105903]=  3}, giver=119197, rew={0,0,0,210}, preq=424515}, -- Drive off the Ragemanes // Vertreibt die Wutmähnen
[424458]={typ=22, lvl=67, rlvl=65, zone=21, mobs={[106104]=  6}, giver=119197, rew={0,0,0,210}, preq=424515},   -- Rescue the Villagers // Rettet die Dorfbewohner
[424459]={typ=22, lvl=67, rlvl=65, zone=21, mobs={[105904]=  1}, giver=119197, rew={0,0,0,210}, preq=424515},   -- Attack the Head // Der Kopf der Schlange
[424460]={typ=21, lvl=67, rlvl=65, zone=21, items={[240603]=  1}, giver=119199, rew={0,0,0,300}, preq={424431}}, -- Effective Cough Medicine // Wirksames Hustenmittel
[424462]={typ=21, lvl=67, rlvl=65, zone=21, items={[240566]= 10}, giver=119202, rew={0,0,0,250}},   -- Night Banquet // Nachtmenü
[424463]={typ=21, lvl=67, rlvl=65, zone=21, items={[240567]= 10}, giver=119201, rew={0,0,0,200}},   -- Tanya's Distress // Tanyas Kummer
[424464]={typ=21, lvl=67, rlvl=65, zone=21, items={[240568]=  1}, giver=119199, taker=118905, rew={0,0,0,100}}, -- Weapon Advance // Waffenlieferung
[424465]={typ=21, lvl=67, rlvl=65, zone=21, items={[545520]=  1}, giver=119197, rew={0,0,0,300}},   -- Shadow Threat // Drohende Schatten
[424466]={typ=21, lvl=67, rlvl=65, zone=21, items={[545532]=  1, [545534]=  1, [545533]=  1, [545535]=  1}, giver=119202, rew={0,0,0,150}}, -- Allotted Supply // Rationen
[424502]={typ=21, lvl=68, rlvl=66, zone=21, items={[240590]= 10}, giver=119158, rew={0,0,0,70}, preq={424467,424501}},  -- The Secret of the Copied Key // Das Geheimnis des kopierten Schlüssels
[424503]={typ=21, lvl=67, rlvl=65, zone=21, items={[240622]= 10}, giver=119122, rew={0,0,0,300}, preq=424467},  -- Numbing Powder Ingredients // Betäubungspulver-Zutaten
[424504]={typ=21, lvl=67, rlvl=65, zone=21, items={[240625]= 10}, giver=119160, rew={0,0,0,300}, preq=424467},  -- Sound Imitation Flute // Imitationsflöte
[424505]={typ=21, lvl=67, rlvl=65, zone=21, items={[240587]=  5, [240588]=  5}, giver=119122, rew={0,0,0,300}, preq=424467},    -- Armored Protection // Rüstungsschutz
[424506]={typ=21, lvl=67, rlvl=65, zone=21, items={[240228]= 10}, giver=118905, rew={0,0,0,70}, preq=424472},   -- In Vino Veritas // In Vino Veritas
[424507]={typ=21, lvl=67, rlvl=65, zone=21, items={[545477]=  1}, giver=119052, taker=119074, rew={0,0,0,50}, preq=424467}, -- People with information control the direction of things. // Wer Informationen kontrolliert, kontrolliert das Geschehen.
[424539]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[103002]=  3}, giver=119416, rew={0,0,0,150}},    -- Delivery of Rebel Information // Übergabe der Informationen über die Rebellen
[424540]={typ=21, lvl=69, rlvl=67, zone=21, items={[545598]=  1, [545597]=  1, [545596]=  1}, giver=119417, rew={0,0,0,180}},   -- Steal the False Flyers // Stehlt die falschen Flugblätter
[424541]={typ=21, lvl=69, rlvl=67, zone=21, items={[545601]=  1, [545600]=  1, [545599]=  1}, giver=119418, rew={0,0,0,180}},   -- Spread Rumors // Gerüchte streuen
[424542]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[103003]=  3}, giver=119417, rew={0,0,0,100}},    -- Deliver to the Residents // Berichtet den Bewohnern
[424543]={typ=21, lvl=69, rlvl=67, zone=21, items={[240642]= 10}, giver=119419, rew={0,0,0,180}},   -- Those weapon boxes! // Diese Waffenkisten!
[424544]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106067]= 10}, giver=119416, rew={0,0,0,180}},    -- Exterminate Those Vermin! // Vernichtet dieses Ungeziefer!
[424600]={typ=21, lvl=68, rlvl=66, zone=21, items={[240626]= 10}, giver=119213, rew={0,0,0,300}, preq=424495},  -- Didola's Pearls // Didolas Perlen
[424601]={typ=21, lvl=68, rlvl=66, zone=21, items={[240627]= 15}, giver=119214, rew={0,0,0,150}, preq=424467},  -- False Countercharge // Falscher Gegenschlag
[424602]={typ=21, lvl=68, rlvl=66, zone=21, items={[240635]= 10}, giver=119214, rew={0,0,0,300}, preq=424472},  -- Thief's Small Knife // Das Messer des kleinen Diebs
[424603]={typ=21, lvl=68, rlvl=66, zone=21, items={[240640]= 10}, giver=119052, rew={0,0,0,70}, preq=424477},   -- Refreshing Mint Tea // Erfrischender Minztee
[424604]={typ=21, lvl=67, rlvl=65, zone=21, items={[545578]=  1}, giver=119215, rew={0,0,0,30}, preq=424467},   -- Battle Tactics: Enemy Confusion // Kampftaktik: Verwirrung des Feindes
[424610]={typ=22, lvl=68, rlvl=66, zone=21, mobs={[105999]=  5}, giver=119053, rew={0,0,0,210}},    -- Maintain Safety on the Trade Routes // Sorgt für Sicherheit auf den Handelsrouten
[424611]={typ=22, lvl=68, rlvl=66, zone=21, mobs={[106122]=  5}, giver=119053, rew={0,0,0,210}},    -- Rescue the Plundered Merchants // Rettet die Geplünderten Händler
[424612]={typ=21, lvl=68, rlvl=66, zone=21, items={[240571]=  5}, giver=119053, rew={0,0,0,175}},   -- Find the Lost Materials // Findet die Verlorenen Materialien
[424613]={typ=22, lvl=68, rlvl=66, zone=21, mobs={[106000]=  5}, giver=119055, rew={0,0,0,175}},    -- Threat of a Rebel Informant // Drohung eines Rebelleninformanten
[424614]={typ=22, lvl=68, rlvl=66, zone=21, mobs={[106057]=  5}, giver=119057, rew={0,0,0,175}},    -- The Galidun's Hindrance // Das Galidun-Problem
[424615]={typ=22, lvl=68, rlvl=66, zone=21, mobs={[105994]=  5}, giver=119054, rew={0,0,0,175}},    -- Extend a Hand of Friendship // Zeichen der Freundschaft
[424616]={typ=22, lvl=68, rlvl=66, zone=21, mobs={[105995]=  5}, giver=119063, rew={0,0,0,250}},    -- Battle Training for the Watch Team // Kampftraining für die Wachmannschaft
[424617]={typ=21, lvl=68, rlvl=66, zone=21, items={[240579]=  5}, giver=119063, rew={0,0,0,300}},   -- Second Stage of the Training // Die zweite Trainingsphase
[424618]={typ=21, lvl=68, rlvl=66, zone=21, items={[240572]=  5}, giver=119063, rew={0,0,0,300}},   -- Requirements to become part of the Rebel Army // Voraussetzungen für die Rebellenarmee
[424619]={typ=21, lvl=68, rlvl=66, zone=21, items={[240573]= 10}, giver=119065, rew={0,0,0,300}},   -- Otto's Secret Research // Ottos geheime Forschungen
[424620]={typ=21, lvl=68, rlvl=66, zone=21, items={[240578]=  1}, giver=119065, rew={0,0,0,350}},   -- Take Back Otto's Research Report // Bringt Otto seinen Forschungsbericht zurück
[424621]={typ=25, lvl=68, rlvl=66, zone=21, giver=119065, taker=119060, rew={0,0,0,50}},            -- Otto's Warning // Ottos Warnung
[424622]={typ=22, lvl=68, rlvl=66, zone=21, mobs={[106158]=  1}, giver=119060, rew={0,0,0,250}},    -- Destroy the Imperial Army's Mysterious Equipment // Zerstört die mysteriösen Anlagen der Imperialen Armee
[424623]={typ=22, lvl=68, rlvl=66, zone=21, mobs={[106001]=  5}, giver=119061, rew={0,0,0,300}},    -- Continue to Clean up the Threats to the Fishing Village // Beseitigt weitere Gefahren für das Fischerdorf
[424624]={typ=22, lvl=68, rlvl=66, zone=21, mobs={[106191]=  5}, giver=119061, rew={0,0,0,300}},    -- Immediate Relief // Sofortige Hilfe
[424636]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106073]=  3, [106074]=  3}, giver=119230, rew={0,0,0,250}, preq=424423}, -- Hope for Safe Delivery // Hoffnung auf eine sichere Lieferung
[424637]={typ=21, lvl=69, rlvl=67, zone=21, items={[545536]=  1}, giver=119231, rew={0,0,0,150}, preq=424425},  -- Special Secluded Valley Cart // Ein besonderer Transport für das Abgeschiedene Tal
[424638]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106079]= 10}, giver=119233, rew={0,0,0,150}, preq=424564},   -- Maintain Long-Term Privacy // Langfristiger Schutz der Privatsphäre
[424639]={typ=21, lvl=69, rlvl=67, zone=21, items={[240629]= 10}, giver=119234, rew={0,0,0,200}, preq=424566},  -- More Hearts of the Ocean // Mehr Herzen des Ozeans
[424640]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106079]=  6}, giver=119235, rew={0,0,0,200}, preq=424592},   -- A Father's Constant Protection // Der ständige eifrige Schutz eines Vaters
[424641]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106117]= 10}, giver=119236, rew={0,0,0,70}, preq=424594},    -- Always Prepared // Allzeit bereit
[424642]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106118]=  8}, giver=119237, rew={0,0,0,250}, preq=424626},   -- Further Use of Natural Enemies // Der weitere Nutzen natürlicher Feinde
[424643]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106075]=  6}, giver=119238, rew={0,0,0,150}, preq=424628},   -- Pets Extremely Prohibited Inside // Haustiere strengstens verboten
[424644]={typ=21, lvl=69, rlvl=67, zone=21, items={[240636]=  4}, giver=119238, rew={0,0,0,250}, preq=424630},  -- Collect more Nest Crystals... // Mehr Nest-Kristalle ...
[424645]={typ=22, lvl=69, rlvl=67, zone=21, mobs={[106121]=  5}, giver=119241, rew={0,0,0,200}, preq=424632},   -- Equipment Upgrade // Der neuste Apparat
[424646]={typ=21, lvl=69, rlvl=67, zone=21, items={[240630]=  5}, giver=119234, rew={0,0,0,200}, preq=424634},  -- More Acting Props // Mehr Requisiten
--[424666]={typ=22, lvl=69, rlvl=67, zone=0, mobs={[103003]=  3}, giver=0, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,80}}, -- Give them out to the residents // Gebt sie den Bewohnern

-- ??? (22)
--[424880]={typ=21, lvl=70, rlvl=68, zone=22, items={[240786]=  5}, giver=119646, rew={0,0,0,60}, preq=424873},   -- Calm Heart // Gelassenheit
--[424886]={typ=21, lvl=71, rlvl=68, zone=22, items={[240786]=  5}, giver=119646, rew={0,0,10}, preq=424873}, -- Calm Heart // Gelassenheit
--[425122]={typ=21, lvl=71, rlvl=68, zone=22, items={[545791]=  1}, giver=119872, rew={0,0,10}, preq=425102}, -- Mission Delivery // Missionserfüllung
--[[ ] ]]

--[[ [ Chrysalia (23) ]]
[425416]={typ=21, lvl=72, rlvl=70, zone=23, items={[546724]=  1}, giver=120281, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,50}},   -- Memory of Hope // Erinnerung der Hoffnung
[425417]={typ=21, lvl=72, rlvl=70, zone=23, items={[546724]=  1}, giver=120281, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,50}},   -- Memory of Bravery // Erinnerung der Tapferkeit
[425418]={typ=21, lvl=72, rlvl=70, zone=23, items={[546724]=  1}, giver=120281, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,50}},   -- Memory of Justice // Erinnerung der Gerechtigkeit
[425419]={typ=21, lvl=72, rlvl=70, zone=23, items={[546724]=  1}, giver=120281, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,50}},   -- Memory of Wisdom // Erinnerung der Weisheit
[425420]={typ=21, lvl=72, rlvl=70, zone=23, items={[546724]=  1}, giver=120281, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,50}},   -- Memory of Love // Erinnerung der Liebe
[425460]={typ=21, lvl=73, rlvl=71, zone=23, items={[546242]=  1}, giver=120518, rew={0,0,0,250}, preq=424958},   -- Killer in the Midst // Mörder in der Mitte
[425461]={typ=21, lvl=73, rlvl=71, zone=23, items={[240980]= 10}, giver=120520, rew={0,0,0,80}, preq=424959},    -- More Simulations // Mehr Simulationen
[425462]={typ=21, lvl=73, rlvl=71, zone=23, items={[240895]= 10}, giver=120521, rew={0,0,0,150}, preq=425235},   -- Myrmex Eating Arts // Die Kunst der Myrmexernährung
[425463]={typ=21, lvl=73, rlvl=71, zone=23, items={[241194]=  5}, giver=120562, rew={0,0,0,30}, preq=425236},    -- Partner Potion // Freundschaftstrank
[425464]={typ=22, lvl=73, rlvl=71, zone=23, mobs={[106733]=  5}, giver=120563, rew={0,0,0,50}, preq=425237}, -- Adjust The Instrument // Instrumenteneinstellung
[425465]={typ=22, lvl=73, rlvl=71, zone=23, mobs={[106533]= 10}, giver=120564, rew={0,0,0,230}, preq=425238},    -- Feeding, Do Not Disturb // Fütterung - Bitte nicht stören!
[425466]={typ=21, lvl=73, rlvl=71, zone=23, items={[241203]=  5}, giver=120565, rew={0,0,0,150}, preq=425239},   -- Hotbed of Incubation // Brutstätte
[425467]={typ=21, lvl=73, rlvl=71, zone=23, items={[241195]= 10}, giver=120575, rew={0,0,0,50}, preq=425240},    -- Local Medicine // Heilmittel aus der Gegend
[425468]={typ=21, lvl=73, rlvl=71, zone=23, items={[241201]=  1}, giver=120496, rew={0,0,0,100}, preq=425241},   -- Busy, But Still Need To Eat // Beschäftigt, muss aber immer noch essen
[425469]={typ=21, lvl=73, rlvl=71, zone=23, items={[241266]=  5}, giver=120575, rew={0,0,0,100}, preq=425242},   -- Protect Oneself Before Saving Others // Man schütze sich selbst, bevor man andere rettet.
[425470]={typ=21, lvl=73, rlvl=71, zone=23, items={[241267]= 10}, giver=120700, rew={0,0,0,100}, preq=425270},   -- Myrmex Queen's Health // Die Gesundheit der Myrmex-Königin
[425471]={typ=22, lvl=73, rlvl=71, zone=23, mobs={[106830]=  3}, giver=120521, rew={0,0,0,30}, preq=425271}, -- Nutrients For Growth // Wachstumsnährstoffe
[425472]={typ=21, lvl=73, rlvl=71, zone=23, items={[241272]=  1}, giver=120700, rew={0,0,0,30}, preq=425272},    -- Reciprocity // Wechselwirkung
[425473]={typ=22, lvl=73, rlvl=71, zone=23, mobs={[107058]= 10}, giver=120678, rew={0,0,0,150}, preq=425273},    -- Garon Funerals // Garon-Beerdigungen
[425480]={typ=21, lvl=74, rlvl=72, zone=23, items={[241193]= 10, [546243]=  1}, giver=120581, rew={0,0,0,80}, preq=425248},  -- Speed Is The Winner // Schnelligkeit gewinnt
[425481]={typ=21, lvl=74, rlvl=72, zone=23, items={[546245]=  1}, giver=120577, rew={0,0,0,50}, preq=425249},    -- Veiled Encampment Cover-Up // Schattenlager-Täuschung
[425482]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106719]= 10}, giver=120578, rew={0,0,0,230}, preq=425250},    -- Kulech Food // Kulech-Nahrung
[425483]={typ=21, lvl=74, rlvl=72, zone=23, items={[241202]= 10}, giver=120579, rew={0,0,0,80}, preq=425251},    -- Extracted From Blood // Blutextrakt
[425484]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106722]=  5, [106723]=  2}, giver=120578, rew={0,0,0,230}, preq=425252},  -- Continued Assistance: Kill Enemies // Weitere Hilfe: Tötet Feinde.
[425485]={typ=21, lvl=74, rlvl=72, zone=23, items={[546256]=  1}, giver=120579, rew={0,0,0,430}, preq=425253},   -- Continued Assistance: Research // Weitere Hilfe: Forschung
[425486]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106728]= 10}, giver=120578, rew={0,0,0,230}, preq=425254},    -- Myrmex Backstab // Myrmex-Stoß in den Rücken
[425487]={typ=21, lvl=74, rlvl=72, zone=23, items={[546283]=  1}, giver=120649, rew={0,0,0,100}, preq=425255},   -- Supreme Efficiency // Höchste Effizienz
[425488]={typ=21, lvl=74, rlvl=72, zone=23, items={[546284]=  1}, giver=120649, rew={0,0,0,80}, preq=425256},    -- Enter the Myrmex initiating team // Schließt Euch dem Myrmex-Startteam an.
[425489]={typ=21, lvl=74, rlvl=72, zone=23, items={[241270]= 10}, giver=120577, rew={0,0,0,150}, preq=425257},   -- Insistence on Materials // Bestehen auf Materialien
[425490]={typ=21, lvl=74, rlvl=72, zone=23, items={[241271]= 10}, giver=120578, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,430}, preq=425274}, -- Last Luck // Letztes Glück
[425491]={typ=21, lvl=74, rlvl=72, zone=23, items={[241330]= 10}, giver=120709, rew={0,0,0,80}, preq=425275},    -- Recycle and Reuse // Aufbereitung und Wiederverwertung
[425492]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106828]=  4}, giver=120581, rew={0,0,0,400}, preq=425276},    -- Plan Destroyer // Planzerstörer
[425493]={typ=21, lvl=74, rlvl=72, zone=23, items={[241329]=  5}, giver=120649, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,430}, preq=425277}, -- Smuggled Myrmex Eggs // Geschmuggelte Myrmex-Eier
[425508]={typ=21, lvl=72, rlvl=70, zone=23, items={[546724]=  1}, giver=120281, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,50}},   -- Memory of Tolerance // Erinnerung an Toleranz
[425509]={typ=21, lvl=72, rlvl=70, zone=23, items={[546724]=  1}, giver=120281, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,50}},   -- Memory of Loyalty // Erinnerung an Loyalität
[425511]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106533]=  5, [106515]=  5}, giver=120673, rew={0,0,0,150}, preq=425265},  -- Cleaning Plan // Reinigungsplan
[425512]={typ=21, lvl=72, rlvl=70, zone=23, items={[241297]= 10}, giver=120717, rew={0,0,0,70}, preq=425432},    -- Trade II // Handel II
[425513]={typ=21, lvl=72, rlvl=70, zone=23, items={[241298]= 10}, giver=120717, rew={0,0,0,70}, preq=425433},    -- Trade III // Handel III
[425514]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106801]= 10}, giver=120842, rew={0,0,0,70}, preq=425438}, -- Dangerous Yasheedees // Gefährliche Yasheedees
[425515]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[101238]= 10}, giver=120792, rew={0,0,0,70}, preq=425440}, -- Myrmex Observation Records // Myrmex-Beobachtungsaufzeichnungen
[425516]={typ=21, lvl=72, rlvl=70, zone=23, items={[241285]=  7, [241286]=  2}, giver=120714, rew={0,0,0,70}, preq=425435},  -- Heaven and Earth Dragon Banquet // Himmlisches Drachenbankett
[425585]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106473]= 10}, giver=120284, rew={0,0,0,100}, preq={425395,425396,425397}},    -- Instant Interception // Sofortige Intervention
[425586]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106805]= 10}, giver=120284, rew={0,0,0,100}, preq={425396,425585}},   -- Watertight // Wasserdicht
[425587]={typ=21, lvl=72, rlvl=70, zone=23, items={[546290]=  1}, giver=119857, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,150}, preq={425397,425586}},    -- Accidental Reception // Zufälliger Empfang
[425588]={typ=21, lvl=72, rlvl=70, zone=23, items={[241322]= 10}, giver=120281, rew={0,0,0,100}, preq={425398,425399}},  -- Ruins Research // Ruinenforschungen
[425589]={typ=21, lvl=72, rlvl=70, zone=23, items={[241323]=  5}, giver=120281, rew={0,0,0,100}, preq={425399,425588}},  -- Research Obstruction // Behinderung der Untersuchung
[425590]={typ=21, lvl=72, rlvl=70, zone=23, items={[546711]=  1, [546710]=  1, [546298]=  1}, giver=120722, rew={0,0,0,100}, preq={425402,425403,425404}},   -- Support the Front Lines // Die Front unterstützen
[425591]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106611]= 10}, giver=120722, rew={0,0,0,100}, preq={425403,425590}},   -- Hold Ground // Standortverteidigung
[425592]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106613]= 10}, giver=120722, rew={0,0,0,100}, preq={425404,425591}},   -- Fireline Mission // Mission in der Schusslinie
[425593]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106808]= 10}, giver=120736, rew={0,0,0,100}, preq={425405,425406,425407,425408}}, -- Immediate Treatment // Sofortige Behandlung
[425594]={typ=21, lvl=72, rlvl=70, zone=23, items={[241280]= 10}, giver=120736, rew={0,0,0,100}, preq={425406,425593}},  -- Special Medicine // Spezialmedikament
[425595]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106619]= 10}, giver=120736, rew={0,0,0,200}, preq={425407,425594}},   -- Wonderful Effect // Wunderbarer Effekt
[425596]={typ=25, lvl=72, rlvl=70, zone=23, giver=119857, GIVER_MIGHT_BE_INVALID=1, rew={0,0,0,150}, preq={425408,425595}},  -- Healer's Heart // Herz eines Heilers
[425597]={typ=21, lvl=72, rlvl=70, zone=23, items={[241324]=  1}, giver=120273, rew={0,0,0,100}, preq={425409,425410,425411,425412}},    -- Unknown Energy // Unbekannte Energie
[425598]={typ=21, lvl=72, rlvl=70, zone=23, items={[546297]=  1}, giver=120273, taker=120281, rew={0,0,0,50}, preq={425410,425597}}, -- Final Analysis // Finale Analyse
[425599]={typ=21, lvl=72, rlvl=70, zone=23, items={[241325]= 10}, giver=120281, rew={0,0,0,100}, preq={425411,425598}},  -- Local Resources // Lokale Ressourcen
[425600]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106807]=  5}, giver=120281, taker=120273, rew={0,0,0,200}, preq={425412,425599}}, -- Crush the Conspiracy // Die Verschwörung zerschlagen
[425601]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106612]= 10}, giver=120273, rew={0,0,0,100}, preq={425413,425414}},   -- Key Moment // Schlüsselmoment
[425602]={typ=21, lvl=72, rlvl=70, zone=23, items={[241279]= 10}, giver=120273, rew={0,0,0,100}, preq={425414,425601}},  -- Potential Threat // Potenzielle Bedrohung
[425603]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106620]=  1}, giver=120273, rew={0,0,0,300}, preq=425415},    -- Decapitation // Enthauptung
[422924]={typ=21, lvl=72, rlvl=70, zone=23, items={[241288]= 10}, giver=120489, taker=120475, rew={0,0,0,70}, preq=425426},  -- Wing and a Prayer // Hals- und Beinbruch
[425258]={typ=21, lvl=72, rlvl=70, zone=23, items={[546270]=  1, [546269]=  1, [546230]=  1}, giver=120276, rew={0,0,0,90}, preq=425243},    -- Secret Herbs and Spices // Geheime Kräuter und Gewürze
[425259]={typ=21, lvl=72, rlvl=70, zone=23, items={[241190]= 10}, mobs={[106613]= 10}, giver=120277, taker=120276, rew={0,0,0,80}, preq=425244},    -- Eliminate Remodeled Beasts // Vernichtung der umgeformten Bestien
[425260]={typ=21, lvl=72, rlvl=70, zone=23, items={[241191]= 10}, mobs={[106611]= 10}, giver=120277, taker=120276, rew={0,0,0,100}, preq=425244},   -- Eliminate Enhanced Remodeled Soldiers // Vernichtung der verbesserten umgeformten Soldaten
[425261]={typ=21, lvl=72, rlvl=70, zone=23, items={[241192]= 10}, mobs={[106612]= 10}, giver=120277, taker=120276, rew={0,0,0,130}, preq=425244},   -- Eliminate Elite Remodeled Soldiers // Vernichtung der umgeformten Elitesoldaten
[425262]={typ=21, lvl=72, rlvl=70, zone=23, items={[241205]= 10}, giver=120280, rew={0,0,0,80}, preq=425245},    -- The Waterfall's Secret // Das Geheimnis des Wasserfalls
[425263]={typ=21, lvl=72, rlvl=70, zone=23, items={[546144]=  1, [546143]=  1, [546145]=  1}, giver=120280, rew={0,0,0,95}, preq={425245,425246}},   -- Treating the Oriel Brothers // Die Oriel-Brüder versorgen
[425264]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106614]= 10}, giver=120277, rew={0,0,0,90}, preq=425247}, -- Out of the Frying Pan // Vom Regen in die Traufe
[425282]={typ=21, lvl=72, rlvl=70, zone=23, items={[241293]= 10}, giver=120762, rew={0,0,0,70}},     -- The Treasure Within // Der Schatz im Inneren
[425288]={typ=21, lvl=72, rlvl=70, zone=23, items={[241290]= 10}, giver=120489, taker=120790, rew={0,0,0,70}, preq=425442},  -- Chunky Lizard Skin Armor // Grobe Echsenhaut-Rüstung
[425289]={typ=21, lvl=72, rlvl=70, zone=23, items={[241291]= 10}, giver=120790, rew={0,0,0,70}, preq=425445},    -- Custom-made Armor // Maßgefertigte Rüstung
[425290]={typ=22, lvl=72, rlvl=70, zone=23, mobs={[106798]= 10}, giver=120489, taker=120791, rew={0,0,0,70}},    -- Beetle Control // Käferbekämpfung
[425291]={typ=21, lvl=72, rlvl=70, zone=23, items={[241287]= 10}, giver=120489, taker=120473, rew={0,0,0,70}, preq=425443},  -- Greeny Yellow // Grünliches Gelb
[425292]={typ=21, lvl=72, rlvl=70, zone=23, items={[241296]= 10}, giver=120717, rew={0,0,0,70}, preq=425431},    -- Trade // Handel
[425298]={typ=21, lvl=73, rlvl=71, zone=23, items={[241227]=  3, [241228]=  3}, giver=120771, rew={0,0,0,100}, preq=425297}, -- Local Supplement Supplies // Lokale Vorratsaufstockung
[425299]={typ=22, lvl=73, rlvl=71, zone=23, mobs={[106862]=  1, [106886]=  1}, giver=120492, rew={0,0,0,100}, preq=425297},  -- Deal With Death // Sich des Todes annehmen
[425300]={typ=21, lvl=73, rlvl=71, zone=23, items={[241229]=  3}, giver=120492, taker=120575, rew={0,0,0,100}, preq=425297}, -- Ongoing Research // Forschungen fortsetzen
[425301]={typ=22, lvl=73, rlvl=71, zone=23, mobs={[106860]= 10}, giver=120492, rew={0,0,0,100}, preq=425297},    -- Endless Supply of Morale // Endloser Vorrat an Kampfmoral
[425302]={typ=21, lvl=73, rlvl=71, zone=23, items={[546503]=  1}, mobs={[106861]=  1}, giver=120492, rew={0,0,0,100}, preq=425297},  -- Friendly Partner // Freundliche Partner
[425336]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[101244]=  8}, giver=120606, rew={0,0,0,150}, preq=425308},    -- Dignity of the Fallen // Würde der Gefallenen
[425337]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[106772]=  7}, giver=120634, rew={0,0,0,150}, preq=425313},   -- Greasing the Gears // Wie geschmiert?
[425338]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[106773]=  2}, giver=120634, rew={0,0,0,150}},     -- The Omega Platform Cannot Fall // Die Omega-Plattform darf nicht fallen
[425339]={typ=21, lvl=74, rlvl=71, zone=23, items={[240797]= 30}, giver=120634, rew={0,0,0,100}, preq=425313},  -- The Key Crystal // Der Schlüsselkristall
[425340]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[101240]= 10}, giver=120634, rew={0,0,0,150}},     -- Charge up: Alliance Warriors // Aufladen: Bündniskrieger
[425341]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[101241]=  5}, giver=120634, rew={0,0,0,130}},     -- Charge Up: Defense Crystal // Aufladen: Verteidigungskristall
[425342]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[101242]= 10}, giver=120606, rew={0,0,0,180}, preq=425319},   -- Kill Them All! // Tötet sie alle!
[425343]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[101242]=  5}, giver=120492, rew={0,0,0,180}},     -- Intense Strikes // Harte Schläge
[425344]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[101243]=  5}, giver=120606, rew={0,0,0,100}, preq=425319},   -- Maintaining Battle Capacity // Erhaltung der Kampfkraft
[425345]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[106865]=  1}, giver=120606, rew={0,0,0,130}},     -- Stomp It! // Zermalmt sie!
[425346]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[102374]=  8}, giver=120606, rew={0,0,0,70}, preq=425319},    -- Beacon on a Bloody Path // Leuchtfeuer auf einem blutigen Pfad
[425347]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[102375]=  8}, giver=120606, rew={0,0,0,100}},     -- Standing Amongst the Corpses // Aufrecht zwischen Leichen
[425348]={typ=22, lvl=74, rlvl=71, zone=23, mobs={[107202]=  1}, giver=120605, rew={0,0,0,830}, preq=425320},   -- The Truth Behind the Kulech Myrmex Attack // Die Wahrheit über den Kulech-Myrmex-Angriff
[425349]={typ=21, lvl=74, rlvl=71, zone=23, items={[241181]=  3}, giver=120492, rew={0,0,0,100}, preq=425175},   -- Scorched Earth // Verbrannte Erde
[425378]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106895]=  8}, giver=119111, rew={0,0,0,200}, preq=425359},    -- Gaining the Upper Hand // Die Oberhand gewinnen
[425379]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[107118]=  5}, giver=119111, rew={0,0,0,100}, preq=425359},    -- Routing the Enemy // Den Feind überwältigen
[425380]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106722]=  8}, giver=119111, rew={0,0,0,120}, preq=425359},    -- Fortune Favors the Bold // Das Glück ist mit den Tapferen
[425381]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106739]=  4}, giver=119111, rew={0,0,0,70}, preq=425359}, -- False Trail // Falsche Spuren
[425382]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[107117]=  5}, giver=120574, rew={0,0,0,100}, preq=425359},    -- Last Line of Defense // Letzte Verteidigungslinie
[425383]={typ=21, lvl=74, rlvl=72, zone=23, items={[209471]= 10}, giver=120574, taker=120579, rew={0,0,0,40}, preq=425359},  -- Enemy Disguises // Täuschung der Gegner
[425384]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106726]= 10}, giver=121027, rew={0,0,0,100}, preq=425362},    -- Unwanted Enemy // Unerwünschte Feinde
[425385]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106722]=  8}, giver=121027, rew={0,0,0,80}, preq=425362},    -- Pushback // Den Feind zurückdrängen
[425386]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106723]=  2}, giver=121027, rew={0,0,0,100}},     -- Surprise Attack // Überraschungsangriff
[425387]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101499]=  3}, giver=119111, rew={0,0,0,70}, preq=425359}, -- Rebuilding Defenses // Verteidigung wieder aufbauen
[425388]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101299]=  4}, giver=121027, rew={0,0,0,200}, preq=425362},    -- Cutting Off Troop Supply // Den Nachschub unterbrechen
[425389]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101300]=  4}, giver=121027, rew={0,0,0,200}, preq=425362},    -- Nipping It in the Bud // Im Keim ersticken
[425390]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[101301]=  1}, giver=121027, rew={0,0,0,120}, preq=425362},    -- Attack Preparations // Angriffsvorbereitungen
[425391]={typ=22, lvl=74, rlvl=72, zone=23, mobs={[106887]=  1}, giver=120577, rew={0,0,0,830}, preq=425363},   -- Sacrifice // Opfer
--[[ ] ]]

----------------------------------------------------------
--[[ [ Specials ]]
-- Miller-Ranch = 304 but 304 is unkonwn
[422343]= {typ= 3, lvl=1, rlvl=1, zone=-1, items={[204787]= 10}, giver=110789, rew={12,25,0}},                 -- // Süsse Milch
[422386]= {typ= 3, lvl=1, rlvl=1, zone=-1, items={[204795]= 10}, giver=114930, rew={12,25,0}},                 -- // Eine einfache Aufgabe

-- Arena
[422549]= {typ=25, lvl=40, rlvl=40, zone=-1, items={[542941]=1,[542942]=1,[542943]=1}, giver=113328, rew={16665,1519,10}},                 -- // Tag des Ruhms

-- Guild
[421629]= {typ=14, lvl=10, rlvl=10, zone=401, items={[203396]=15}, giver=113037, rew={292,604,0}, mobs={[100399]=0}},  -- // Bauarbeiter
[421525]= {typ=14, lvl=20, rlvl=20, zone=401, items={[203398]= 2}, giver=113038, rew={2003,2341,0} }, --, mobs={[100101]=10,[100102]=5}},  -- // Baumaterial
[421630]= {typ=14, lvl=20, rlvl=20, zone=401, items={[203398]= 1}, giver=113037, rew={1502,1951,0} }, --, mobs={[100101]=10,[100102]=5}},  -- // Baumaterial
[421644]= {typ=14, lvl=20, rlvl=20, zone=401, items={[203398]= 3}, giver=113039, rew={3004,2731,0} }, --, mobs={[100101]=10,[100102]=5}},  -- // Baumaterial
[421526]= {typ=14, lvl=25, rlvl=25, zone=401, items={[203400]=25,[203399]= 5}, giver=113038, rew={4626,2979,0}, mobs={[100139]=0,[100272]=0}},  -- // Die Gilde braucht Kräuter
[421631]= {typ=14, lvl=25, rlvl=25, zone=401, items={[203400]=15,[203399]= 5}, giver=113037, rew={3469,2483,0}, mobs={[100139]=0,[100272]=0}},  -- // Die Gilde braucht Kräuter
[421645]= {typ=14, lvl=25, rlvl=25, zone=401, items={[203400]=30,[203399]=10}, giver=113039, rew={6939,3476,0}, mobs={[100139]=0,[100272]=0}},  -- // Die Gilde braucht Kräuter
[421527]= {typ=14, lvl=30, rlvl=30, zone=401, items={[203401]=25}, giver=113038, rew={7922,3960,0}, mobs={[100231]=0,[100232]=0,[100641]=0}},  -- // Materialien zum Bauen
[421632]= {typ=14, lvl=30, rlvl=30, zone=401, items={[203401]=20}, giver=113037, rew={5941,3300,0}, mobs={[100231]=0,[100232]=0,[100641]=0}},  -- // Materialien zum Bauen
[421646]= {typ=14, lvl=30, rlvl=30, zone=401, items={[203401]=30}, giver=113039, rew={11883,4620,0}, mobs={[100231]=0,[100232]=0,[100641]=0}},  -- // Materialien zum Bauen
[421528]= {typ=14, lvl=40, rlvl=40, zone=401, items={[203402]=25}, giver=113038, rew={33331,3645,0}, mobs={[100419]=0,[100421]=0,[100616]=0,[100617]=0}},  -- // Die Gilde braucht Waffen
[421633]= {typ=14, lvl=40, rlvl=40, zone=401, items={[203402]=20}, giver=113037, rew={24998,3038,0}, mobs={[100419]=0,[100421]=0,[100616]=0,[100617]=0}},  -- // Die Gilde braucht Waffen
[421647]= {typ=14, lvl=40, rlvl=40, zone=401, items={[203402]=30}, giver=113039, rew={49996,4253,0}, mobs={[100419]=0,[100421]=0,[100616]=0,[100617]=0}},  -- // Die Gilde braucht Waffen
[421648]= {typ=12, lvl=45, rlvl=45, zone=401, giver=113039, rew={150086,11979,0}, mobs={[101352]=1}},  -- // Belohnung: Uguda
[421639]= {typ=12, lvl=10, rlvl=10, zone=401, giver=113039, rew={858,1328,0},    mobs={[100926]=8, [100927]=8}},  -- // Der Antrag der Garnison
[421524]= {typ=12, lvl=10, rlvl=10, zone=401, giver=113038, rew={780,1208,0},    mobs={[100926]=5, [100927]=5}},  -- // Der Antrag der Stadtwache
[421634]= {typ=12, lvl=45, rlvl=45, zone=401, giver=113037, rew={77631,7986,0},  mobs={[100611]=1}},  -- // Belohnung: Dorlos
[421529]= {typ=12, lvl=45, rlvl=45, zone=401, giver=113038, rew={113858,9982,0}, mobs={[100794]=1}},  -- // Gesucht: Schwarzhorn-Hafiz
}
--[[ ] ]]

DailyNotes.DB_Zones ={
  [1]=9998,
  [2]=9998,
  [3]=9998,
  [4]=9998,
  [5]=9998,
  [6]=9998,
  [7]=9998,
  [8]=9998,
  [9]=9998,
  [10]=9998,
  [11]=9998,
  [12]=9998,
  [13]=9997,
  [14]=9997,
  [15]=9997,
  [16]=9997,
  [17]=9997,
  [18]=9997,
  [19]=9997,
  [20]=9997,
  [21]=9997,
  [22]=9996,
  [23]=9996,
  [31]=9999,
  [10000]=2,
  [10001]=6,
  [100]=1,
  [101]=1,
  [102]=2,
  [103]=4,
  [104]=5,
  [105]=6,
  [106]=10,
  [107]=6,
  [108]=3,
  [110]=1,
  [113]=11,
  [114]=11,
  [115]=7, -- Ocean's Heart - Herz des Ozeans

  [670]=9998, -- Dummy: Ysta-Lab
  [201]=2,
  [202]=670,
  [203]=670,
  [204]=670,
  [205]=670,
  [206]=670,
  [207]=670,
  [209]=15,
  [250]=1,
  [251]=10,
  [252]=10,
  [301]=1,
  [302]=6,
  [304]=9999, -- Miller Ranch
  [401]=9999, -- Guild
  [-1] =9999, -- no zone (304 workaround)
}

---------------------------
-- NPCs
-- here DN caches all NPC-Information
-- this is only usfull for:
--  - adding sub-zones (TEXT identifier)
--  - if npc isn't listed in world-search
-- a full entry example (all attributes are optional):
--   [110102]= {map=6,name="Bulletin board in Obsidian Stronghold",x=41.8,y=52.4,map_name="Obisdian"},
---------------------------
DailyNotes.DB_NPC ={

[113046]={map_name="SC_207_GOTO_PP1"}, -- Blake Fos
[113062]={map_name="SC_205_GOTO_PP2"}, -- Lolin Caffey
[113063]={map_name="SC_205_GOTO_PP3"}, -- Jiner Bighead
[113064]={map_name="SC_205_GOTO_PP3"}, -- Shirley Higgens
[113068]={map_name="SC_205_GOTO_PP0"}, -- Waton Raydor
[113069]={map_name="SC_205_GOTO_PP2"}, -- Fra Gau
[113070]={map_name="SC_205_GOTO_PP1"}, -- Sai Kasrate
[113077]={map_name="SC_205_GOTO_PP0"}, -- Hylun Leard
[113082]={map_name="SC_206_GOTO_PP1"}, -- Jilo Anta
[113083]={map_name="SC_206_GOTO_PP3"}, -- Dalina Telo
[113084]={map_name="SC_206_GOTO_PP2"}, -- Koke Palsi
[113085]={map_name="SC_206_GOTO_PP4"}, -- Tiwo Sabya
[113037]={map=401,name=TEXT("Sys113037_name"),x=50,y=50,map_name=TEXT("QUEST_DIR_118")}, -- Guild Board
[113038]={map=401,name=TEXT("Sys113038_name"),x=50,y=50,map_name=TEXT("QUEST_DIR_118")}, -- Guild Board
[113039]={map=401,name=TEXT("Sys113039_name"),x=50,y=50,map_name=TEXT("QUEST_DIR_118")}, -- Guild Board

}
